# 1 "C:\\Users\\Flo\\AppData\\Local\\Temp\\tmph3ing78v"
#include <Arduino.h>
# 1 "D:/Flo/git/WiFiThermostat/src/WiFiThermostat.ino"


#include "fwversion.h"
#include "fwsettings.h"


#include <ESP8266HTTPUpdateServer.h>
#include <ESP8266WebServer.h>
#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>

#ifdef USE_MQTT_TLS
#include <WiFiClientSecure.h>
#else
#include <WiFiClient.h>
#endif


#include <PersWiFiManagerExt.h>


#include <DNSServer.h>


#include <PubSubClient.h>


#include <FS.h>


#include <ArduinoJson.h>



#include <Wire.h>
#include <LiquidCrystal_I2C.h>


#include <DHT.h>


#include <Bounce2.h>
#include <Button.h>
#include <ButtonEventCallback.h>
#include <PushButton.h>


PROGMEM const char PGMStr_FIRMWARE_NAME[] = FIRMWARE_NAME;
PROGMEM const char PGMStr_FIRMWARE_VERSION[] = FIRMWARE_VERSION;
PROGMEM const char PGMStr_FIRMWARE_URL[] = FIRMWARE_URL;
PROGMEM const char PGMStr_FIRMWARE_COPYRIGHT[] = FIRMWARE_COPYRIGHT;
PROGMEM const char PGMStr_FIRMWARE_COPYRIGHT_URL[] = FIRMWARE_COPYRIGHT_URL;
PROGMEM const char PGMStr_FIRMWARE_SHORTNAME[] = FIRMWARE_SHORTNAME;

PROGMEM const char PGMStr_changedTo[] = "changed to";
PROGMEM const char PGMStr_preset[] = "preset";
PROGMEM const char PGMStr_heatingMode[] = "heatingMode";
PROGMEM const char PGMStr_heatingPause[] = "heatingPause";
PROGMEM const char PGMStr_setTemp[] = "setTemp";
PROGMEM const char PGMStr_currentSetTemp[] = "currSetTemp";
PROGMEM const char PGMStr_setTempLow[] = "setTempLow";
PROGMEM const char PGMStr_setTempLow2[] = "setTempLow2";
PROGMEM const char PGMStr_switchHeating[] = "switch heating";
PROGMEM const char PGMStr_mqttRetainedSave[] = "MQTT retained save";
PROGMEM const char PGMStr_heating[] = "heating";
PROGMEM const char PGMStr_thermostat[] = "THST";
PROGMEM const char PGMStr_WiFi[] = "WiFi";


PROGMEM const char PGMStr_MQTT[] = "MQTT";
PROGMEM const char PGMStr_connectedTo[] = "connected to";
PROGMEM const char PGMStr_reconnects[] = "reconnects";
PROGMEM const char PGMStr_connectedFailed[] = "connect FAILED";

PROGMEM const char PGMStr_enabled[] = "enabled";
PROGMEM const char PGMStr_disabled[] = "disabled";



PROGMEM const char compile_date[] = __DATE__ " " __TIME__;

const char PGMStr_confDevWiFi[] PROGMEM = "confDevWiFi";
const char PGMStr_confWeb[] PROGMEM = "confWeb";
const char PGMStr_confMqtt[] PROGMEM = "confMqtt";
const char PGMStr_confBas[] PROGMEM = "confBas";
const char PGMStr_confAdv[] PROGMEM = "confAdv";
const char PGMStr_confAdd[] PROGMEM = "confAdd";
const char PGMStr_confTime[] PROGMEM = "confTime";
const char PGMStr_confLog[] PROGMEM = "confLog";


const char PGMStr_MQTTState_DIS[] PROGMEM = "DISABLED";
const char PGMStr_MQTTState_M4[] PROGMEM = "CONNECTION_TIMEOUT";
const char PGMStr_MQTTState_M3[] PROGMEM = "CONNECTION_LOST";
const char PGMStr_MQTTState_M2[] PROGMEM = "CONNECT_FAILED";
const char PGMStr_MQTTState_M1[] PROGMEM = "DISCONNECTED";
const char PGMStr_MQTTState_0[] PROGMEM = "CONNECTED";
const char PGMStr_MQTTState_1[] PROGMEM = "CONNECT_BAD_PROTOCOL";
const char PGMStr_MQTTState_2[] PROGMEM = "CONNECT_BAD_CLIENT_ID";
const char PGMStr_MQTTState_3[] PROGMEM = "CONNECT_UNAVAILABLE";
const char PGMStr_MQTTState_4[] PROGMEM = "CONNECT_BAD_CREDENTIALS";
const char PGMStr_MQTTState_5[] PROGMEM = "CONNECT_UNAUTHORIZED";
const char *const PGMStr_MQTTStates[] PROGMEM =
    {
        PGMStr_MQTTState_M4,
        PGMStr_MQTTState_M3,
        PGMStr_MQTTState_M2,
        PGMStr_MQTTState_M1,
        PGMStr_MQTTState_0,
        PGMStr_MQTTState_1,
        PGMStr_MQTTState_2,
        PGMStr_MQTTState_3,
        PGMStr_MQTTState_4,
        PGMStr_MQTTState_5,
};
char mqttCurrentStateName[25];



PushButton buttonPlus = PushButton(PIN_BUTTON_PLUS, ENABLE_INTERNAL_PULLUP);
PushButton buttonMinus = PushButton(PIN_BUTTON_MINUS, ENABLE_INTERNAL_PULLUP);
PushButton buttonMode = PushButton(PIN_BUTTON_MODE, ENABLE_INTERNAL_PULLUP);
PushButton pirSensor = PushButton(PIN_PIRSENSOR, PRESSED_WHEN_HIGH);

bool WifiInApMode = false;
unsigned long WifiApModeStartedAt;

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
char encKey[] = PW_ENCRYPTION_KEY;
#endif
bool confEncryptionEnabled = false;

#ifdef ENABLE_FEATURE_NTP_TIME
struct tm lt;




#endif




struct confDataDevWiFi
{
  char deviceName[33];
  char hostName[33];
  char WiFiSSID1[33];
  char WiFiPW1[64];
  char WiFiSSID2[33];
  char WiFiPW2[64];
  char WiFiAPModeSSID[33];
  char WiFiAPModePassword[64];
  uint16_t WiFiAPModeTimeout;
  uint16_t WiFiRetryInterval;
  uint16_t WiFiConnCheckInterval;
  uint16_t WiFiRebootOnNoConnect;
  bool wasChanged;
} confDevWiFi;


struct confDataWeb
{
  char http_token[31];
  char http_user[31];
  char http_pass[31];
  bool http_user_auth;
  char http_user1[31];
  char http_pass1[31];
  char http_user2[31];
  char http_pass2[31];
  bool wConsole;
  bool wsConsole;
  bool wasChanged;
} confWeb;


struct confDataMqtt
{
  bool mqtt_enable;
  char mqtt_server[41];
  uint16_t mqtt_port;
  char mqtt_user[31];
  char mqtt_pass[31];
  char mqtt_topic_in[51];
  char mqtt_topic_out[51];
  char mqtt_willTopic[51];
  uint8_t mqtt_willQos;
  bool mqtt_willRetain;
  char mqtt_willMsg[31];
  char mqtt_connMsg[31];
  bool mqtt_outRetain;
  bool mqtt_outRetain_sensors;
  uint8_t mqtt_outPubInterval;
  uint8_t mqtt_outPubInterval_sensors;
  bool mqtt_enable_heartbeat;
  unsigned long mqtt_heartbeat_maxage_reconnect;
  unsigned long mqtt_heartbeat_maxage_reboot;
  bool wasChanged;
} confMqtt;


struct confDataBas
{
  float setTempMin;
  float setTempMax;
  bool autoSaveSetTemp;
  bool autoSaveHeatingMode;
  bool saveToMqttRetained;
  uint16_t measureInterval;
  uint16_t displayInterval;

  uint16_t displayTimeout;
  bool PIR_enablesDisplay;
  bool PIR_enablesDisplay_preset0only;
  bool togglingTempHumAIDisplay;
  bool wasChanged;
} confBas;


struct confDataAdv
{
  float hysteresis;
  uint16_t heatingMinOffTime;

  float tempCorrVal;

  int humCorrVal;
  float setTempDecreaseVal;


  char offMessage[15];
  char iTempLabel[2];
  char oTempLabel[2];
  char modeName0[15];
  char modeName1[15];
  char psetName0[15];
  char psetName1[15];
  char psetName2[15];
  int pauseTout;
  bool wasChanged;
} confAdv;


struct confDataAdd
{
  char mqtt_topic_pir[51];
  char mqtt_payload_pir_on[10];
  char mqtt_payload_pir_off[10];
  char outTemp_topic_in[51];
  char outHum_topic_in[51];
  bool wasChanged;
} confAdd;


struct confDataTime
{
  bool ntpEnable;
  char timeZoneStr[50];
  char ntpServer1[31];
  char ntpServer2[31];
  unsigned long ntpSyncInterval;
  bool wasChanged;
} confTime;


struct confDataLog
{
  uint8_t logLevelSerial;
  uint8_t logLevelWeb;
  uint8_t logLevelMqtt;
  uint8_t logLevelSyslog;
  bool logWebRequests;
  bool wasChanged;
} confLog;


struct sysUptimeStruct
{
  unsigned int day = 0;
  unsigned int hour = 0;
  unsigned int min = 0;
  unsigned int sec = 0;
  unsigned int highMillis = 0;
  unsigned int rollover = 0;
  char uptimeStr[16];
} sysUptime;

bool mqtt_tempDisabled_credentialError = false;

char mqtt_topic_in_cmd[61];
char mqtt_topic_in_setTemp[61];
char mqtt_topic_in_setMode[61];
char mqtt_topic_in_setPreset[61];
char mqtt_topic_in_setPause[61];


float setTemp = DEFAULT_SETTEMP;
float setTempLow = DEFAULT_SETTEMP_LOW;
float setTempLow2 = DEFAULT_SETTEMP_LOW2;
float currSetTemp = DEFAULT_SETTEMP;
float currActualSetTemp = DEFAULT_SETTEMP;
uint8_t heatingMode = DEFAULT_HEATINGMODE;
uint16_t heatingPause = 0;
uint8_t preset = DEFAULT_PRESET;




float setTempSaved;
float setTempLowSaved;
float setTempLow2Saved;
uint8_t heatingModeSaved;
uint8_t presetSaved;


float setTempLowMin = SETTEMP_LOW_MIN;
float setTempLowMax = SETTEMP_LOW_MAX;


unsigned long maxMeasurementAge = MAX_MEASUREMENT_AGE;
unsigned long maxMeasurementAgeOut = MAX_MEASUREMENT_AGE_OUT;


float currTemp;
float currTemp_raw;
uint16_t currHum;
uint16_t currHum_raw;
bool turnHeatingOn = false;

uint16_t heatingLockTime = 0;
unsigned long heatingLastOnMillis;
unsigned long heatingLastOffMillis;
float outTemp;
uint16_t outHum;
unsigned long outTempHumLastUpdate;
char outTemp_newValue[6];
bool outTemp_parseNewValue;
char outHum_newValue[4];
bool outHum_parseNewValue;
char currentModeName[15];
char currentPresetName[15];
uint16_t displayInterval;
uint8_t whichTempToDisplay;



unsigned long lastMeasure = 0;
unsigned long lastDisplayUpdate = 0;
unsigned long lastDisplayToggle = 0;
unsigned long lastTempUpdate = 0;


bool displayActive = false;


bool PIRSensorOn = false;
unsigned long heatingOnTime, heatingOffTime;

bool configChangedRestartRequired = false;
bool configChangedMqttConnResetRequired = false;

unsigned long lastUpdate_setTemp = 0;
unsigned long lastUpdate_setTempLow = 0;
unsigned long lastUpdate_setTempLow2 = 0;
unsigned long lastUpdate_heatingMode = 0;
unsigned long lastUpdate_preset = 0;

char cmdPayload[101];
bool cmdInQueue = false;






uint16_t saveValuesTimeout = 5000;
unsigned long lastValueChange;


unsigned long lastConfigChange;
bool lastConfigChangeNoteAlreadyDone = false;
bool setTempAlreadySaved = true;
bool setTempLowAlreadySaved = true;
bool setTempLow2AlreadySaved = true;
bool heatingModeAlreadySaved = true;
bool presetAlreadySaved = true;

unsigned long lastRun = 0;
uint16_t count100ms = 0;
uint16_t countSeconds = 0;
uint16_t countMeasureInterval = 0;
uint16_t countDisplayInterval = 0;
uint16_t displayOverlayMsgTimeout = 2;

unsigned long mqttLastReconnectAttempt = 0;
uint16_t mqttReconnectAttempts = 0;
uint16_t mqttReconnects = 0;
bool mqttConnected = false;
unsigned long mqttLastHeartbeat;
bool mqttInTopicSubscribed = false;

bool pendingRestart = false;
bool doRestart = false;
unsigned long pendingRestart_lastMillis = 0;

bool displayShowFullscreenMsg = false;


bool pendingPresetToggle = false;
bool updateDisplayImmediately = false;
uint8_t pendingPreset;
char pendingPresetName[15];

bool displayShowLine2OverlayMsg = false;


bool sysInfoEverySecond = false;

#ifdef ENABLE_FEATURE_WEB_CONSOLE
char webLogBuffer[WEB_CONSOLE_BUFFER_SIZE];
unsigned int webLogBuffer_index = 0;
#endif



DHT dht(PIN_DHTSENSOR, DHTTYPE);
LiquidCrystal_I2C lcd(LCDADDR, LCDCOLS, LCDLINES);

#ifdef USE_MQTT_TLS

BearSSL::WiFiClientSecure wifiClient;
#else
WiFiClient wifiClient;
#endif

PubSubClient mqttclient(wifiClient);

ESP8266WebServer httpServer(80);


#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
WebSocketsServer webSocket(81);
unsigned long int wsValidSessionId = 0;
#endif

DNSServer dnsServer;
PersWiFiManager persWM(httpServer, dnsServer);

#ifdef ENABLE_FEATURE_HTTP_UPDATER
ESP8266HTTPUpdateServer httpUpdater;
#endif


#ifdef ENABLE_FEATURE_NTP_TIME
void updateTime();
bool setupTime();
void syncClock(bool force = false);
#endif
char *getUptimeStr(bool includeSeconds = false);
void sendLog(const char *msg, uint8_t loglevel = 1);
void sendLog(const __FlashStringHelper *msg, uint8_t loglevel = 1);
void mqttCallback(char *topic, byte *payload, uint16_t length);
char *getTimeStringFromSeconds(unsigned int inSeconds);
void setup();
void loop();
void enableDisplay();
void disableDisplay();
void extendDisplayTimeout();
void handleDisplayTimeout();
void initDisplay();
void displayShowWifiConnected();
void displayShowWifiConnectionError();
void displayShowMQTTConnected();
void displayShowMQTTConnectionError();
void displayShowLine2OverlayMessage(char *msg);
void displayAddConnectionIcon();
void updateDisplay();
void configurePushButton(Bounce &bouncedButton);
void setupInputsButtons();
void onButtonHeld(Button &btn, uint16_t duration, uint16_t repeatCount);
void onButtonHeldNoRepeat(Button &btn, uint16_t duration);
void onButtonReleased(Button &btn, uint16_t duration);
void plusButtonAction();
void minusButtonAction();
void modeButtonAction();
void modeButtonHoldAction();
void modeButtonRebootPendingAction();
void modeButtonRebootAction();
void pirSensorOnAction();
void pirSensorOffAction();
void serialEvent();
void evalCmd();
void cmdPrintHelp();
double round2(double value);
double round1(double value);
char* XORENC(char* in, char* key);
char* getTimeStringFromSeconds(unsigned int inSeconds);
void setConfig(char *param, char *value);
void getConfig(char *param);
boolean loadConfigDevWiFi();
boolean loadConfigWeb();
boolean loadConfigMqtt();
boolean loadConfigBas();
boolean loadConfigAdv();
boolean loadConfigAdd();
boolean loadConfigTime();
boolean loadConfigLog();
boolean loadSetTemp();
boolean loadSetTempLow();
boolean loadSetTempLow2();
boolean loadHeatingMode();
boolean loadPreset();
boolean saveConfigWeb();
boolean saveConfigMqtt();
boolean saveConfigDevWiFi();
boolean saveConfigBas();
boolean saveConfigAdv();
boolean saveConfigAdd();
boolean saveConfigTime();
boolean saveConfigLog();
boolean saveSetTemp();
boolean saveSetTempLow();
boolean saveSetTempLow2();
boolean saveHeatingMode();
boolean savePreset();
void deleteConfig();
void loadConf_all();
void saveConfig_all();
void loadSavedValues();
void saveValues();
void SPIFFS_format();
void SPIFFS_formatIfIsnt();
void SPIFFS_listFiles();
void loadConf_defaults();
void loadConf_restoreDefaultWhenMissing();
void confClearCredentials();
void confClearWiFiCredentials();
bool confCheckEncrypted();
void confEncrypt();
void confDecrypt();
bool confCheckUnsaved();
void confRestartRequiredLogNote();
void confMqttConnResetRequiredLogNote();
void httpServerHandleMainPage();
void httpServerHandleRedTempsPage();
void httpServerHandleConfPage();
void httpServerHandleConfWebPage();
void httpServerHandleConfMqttPage();
void httpServerHandleConfDevWiFiPage();
void httpServerHandleConfBasPage();
void httpServerHandleConfAdvPage();
void httpServerHandleConfAddPage();
void httpServerHandleConfTimePage();
void httpServerHandleConfLogPage();
void httpServerHandleWSConsolePage();
void httpServerHandleConsolePage();
void httpServerHandleConfSavedPage();
void httpServerHandleRestartPage();
void httpServerHandleClearconfPage();
void httpServerHandleSysInfoPage();
void httpServerSendHtmlHeadChunked();
void httpServerSendHtmlBodyPageheadChunked();
void httpServerSendHtmlFooterChunked();
boolean httpIsAuthenticated();
boolean httpIsAuthenticatedAdmin();
void httpServerHandleNotFound();
void httpSendUnauthorized();
void httpSend200OK();
boolean httpCheckToken();
void httpServerInit();
void sendLog(const char *msg, uint8_t loglevel);
void sendLog(const __FlashStringHelper *msg, uint8_t loglevel);
void updateUptime();
char* getUptimeStr(bool includeSeconds);
void createDeviceName();
void restart();
void logSysdata();
void printIpcfg();
void mqttCallback(char *topic, unsigned char *payload, uint16_t length);
void mqttPrepareSubscribeTopics();
bool mqttReconnect(void);
void mqttClientInit();
void mqttHandleConnection();
void mqttPublishStatus();
void mqttOnConnect();
void mqttOnDisconnect();
void mqttPublishConnectMsg();
void mqttPublishHeartbeat();
void mqtt_updateCurrentStateName();
void mqttResetConnection();
void publish_heatingLockTime();
void publish_heatingPauseTime();
void publishCurrentPIRValue();
void publishDeleteRetainedSavedStates();
void publishDeleteRetainedOutMessages();
void publishDeleteRetainedOutMessages_sensors();
void outTempHum_updateOnNewValue();
void outTemp_update();
void outHum_update();
void checkMillis();
void every100ms();
void everySecond();
void everyMinute();
void readDHTsensorTemp();
void readDHTsensorHum();
void measureTempHum();
void updateCurrSetTemp();
void thermostat();
void toggleOnOff();
void togglePreset();
void updateCurrentHeatingModeName();
void updateCurrentPresetName();
void updatePendingPresetName();
void setTempStepUp();
void setTempStepDown();
void setTempTo(float setTo);
void setTempLowStepUp();
void setTempLowStepDown();
void setTempLowTo(float setTo);
void setTempLow2StepUp();
void setTempLow2StepDown();
void setTempLow2To(float setTo);
void setHeatingmodeTo(unsigned char setTo);
void setHeatingPause(uint8_t _setTo);
void setPresetTo(unsigned char setTo);
void checkValuesChanged();
void syncClock(bool force);
void printDate();
bool isCookieValid(String rawCookieHeaderValue);
void clearValidSessionId();
bool validateHttpHeader(String headerName, String headerValue);
void startWebSocketServer();
void webSocketEvent(uint8_t num, WStype_t type, uint8_t * payload, size_t length);
#line 468 "D:/Flo/git/WiFiThermostat/src/WiFiThermostat.ino"
void setup()
{
  Serial.begin(115200);
  delay(50);
  Serial.println();
  Serial.print(PGMStr_FIRMWARE_NAME);
  Serial.print(F(" v"));
  Serial.print(PGMStr_FIRMWARE_VERSION);
  Serial.println(F(" starting..."));

  pinMode(PIN_RELAIS, OUTPUT);
  digitalWrite(PIN_RELAIS, !RELAISONSTATE);

  setupInputsButtons();


  loadConf_defaults();




  sendLog(F("CONF: default config loaded."), LOGLEVEL_INFO);

  initDisplay();

  sendLog(F("Mounting SPIFFS..."), LOGLEVEL_INFO);
  if (!SPIFFS.begin())
  {
    sendLog(F("Failed to mount SPIFFS"), LOGLEVEL_ERROR);
    return;
  }

#ifdef FORCE_SPIFFS_FORMAT
  SPIFFS_format();
#endif

  SPIFFS_formatIfIsnt();



#ifdef ENABLE_FEATURE_PW_ENCRYPTION
  confCheckEncrypted();
#endif

  loadConf_all();
  loadSavedValues();




  loadConf_restoreDefaultWhenMissing();

  updateCurrentHeatingModeName();
  updateCurrentPresetName();


  dht.begin();

  if (strlen(confDevWiFi.hostName) >= 4)
  {

    WiFi.hostname(confDevWiFi.hostName);
  }


  persWM.onConnect([]() {







    printIpcfg();

    WifiInApMode = false;

#ifdef ENABLE_FEATURE_NTP_TIME
    if (confTime.ntpEnable)
      setupTime();
#endif

    displayShowWifiConnected();
  });

  persWM.onAp([]() {
# 562 "D:/Flo/git/WiFiThermostat/src/WiFiThermostat.ino"
    char buf[60];
    sprintf(buf, "%s: AP-MODE started, SSID '%s', PW: '%s'", PGMStr_WiFi, persWM.getApSsid().c_str(), confDevWiFi.WiFiAPModePassword);
    sendLog(buf, LOGLEVEL_INFO);

    WifiInApMode = true;
    WifiApModeStartedAt = millis();
    displayShowWifiConnectionError();
  });

  persWM.onApOff([]() {

    sendLog(F("WiFi: AP-MODE stopped"), LOGLEVEL_INFO);
  });



  if (strlen(confDevWiFi.deviceName) >= 8)
    strlcpy(confDevWiFi.WiFiAPModeSSID, confDevWiFi.deviceName, sizeof(confDevWiFi.WiFiAPModeSSID));
  else
  {
    byte mac[6];
    WiFi.macAddress(mac);
    sprintf(confDevWiFi.WiFiAPModeSSID, "%s-%02X%02X", FIRMWARE_SHORTNAME, (uint8_t)mac[4], (uint8_t)mac[5]);
  }




  if (strlen(confDevWiFi.WiFiAPModePassword) < 5)
  {
    persWM.setApCredentials(confDevWiFi.WiFiAPModeSSID);

  }
  else
  {
    persWM.setApCredentials(confDevWiFi.WiFiAPModeSSID, confDevWiFi.WiFiAPModePassword);

  }




  persWM.setWifi1Credentials(confDevWiFi.WiFiSSID1, confDevWiFi.WiFiPW1);
  persWM.setWifi2Credentials(confDevWiFi.WiFiSSID2, confDevWiFi.WiFiPW2);
  persWM.setHttpCredentials(confWeb.http_user, confWeb.http_pass);
  persWM.setApTimeout(confDevWiFi.WiFiAPModeTimeout);
  persWM.setConnCheckInterval(confDevWiFi.WiFiConnCheckInterval);
  persWM.setForceRetryWifi1Interval(confDevWiFi.WiFiRetryInterval);
  persWM.setRebootOnNoConnect(confDevWiFi.WiFiRebootOnNoConnect);


  persWM.setConnectNonBlock(true);


  persWM.begin();

#ifdef USE_MQTT_TLS


  wifiClient.setInsecure();
  wifiClient.allowSelfSignedCerts();
  wifiClient.setCiphersLessSecure();
#endif

  delay(500);

  httpServerInit();

#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
  if (confWeb.wsConsole)
    startWebSocketServer();
#endif

  if (confMqtt.mqtt_enable)
  {
    mqttPrepareSubscribeTopics();
    mqttClientInit();
  }

  sendLog(F("DEV:  setup complete."), LOGLEVEL_INFO);
}

void loop()
{
  checkMillis();

  persWM.handleWiFi();

  yield();

  mqttHandleConnection();
  yield();

  outTempHum_updateOnNewValue();

  yield();

  dnsServer.processNextRequest();
  httpServer.handleClient();

  buttonPlus.update();
  buttonMinus.update();
  buttonMode.update();
  pirSensor.update();

  yield();

  evalCmd();
  yield();

  if (Serial.available())
  {
    serialEvent();
    yield();
  }

  if (updateDisplayImmediately)
  {
    updateDisplayImmediately = false;
    updateDisplay();
  }

#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
  if (confWeb.wsConsole)
  {
    if (WiFi.status() == WL_CONNECTED)
    {
      webSocket.loop();
    }
    else
    {
      webSocket.disconnect();
    }
  }
#endif

}
# 1 "D:/Flo/git/WiFiThermostat/src/Display.ino"


unsigned char customCharSun[] = {B00100, B10001, B01110, B11111, B11111, B01110, B10001, B00100};

unsigned char customCharMoon[] = {B00011, B01110, B01100, B11100, B11100, B01100, B01110, B00011};
unsigned char customCharArrowRight[] = {B01000, B01100, B01110, B01111, B01110, B01100, B01000, B00000};
unsigned char customCharDegC[] = {B01000, B10100, B01000, B00011, B00100, B00100, B00011, B00000};
unsigned char customCharConn[] = {B00000, B00000, B11100, B00010, B11001, B00101, B10101, B00000};
unsigned char customCharDisconn[] = {B10001, B01010, B00100, B01010, B10001, B00000, B10000, B00000};
unsigned char customCharReduction2[] = {B00000, B11111, B01110, B00100, B00000, B11111, B01110, B00100};
unsigned char customCharFlame[] = {B00100, B00100, B01010, B01010, B10101, B10101, B10101, B01110};
unsigned char customCharLock[] = {B01110, B10001, B10001, B11111, B11011, B11011, B11111, B00000};
unsigned char customCharPause[] = {B11011, B11011, B11011, B11011, B11011, B11011, B11011, B11011};

unsigned long displayLastOnMillis = 0;

void enableDisplay()
{
  lcd.backlight();
  displayActive = true;
  displayLastOnMillis = millis();
}

void disableDisplay()
{
  lcd.noBacklight();
  displayActive = false;
}

void extendDisplayTimeout() { displayLastOnMillis = millis(); }

void handleDisplayTimeout()
{
  if (displayActive && (millis() - displayLastOnMillis) > (confBas.displayTimeout * 1000)) { disableDisplay(); }
}

void initDisplay()
{
  lcd.init();
  lcd.createChar(0, customCharMoon);
  lcd.createChar(1, customCharSun);
  lcd.createChar(2, customCharArrowRight);
  lcd.createChar(3, customCharDegC);
  lcd.createChar(4, customCharConn);
  lcd.createChar(5, customCharDisconn);
  lcd.createChar(6, customCharReduction2);
  lcd.createChar(7, customCharFlame);




  lcd.setCursor(0, 0);

  lcd.print("WiFiThermostat  ");
  lcd.setCursor(0, 1);
  lcd.print("(c) by FloKra.at");







  lcd.backlight();


  displayActive = true;
  displayLastOnMillis = millis();
}

void displayShowWifiConnected()
{
  lcd.setCursor(0, 0);

  lcd.print("WiFi connected  ");
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(WiFi.localIP());

  lcd.backlight();
  displayActive = true;
  displayLastOnMillis = millis();
  delay(2000);
}

void displayShowWifiConnectionError()
{
  lcd.setCursor(0, 0);
  lcd.print("WiFi connecting ");
  lcd.setCursor(0, 1);
  lcd.print("FAILED          ");
  lcd.backlight();
  displayActive = true;
  displayLastOnMillis = millis();
  delay(2000);

  lcd.setCursor(0, 0);
  lcd.print("AP mode active  ");
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(persWM.getApSsid());
  lcd.backlight();
  displayActive = true;
  displayLastOnMillis = millis();
  delay(2000);

  lcd.setCursor(0, 0);
  lcd.print("Password:       ");
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(confDevWiFi.WiFiAPModePassword);
  lcd.backlight();
  displayActive = true;
  displayLastOnMillis = millis();
  delay(2000);
}

void displayShowMQTTConnected()
{
  lcd.setCursor(0, 0);

  lcd.print("MQTT conn. to:  ");
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.print(confMqtt.mqtt_server);

  lcd.backlight();
  displayActive = true;
  displayLastOnMillis = millis();

  displayShowFullscreenMsg = true;
  countDisplayInterval = 0;
  displayInterval = displayOverlayMsgTimeout;
}

void displayShowMQTTConnectionError()
{
  lcd.setCursor(0, 0);
  lcd.print("MQTT connection ");
  lcd.setCursor(0, 1);
  lcd.print("FAILED          ");

  lcd.backlight();
  displayActive = true;
  displayLastOnMillis = millis();
  displayShowFullscreenMsg = true;
  countDisplayInterval = 0;
  displayInterval = displayOverlayMsgTimeout;
}

void displayShowLine2OverlayMessage(char *msg)
{
  lcd.setCursor(0, 1);
  lcd.print("                ");
  lcd.setCursor(0, 1);
  lcd.write((uint8_t)2);
  lcd.print(" ");
  lcd.print(msg);

  for (int i = strlen(msg); i < 14; i++)
  {
    lcd.print(" ");
  }

  displayShowLine2OverlayMsg = true;
  countDisplayInterval = 0;
  displayInterval = displayOverlayMsgTimeout;
}

void displayAddConnectionIcon()
{
  lcd.setCursor(14, 1);
  lcd.print(" ");
  if (mqttConnected)
    lcd.write((uint8_t)4);
  else
    lcd.write((uint8_t)5);
}

void updateDisplay()
{
  if (displayShowFullscreenMsg)
  {
    displayShowFullscreenMsg = false;
    displayInterval = confBas.displayInterval;
    updateDisplayImmediately = true;
  }
  else
  {
    boolean showTemp = false;
    char ch_temp[6];
    long now = millis();

    if (confBas.togglingTempHumAIDisplay)
    {
      char ch_hum[4];
      char tempLabel[2];

      if (((now - outTempHumLastUpdate) < maxMeasurementAgeOut) && outTempHumLastUpdate != 0 && whichTempToDisplay == 1 &&
          ((now - lastDisplayToggle) > (displayInterval * 1000)))
      {

        whichTempToDisplay = 2;
        lastDisplayToggle = now;
      }
      else if (whichTempToDisplay != 1 && ((now - lastDisplayToggle) > (displayInterval * 1000)))
      {
        whichTempToDisplay = 1;
        lastDisplayToggle = now;
      }

      lastDisplayUpdate = now;

      if (whichTempToDisplay == 2)
      {
        if (outTempHumLastUpdate != 0 && (now - outTempHumLastUpdate) < maxMeasurementAgeOut)
        {
          showTemp = true;
          dtostrf(outTemp, 5, 1, ch_temp);
          sprintf(ch_hum, "%2i", outHum);
          strcpy(tempLabel, confAdv.oTempLabel);
        }
      }
      else
      {
        if (lastTempUpdate != 0 && (now - lastTempUpdate) < maxMeasurementAge)
        {
          showTemp = true;
          dtostrf(currTemp, 5, 1, ch_temp);
          sprintf(ch_hum, "%2i", currHum);
          strcpy(tempLabel, confAdv.iTempLabel);
        }
      }
# 247 "D:/Flo/git/WiFiThermostat/src/Display.ino"
      lcd.setCursor(0, 0);

      if (showTemp)
      {

        lcd.print(tempLabel);
        lcd.print(ch_temp);

        lcd.write((uint8_t)3);
        lcd.print(" ");

        if (currHum == 0)
          lcd.print("--");
        else if (currHum < 10)
        {
          lcd.print(" ");
          lcd.print(ch_hum);
        }
        else
        {
          lcd.print(ch_hum);
        }
        lcd.print("%");
        lcd.print("     ");
      }
      else
      {
        lcd.print("                ");
      }
    }

    else
    {
      lcd.setCursor(0, 0);
      lcd.print(confAdv.iTempLabel);

      if (lastTempUpdate != 0 && (now - lastTempUpdate) < maxMeasurementAge)
      {
        dtostrf(currTemp, 5, 1, ch_temp);
        lcd.print(ch_temp);
      }
      else
      {
        lcd.print(" --.-");
      }
      lcd.write((uint8_t)3);
      lcd.print(" ");

      if (outTempHumLastUpdate != 0 && (now - outTempHumLastUpdate) < maxMeasurementAgeOut)
      {

        lcd.print(" ");
        lcd.print(confAdv.oTempLabel);

        dtostrf(outTemp, 5, 1, ch_temp);
        lcd.print(ch_temp);
        lcd.write((uint8_t)3);
      }
      else
      {
        lcd.print("        ");
      }
    }

    updateCurrSetTemp();

    char ch_currSetTemp[6];
    dtostrf(currSetTemp, 5, 1, ch_currSetTemp);



    lcd.setCursor(0, 1);

    if (doRestart) { lcd.print("Restarting... "); }
    else if (pendingRestart)
    {
      lcd.print("Restart?      ");
    }
    else if (heatingMode == 0)
    {

      lcd.print("               ");
      lcd.setCursor(0, 1);
      lcd.print(confAdv.offMessage);



      displayAddConnectionIcon();
    }
# 350 "D:/Flo/git/WiFiThermostat/src/Display.ino"
    else if (displayShowLine2OverlayMsg)
    {
      displayShowLine2OverlayMsg = false;
      displayInterval = confBas.displayInterval;
      if (pendingPresetToggle)
      {
        preset = pendingPreset;
        updateCurrentPresetName();
        pendingPresetToggle = false;
      }
      updateDisplayImmediately = true;
    }
    else
    {
      lcd.write((uint8_t)2);



      lcd.print(ch_currSetTemp);

      lcd.write((uint8_t)3);

      lcd.print(" ");

      lcd.setCursor(8, 1);
      lcd.print("        ");


      lcd.setCursor(9, 1);
      if (preset == 0)
      {
        lcd.write((uint8_t)1);
      }
      else if (preset == 1)
      {
        lcd.write((uint8_t)0);
      }
      else if (preset == 2)
      {
        lcd.write((uint8_t)6);
      }

      if (heatingPause > 0)
      {
        lcd.createChar(7, customCharPause);
        lcd.setCursor(12, 1);
        lcd.write((uint8_t)7);
      }
      else if (heatingLockTime > 0)
      {
        lcd.createChar(7, customCharLock);
        lcd.setCursor(12, 1);
        lcd.write((uint8_t)7);
      }
      else if (turnHeatingOn)
      {
        lcd.createChar(7, customCharFlame);
        lcd.setCursor(12, 1);
        lcd.write((uint8_t)7);
      }
      else
      {
        lcd.setCursor(12, 1);
        lcd.print(" ");
      }
      displayAddConnectionIcon();
    }
  }
}
# 1 "D:/Flo/git/WiFiThermostat/src/buttonhandling.ino"

const unsigned int buttonMaxClickTime = 500;
const unsigned int buttonMaxClickTime_2 = 350;
const unsigned int buttonDebounceTime = 50;
const unsigned int buttonRepeatTime = 350;
const unsigned int buttonHoldTime = 1000;
const unsigned int buttonRepeatTime_menuButton = 1000;



void configurePushButton(Bounce &bouncedButton)
{

  bouncedButton.interval(15);
}

void setupInputsButtons()
{

  buttonPlus.configureButton(configurePushButton);

  buttonPlus.onHoldRepeat(buttonHoldTime, buttonRepeatTime, onButtonHeld);
  buttonPlus.onRelease(buttonDebounceTime, buttonMaxClickTime, onButtonReleased);

  buttonMinus.configureButton(configurePushButton);

  buttonMinus.onHoldRepeat(buttonHoldTime, buttonRepeatTime, onButtonHeld);
  buttonMinus.onRelease(buttonDebounceTime, buttonMaxClickTime, onButtonReleased);

  buttonMode.configureButton(configurePushButton);


  buttonMode.onHoldRepeat(buttonHoldTime, buttonRepeatTime_menuButton, onButtonHeld);
  buttonMode.onRelease(buttonDebounceTime, buttonMaxClickTime, onButtonReleased);

  pirSensor.configureButton(configurePushButton);

  pirSensor.onHold(150, onButtonHeldNoRepeat);
  pirSensor.onRelease(150, onButtonReleased);
}
# 55 "D:/Flo/git/WiFiThermostat/src/buttonhandling.ino"
void onButtonHeld(Button &btn, uint16_t duration, uint16_t repeatCount)
{
  if (buttonPlus.isPressed())
  {
    plusButtonAction();
  }
  if (buttonMinus.isPressed())
  {
    minusButtonAction();
  }
  if (buttonMode.isPressed())
  {
    if (repeatCount <= 2)
      modeButtonHoldAction();
    else if (repeatCount == 4)
      modeButtonRebootPendingAction();
    else if (repeatCount > 4)
      modeButtonRebootAction();
  }
}

void onButtonHeldNoRepeat(Button &btn, uint16_t duration)
{



  if (pirSensor.isPressed())
  {
    pirSensorOnAction();
  }
}


void onButtonReleased(Button &btn, uint16_t duration)
{
  if (btn.is(buttonPlus) && duration < buttonMaxClickTime_2)
  {
    plusButtonAction();
  }
  else if (btn.is(buttonMinus) && duration < buttonMaxClickTime_2)
  {
    minusButtonAction();
  }
  else if (btn.is(buttonMode) && duration < buttonMaxClickTime_2)
  {
    modeButtonAction();
  }
  else if (btn.is(pirSensor))
  {
    pirSensorOffAction();
  }
}

void plusButtonAction()
{

  sendLog("DEV: Btn +", LOGLEVEL_INFO);
  if (!displayActive)
  {
    enableDisplay();
  }
  else
  {
    extendDisplayTimeout();
    if (heatingMode == 1 && preset != 0)
      setPresetTo(0);
    else
      setTempStepUp();
  }
}

void minusButtonAction()
{

  sendLog("DEV: Btn -", LOGLEVEL_INFO);
  if (heatingMode == 1 && preset != 0)
    setPresetTo(0);
  if (!displayActive)
  {
    enableDisplay();
  }
  else
  {
    extendDisplayTimeout();
    if (heatingMode == 1 && preset != 0)
      setPresetTo(0);
    else
      setTempStepDown();
  }
}

void modeButtonAction()
{

  sendLog("DEV: Btn MODE", LOGLEVEL_INFO);
  if (!displayActive)
  {
    enableDisplay();

  }
  else
  {
    extendDisplayTimeout();
    if (pendingRestart)
    {
      doRestart = true;
      updateDisplay();
    }
    else
    {
      if (heatingMode > 0)
      {
        if (pendingPresetToggle)
        {
          togglePreset();
        }
        else
        {
          pendingPresetToggle = true;
          displayShowLine2OverlayMessage(currentPresetName);
        }
      }
    }
  }
}

void modeButtonHoldAction()
{

  sendLog("DEV: Btn MODE HOLD", LOGLEVEL_INFO);
  extendDisplayTimeout();
  if (pendingRestart)
  {
    doRestart = true;
    updateDisplay();
  }
  else
  {
    toggleOnOff();
  }
}

void modeButtonRebootPendingAction()
{
  extendDisplayTimeout();
  pendingRestart = true;
  pendingRestart_lastMillis = millis();
  updateDisplay();
}

void modeButtonRebootAction()
{
  extendDisplayTimeout();
  doRestart = true;
  updateDisplay();
}

void pirSensorOnAction()
{
  PIRSensorOn = true;


  publishCurrentPIRValue();
  if (confBas.PIR_enablesDisplay)
  {
    if (confBas.PIR_enablesDisplay_preset0only && preset == 0)
      enableDisplay();
    else if (!confBas.PIR_enablesDisplay_preset0only)
      enableDisplay();
  }
}

void pirSensorOffAction()
{
  PIRSensorOn = false;


  publishCurrentPIRValue();
}
# 1 "D:/Flo/git/WiFiThermostat/src/commands.ino"

#define SER_INPUT_SIZE 70
char serBuffer[SER_INPUT_SIZE + 1];
int serBufferCount;

void serialEvent()
{
  char ch = Serial.read();
  serBuffer[serBufferCount] = ch;
  serBufferCount++;
  if (ch == 13 || ch == 10)
  {
    serBuffer[serBufferCount - 1] = '\0';
#ifdef DEBUG_VERBOSE
    Serial.print("serial cmd: '");
    Serial.print(serBuffer);
    Serial.println("'");
#endif
    strlcpy(cmdPayload, serBuffer, sizeof(cmdPayload));
    cmdInQueue = true;
    evalCmd();
    serBufferCount = 0;
  }
}

void evalCmd()
{
  if (cmdInQueue)
  {



    char cmdPayload_lower[sizeof(cmdPayload)];
    strlcpy(cmdPayload_lower, cmdPayload, sizeof(cmdPayload_lower));
    strlwr(cmdPayload_lower);

    if (strncmp(cmdPayload_lower, "loadconf", 8) == 0)
    {
      sendLog(F("loading config..."));
      loadConf_all();
    }

    else if (strncmp(cmdPayload_lower, "set ", 4) == 0)
    {
      char buf[81];
      char setconfCmd[16];

      uint8_t len = strlen(cmdPayload) - 4;
      for (unsigned char i = 0; i < len; i++)
      {
        if (i < (sizeof(buf) - 1))
          buf[i] = cmdPayload[i + 4];
      }
      if (len <= (sizeof(buf) - 1))
        buf[len] = '\0';
      else
        buf[(sizeof(buf) - 1)] = '\0';

#ifdef DEBUG_VERBOSE
      Serial.print("Buf: ");
      Serial.println(buf);
#endif

      bool cmdNoPayload = false;
      uint8_t setconfCmdLen = 0;
      for (unsigned char i = 0; i < len; i++)
      {

        if (buf[i] == 32 || buf[i] == 61 || buf[i] == 58)
          break;
        else if (buf[i] == 0 || buf[i] == 10 || buf[i] == 13)
        {
          cmdNoPayload = true;
          break;
        }
        setconfCmd[i] = buf[i];
        setconfCmdLen++;
      }
      setconfCmd[setconfCmdLen] = '\0';
      yield();

      if (setconfCmdLen == len)
        cmdNoPayload = true;

#ifdef DEBUG_VERBOSE
      Serial.print("setconfCmd: '");
      Serial.print(setconfCmd);
      Serial.print("'");
#endif

      if (cmdNoPayload)
      {
#ifdef DEBUG_VERBOSE
        Serial.println(", no payload, displaying current value");
#endif

        cmdPrintHelp();
      }
      else
      {
        char setconfPayload[62];
#ifdef DEBUG_VERBOSE
        Serial.println();
#endif
        int setconfPayloadLen = 0;
        for (int i = 0; i < len; i++)
        {
          char c = buf[i + setconfCmdLen + 1];
          if (c == 0 || c == 10 || c == 13)
            break;
          setconfPayload[i] = c;
          setconfPayloadLen++;
        }
        setconfPayload[setconfPayloadLen] = '\0';

#ifdef DEBUG_VERBOSE
        Serial.print("setconfPayload: '");
        Serial.print(setconfPayload);
        Serial.println("'");
#endif

        char bufg[100];
        sprintf(bufg, "set '%s'->'%s'", setconfCmd, setconfPayload);
        sendLog(bufg, LOGLEVEL_VERBOSE);

        setConfig(setconfCmd, setconfPayload);
      }
    }

    else if (strncmp(cmdPayload_lower, "get ", 4) == 0)
    {
      char buf[81];
      char setconfCmd[16];

      uint8_t len = strlen(cmdPayload) - 4;
      for (int i = 0; i < len; i++)
      {
        if (i < 81)
          buf[i] = cmdPayload[i + 4];
      }
      if (len <= (sizeof(buf) - 1))
        buf[len] = '\0';
      else
        buf[(sizeof(buf) - 1)] = '\0';

#ifdef DEBUG_VERBOSE
      Serial.print("Buf: ");
      Serial.println(buf);
#endif

      uint8_t setconfCmdLen = 0;
      for (int i = 0; i < len; i++)
      {

        if (buf[i] == 32 || buf[i] == 61 || buf[i] == 58)
          break;
        else if (buf[i] == 0 || buf[i] == 10 || buf[i] == 13)
        {
          break;
        }
        setconfCmd[i] = buf[i];
        setconfCmdLen++;
      }
      setconfCmd[setconfCmdLen] = '\0';
      yield();
#ifdef DEBUG_VERBOSE
      Serial.print("setconfCmd: '");
      Serial.print(setconfCmd);
      Serial.println("'");
#endif
      char bufg[50];
      sprintf(bufg, "get '%s'", setconfCmd);
      sendLog(bufg);
      getConfig(setconfCmd);
    }
# 219 "D:/Flo/git/WiFiThermostat/src/commands.ino"
    else if (strncmp(cmdPayload_lower, "restart", 7) == 0)
    {
      sendLog(F("restarting..."));
      restart();
    }

    else if (strncmp(cmdPayload_lower, "sysinfo", 7) == 0)
    {
      logSysdata();
    }

    else if (strncmp(cmdPayload_lower, "debugmode 1", 11) == 0)
    {
      sendLog(F("debugmode on"));
      sysInfoEverySecond = true;
    }

    else if (strncmp(cmdPayload_lower, "debugmode 0", 11) == 0)
    {
      sendLog(F("debugmode off"));
      sysInfoEverySecond = false;
    }

#ifdef ENABLE_FEATURE_NTP_TIME
    else if (strncmp(cmdPayload_lower, "date", 7) == 0)
    {
      printDate();
    }
#endif

#ifdef ENABLE_FEATURE_NTP_TIME
    else if (strncmp(cmdPayload_lower, "syncclock", 7) == 0)
    {
      syncClock(true);
    }
#endif

    else if (strncmp(cmdPayload_lower, "clearcreds", 10) == 0)
    {
      confClearCredentials();
    }

    else if (strncmp(cmdPayload_lower, "clearwifi", 10) == 0)
    {
      confClearWiFiCredentials();
    }

    else if (strncmp(cmdPayload_lower, "saveconf", 8) == 0)
    {
      saveConfig_all();
    }

    else if (strncmp(cmdPayload_lower, "savevalues", 10) == 0)
    {
      saveValues();
    }

    else if (strncmp(cmdPayload_lower, "encrypt", 10) == 0)
    {
      confEncrypt();
    }

    else if (strncmp(cmdPayload_lower, "decrypt", 10) == 0)
    {
      confDecrypt();
    }

    else if (strncmp(cmdPayload_lower, "ls", 2) == 0)
    {
      SPIFFS_listFiles();
    }

    else if (strncmp(cmdPayload_lower, "ipcfg", 5) == 0)
    {
      printIpcfg();
    }

    else if (strncmp(cmdPayload_lower, "help", 4) == 0)
    {
      cmdPrintHelp();
    }

    else if (strncmp(cmdPayload_lower, "mqttreset", 9) == 0)
    {
      mqttResetConnection();
    }

    else if (strncmp(cmdPayload_lower, "mqttinfo", 8) == 0)
    {
      mqttPublishStatus();
    }

    else if (strncmp(cmdPayload_lower, "getconf", 7) == 0)
    {
      sendLog(F("CONF: listing all conf parameters:"));
      getConfig((char *)"confDevWiFi");
      getConfig((char *)"confWeb");
      getConfig((char *)"confMqtt");
      getConfig((char *)"confBas");
      getConfig((char *)"confAdv");
      getConfig((char *)"confAdd");
      getConfig((char *)"confTime");
      getConfig((char *)"confLog");
      sendLog(F("------"));
    }
    else if (strncmp(cmdPayload_lower, "delconf", 7) == 0)
    {
      sendLog(F("deleting configuration..."));
      deleteConfig();
    }

    cmdInQueue = false;
  }
}

void cmdPrintHelp()
{
  sendLog(F("valid commands:"));
  sendLog(F("   sysinfo       show uptime, heap usage..."));
  sendLog(F("   date          show current date/time"));
  sendLog(F("   syncclock     perform NTP time sync now"));
  sendLog(F("   debugmode [0/1]"));
  sendLog(F("   loadconf      load saved configuration"));
  sendLog(F("   getconf       list all conf parameters"));
  sendLog(F("   get [PARAM]   show conf value"));
  sendLog(F("   get values    list current saved values"));
  sendLog(F("   set [PARAM] [VALUE] (1 blank after PARAM to clear)"));
  sendLog(F("   saveconf      save all configurations"));
  sendLog(F("   savevalues    save set values"));
  sendLog(F("   clearcreds    delete all passwords"));
  sendLog(F("   clearwifi     delete WiFi configurations"));
  sendLog(F("   mqttinfo      MQTT connection status"));
  sendLog(F("   mqttreset     reset MQTT connection"));
  sendLog(F("   encrypt       switch on encrypted stored passwords"));
  sendLog(F("   decrypt       switch off encrypted stored passwords"));
  sendLog(F("                 WARNING: deletes all currently saved credentials"));
  sendLog(F("   ls            list files on SPIFFS"));
  sendLog(F("   delconf       delete ALL configuration"));
  sendLog(F("   restart"));
}
# 1 "D:/Flo/git/WiFiThermostat/src/commonFunctions.ino"


char *strlwr(char *str)
{
  unsigned char *p = (unsigned char *)str;
  while (*p)
  {
    *p = tolower((unsigned char)*p);
    p++;
  }
  return str;
}

double round2(double value) {
   return round(value * 100) / 100.0;
}

double round1(double value) {
   return round(value * 10) / 10.0;
}

char* XORENC(char* in, char* key){

  int insize = strlen(in);
  int keysize = strlen(key);
  for(int x=0; x<insize; x++){
    for(int i=0; i<keysize;i++){
      in[x]=(in[x]^key[i])^(x*i);
    }
  }
  return in;
}

char timeStringFromSeconds[10];
char* getTimeStringFromSeconds(unsigned int inSeconds) {
  unsigned int minutes, hours, seconds;
  minutes = inSeconds/60;
  hours = minutes/60;
  seconds = inSeconds - (hours*3600 + minutes*60);
  sprintf(timeStringFromSeconds, "%02u:%02u:%02u", hours, minutes, seconds);
  return timeStringFromSeconds;
}
# 1 "D:/Flo/git/WiFiThermostat/src/config.ino"
# 12 "D:/Flo/git/WiFiThermostat/src/config.ino"
void setConfig(char *param, char *value)
{
  if (confLog.logLevelSerial >= LOGLEVEL_VERBOSE)
  {
    Serial.print("setConfig - '");
    Serial.print(param);
    Serial.print("' to '");
    Serial.print(value);
    Serial.println("'");
  }


  strlwr(param);


  if (strcmp(param, "temp") == 0)
  {
    float valueFloat = round(atof(value) * 2.0) / 2.0;
    setTempTo(valueFloat);
  }
  else if (strcmp(param, "templow") == 0)
  {
    float valueFloat = round(atof(value) * 2.0) / 2.0;
    setTempLowTo(valueFloat);
  }
  else if (strcmp(param, "templow2") == 0)
  {
    float valueFloat = round(atof(value) * 2.0) / 2.0;
    setTempLow2To(valueFloat);
  }
  else if (strcmp(param, "mode") == 0)
  {
    int val = atoi(value);
    if (val >= 0 && val <= 1)
    {
      setHeatingmodeTo(val);
    }
  }
  else if (strcmp(param, "preset") == 0)
  {
    int val = atoi(value);
    if (val >= 0 && val <= 2)
    {
      setPresetTo(val);
    }
  }


  else if (strcmp(param, "devname") == 0)
  {
    if (strcmp(value, confDevWiFi.deviceName) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confDevWiFi.deviceName, "", sizeof(confDevWiFi.deviceName));
        configChangedRestartRequired = true;
        confDevWiFi.wasChanged = true;
      }
      else
      {
        if (strlen(value) >= 4)
        {
          strlcpy(confDevWiFi.deviceName, value, sizeof(confDevWiFi.deviceName));
          configChangedRestartRequired = true;
          confDevWiFi.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "hostname") == 0)
  {
    if (strcmp(value, confDevWiFi.hostName) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confDevWiFi.hostName, "", sizeof(confDevWiFi.hostName));
        configChangedRestartRequired = true;
        confDevWiFi.wasChanged = true;
      }
      else
      {
        if (strlen(value) >= 4)
        {
          strlcpy(confDevWiFi.hostName, value, sizeof(confDevWiFi.hostName));
          configChangedRestartRequired = true;
          confDevWiFi.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "ssid1") == 0)
  {
    if (strcmp(value, confDevWiFi.WiFiSSID1) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confDevWiFi.WiFiSSID1, "", sizeof(confDevWiFi.WiFiSSID1));
        configChangedRestartRequired = true;
        confDevWiFi.wasChanged = true;
      }
      else
      {
        strlcpy(confDevWiFi.WiFiSSID1, value, sizeof(confDevWiFi.WiFiSSID1));
        configChangedRestartRequired = true;
        confDevWiFi.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "wpw1") == 0)
  {
    if (strcmp(value, confDevWiFi.WiFiPW1) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confDevWiFi.WiFiPW1, "", sizeof(confDevWiFi.WiFiPW1));
        configChangedRestartRequired = true;
        confDevWiFi.wasChanged = true;
      }
      else
      {
        if (!strcmp(value, "****") == 0)
        {
          strlcpy(confDevWiFi.WiFiPW1, value, sizeof(confDevWiFi.WiFiPW1));
          configChangedRestartRequired = true;
          confDevWiFi.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "ssid2") == 0)
  {
    if (strcmp(value, confDevWiFi.WiFiSSID2) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confDevWiFi.WiFiSSID2, "", sizeof(confDevWiFi.WiFiSSID2));
        configChangedRestartRequired = true;
        confDevWiFi.wasChanged = true;
      }
      else
      {
        strlcpy(confDevWiFi.WiFiSSID2, value, sizeof(confDevWiFi.WiFiSSID2));
        configChangedRestartRequired = true;
        confDevWiFi.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "wpw2") == 0)
  {
    if (strcmp(value, confDevWiFi.WiFiPW2) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confDevWiFi.WiFiPW2, "", sizeof(confDevWiFi.WiFiPW2));
        configChangedRestartRequired = true;
        confDevWiFi.wasChanged = true;
      }
      else
      {
        if (!strcmp(value, "****") == 0)
        {
          strlcpy(confDevWiFi.WiFiPW2, value, sizeof(confDevWiFi.WiFiPW2));
          configChangedRestartRequired = true;
          confDevWiFi.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "wpwap") == 0)
  {
    if (strcmp(value, confDevWiFi.WiFiAPModePassword) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confDevWiFi.WiFiAPModePassword, "", sizeof(confDevWiFi.WiFiAPModePassword));
        confDevWiFi.wasChanged = true;
      }
      else
      {
        if (!strcmp(value, "****") == 0)
        {
          strlcpy(confDevWiFi.WiFiAPModePassword, value, sizeof(confDevWiFi.WiFiAPModePassword));
          confDevWiFi.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "waptout") == 0)
  {
    int tmpval = atoi(value);
    if (tmpval != confDevWiFi.WiFiAPModeTimeout)
    {
      if (tmpval >= 0 && tmpval <= 120)
      {
        confDevWiFi.WiFiAPModeTimeout = tmpval;
        confDevWiFi.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "wconncheck") == 0)
  {
    int tmpval = atoi(value);
    if (tmpval != confDevWiFi.WiFiConnCheckInterval)
    {
      if (tmpval == 0)
      {
        confDevWiFi.WiFiConnCheckInterval = 0;
        confDevWiFi.wasChanged = true;
      }
      else
      {
        if (tmpval >= 10 && tmpval <= 3600)
        {
          confDevWiFi.WiFiConnCheckInterval = tmpval;
          confDevWiFi.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "wretry") == 0)
  {
    int tmpval = atoi(value);
    if (tmpval != confDevWiFi.WiFiRetryInterval)
    {
      if (tmpval >= 0 && tmpval <= 120)
      {
        confDevWiFi.WiFiRetryInterval = tmpval;
        confDevWiFi.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "wreboot") == 0)
  {
    int tmpval = atoi(value);
    if (tmpval != confDevWiFi.WiFiRebootOnNoConnect)
    {
      if (tmpval >= 0 && tmpval <= 2880)
      {
        confDevWiFi.WiFiRebootOnNoConnect = tmpval;
        confDevWiFi.wasChanged = true;
      }
    }
  }


  else if (strcmp(param, "apitoken") == 0)
  {
    if (strcmp(value, confWeb.http_token) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confWeb.http_token, "", sizeof(confWeb.http_token));
        confWeb.wasChanged = true;
      }
      else
      {
        if (!strcmp(value, "****") == 0)
        {
          strlcpy(confWeb.http_token, value, sizeof(confWeb.http_token));
          confWeb.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "httpua") == 0)
  {
    if (strcmp(value, confWeb.http_user) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confWeb.http_user, "", sizeof(confWeb.http_user));
        confWeb.wasChanged = true;
      }
      else
      {
        strlcpy(confWeb.http_user, value, sizeof(confWeb.http_user));
        confWeb.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "httppa") == 0)
  {
    if (strcmp(value, confWeb.http_pass) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confWeb.http_pass, "", sizeof(confWeb.http_pass));
        confWeb.wasChanged = true;
      }
      else
      {
        if (!strcmp(value, "****") == 0)
        {
          strlcpy(confWeb.http_pass, value, sizeof(confWeb.http_pass));
          confWeb.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "httpauth") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confWeb.http_user_auth != tmpval)
    {
      confWeb.http_user_auth = tmpval;
      confWeb.wasChanged = true;
    }
  }
  else if (strcmp(param, "httpu1") == 0)
  {
    if (strcmp(value, confWeb.http_user1) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confWeb.http_user1, "", sizeof(confWeb.http_user1));
        confWeb.wasChanged = true;
      }
      else
      {
        strlcpy(confWeb.http_user1, value, sizeof(confWeb.http_user1));
        confWeb.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "httpp1") == 0)
  {
    if (strcmp(value, confWeb.http_pass1) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confWeb.http_pass1, "", sizeof(confWeb.http_pass1));
        confWeb.wasChanged = true;
      }
      else
      {
        if (!strcmp(value, "****") == 0)
        {
          strlcpy(confWeb.http_pass1, value, sizeof(confWeb.http_pass1));
          confWeb.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "httpu2") == 0)
  {
    if (strcmp(value, confWeb.http_user2) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confWeb.http_user2, "", sizeof(confWeb.http_user2));
        confWeb.wasChanged = true;
      }
      else
      {
        strlcpy(confWeb.http_user2, value, sizeof(confWeb.http_user2));
        confWeb.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "httpp2") == 0)
  {
    if (strcmp(value, confWeb.http_pass2) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confWeb.http_pass2, "", sizeof(confWeb.http_pass2));
        confWeb.wasChanged = true;
      }
      else
      {
        if (!strcmp(value, "****") == 0)
        {
          strlcpy(confWeb.http_pass2, value, sizeof(confWeb.http_pass2));
          confWeb.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "wconsole") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confWeb.wConsole != tmpval)
    {
      confWeb.wConsole = tmpval;
      configChangedRestartRequired = true;
      confWeb.wasChanged = true;
    }
  }
  else if (strcmp(param, "wsconsole") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confWeb.wsConsole != tmpval)
    {
      confWeb.wsConsole = tmpval;
      configChangedRestartRequired = true;
      confWeb.wasChanged = true;
    }
  }


  else if (strcmp(param, "mqttenable") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confMqtt.mqtt_enable != tmpval)
    {
      confMqtt.mqtt_enable = tmpval;
      configChangedMqttConnResetRequired = true;
      confMqtt.wasChanged = true;
    }
  }
  else if (strcmp(param, "mqtthost") == 0)
  {
    if (strcmp(value, confMqtt.mqtt_server) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confMqtt.mqtt_server, "", sizeof(confMqtt.mqtt_server));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
      else
      {
        strlcpy(confMqtt.mqtt_server, value, sizeof(confMqtt.mqtt_server));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "mqttport") == 0)
  {
    if (atoi(value) != confMqtt.mqtt_port)
    {
      confMqtt.mqtt_port = atoi(value);
      configChangedMqttConnResetRequired = true;
      confMqtt.wasChanged = true;
    }
  }
  else if (strcmp(param, "mqttuser") == 0)
  {
    if (strcmp(value, confMqtt.mqtt_user) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confMqtt.mqtt_user, "", sizeof(confMqtt.mqtt_user));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
      else
      {
        strlcpy(confMqtt.mqtt_user, value, sizeof(confMqtt.mqtt_user));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "mqttpass") == 0)
  {
    if (strcmp(value, confMqtt.mqtt_pass) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confMqtt.mqtt_pass, "", sizeof(confMqtt.mqtt_pass));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
      else
      {
        if (!strcmp(value, "****") == 0)
        {
          strlcpy(confMqtt.mqtt_pass, value, sizeof(confMqtt.mqtt_pass));
          configChangedMqttConnResetRequired = true;
          confMqtt.wasChanged = true;
        }
      }
    }
  }
  else if (strcmp(param, "intop") == 0)
  {
    if (strcmp(value, confMqtt.mqtt_topic_in) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confMqtt.mqtt_topic_in, "", sizeof(confMqtt.mqtt_topic_in));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
      else
      {
        strlcpy(confMqtt.mqtt_topic_in, value, sizeof(confMqtt.mqtt_topic_in));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "outtop") == 0)
  {
    if (strcmp(value, confMqtt.mqtt_topic_out) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confMqtt.mqtt_topic_out, "", sizeof(confMqtt.mqtt_topic_out));
        confMqtt.wasChanged = true;
      }
      else
      {
        strlcpy(confMqtt.mqtt_topic_out, value, sizeof(confMqtt.mqtt_topic_out));
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "outret") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confMqtt.mqtt_outRetain != tmpval)
    {
      confMqtt.mqtt_outRetain = tmpval;
      confMqtt.wasChanged = true;
      if (tmpval == false)
      {
        publishDeleteRetainedOutMessages();
      }
    }
  }
  else if (strcmp(param, "outretsens") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confMqtt.mqtt_outRetain_sensors != tmpval)
    {
      confMqtt.mqtt_outRetain_sensors = tmpval;
      confMqtt.wasChanged = true;
      if (tmpval == false)
      {
        publishDeleteRetainedOutMessages_sensors();
      }
    }
  }
  else if (strcmp(param, "outpubint") == 0)
  {
    if (atoi(value) != confMqtt.mqtt_outPubInterval)
    {
      confMqtt.mqtt_outPubInterval = atoi(value);
      confMqtt.wasChanged = true;
    }
  }
  else if (strcmp(param, "outpubintsens") == 0)
  {
    if (atoi(value) != confMqtt.mqtt_outPubInterval_sensors)
    {
      confMqtt.mqtt_outPubInterval_sensors = atoi(value);
      confMqtt.wasChanged = true;
    }
  }
  else if (strcmp(param, "willtop") == 0)
  {
    if (strcmp(value, confMqtt.mqtt_willTopic) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confMqtt.mqtt_willTopic, "", sizeof(confMqtt.mqtt_willTopic));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
      else
      {
        strlcpy(confMqtt.mqtt_willTopic, value, sizeof(confMqtt.mqtt_willTopic));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "willqos") == 0)
  {
    int tmpval = atoi(value);
    if (tmpval != confMqtt.mqtt_willQos)
    {
      if (tmpval >= 0 && tmpval <= 2)
      {
        confMqtt.mqtt_willQos = tmpval;
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "willret") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confMqtt.mqtt_willRetain != tmpval)
    {
      confMqtt.mqtt_willRetain = tmpval;
      configChangedMqttConnResetRequired = true;
      confMqtt.wasChanged = true;
    }
  }
  else if (strcmp(param, "willmsg") == 0)
  {
    if (strcmp(value, confMqtt.mqtt_willMsg) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confMqtt.mqtt_willMsg, "", sizeof(confMqtt.mqtt_willMsg));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
      else
      {
        strlcpy(confMqtt.mqtt_willMsg, value, sizeof(confMqtt.mqtt_willMsg));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "connmsg") == 0)
  {
    if (strcmp(value, confMqtt.mqtt_connMsg) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confMqtt.mqtt_connMsg, "", sizeof(confMqtt.mqtt_connMsg));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
      else
      {
        strlcpy(confMqtt.mqtt_connMsg, value, sizeof(confMqtt.mqtt_connMsg));
        configChangedMqttConnResetRequired = true;
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "hbenable") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confMqtt.mqtt_enable_heartbeat != tmpval)
    {
      confMqtt.mqtt_enable_heartbeat = tmpval;
      confMqtt.wasChanged = true;
    }
  }
  else if (strcmp(param, "hbreconn") == 0)
  {
    unsigned int tmpval = atoi(value);
    if ((tmpval * 60000) != confMqtt.mqtt_heartbeat_maxage_reconnect)
    {
      if (tmpval == 0)
      {
        confMqtt.mqtt_heartbeat_maxage_reconnect = 0;
        confMqtt.wasChanged = true;
      }
      else if (tmpval >= 2 && tmpval <= 10)
      {
        confMqtt.mqtt_heartbeat_maxage_reconnect = tmpval * 60000;
        confMqtt.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "hbreboot") == 0)
  {
    unsigned int tmpval = atoi(value);
    if ((tmpval * 60000) != confMqtt.mqtt_heartbeat_maxage_reboot)
    {
      if (tmpval == 0)
      {
        confMqtt.mqtt_heartbeat_maxage_reboot = 0;
        confMqtt.wasChanged = true;
      }
      else if (tmpval >= 10 && tmpval <= 120)
      {
        confMqtt.mqtt_heartbeat_maxage_reboot = tmpval * 60000;
        confMqtt.wasChanged = true;
      }
    }
  }


  else if (strcmp(param, "autosavetemp") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confBas.autoSaveSetTemp != tmpval)
    {
      confBas.autoSaveSetTemp = tmpval;
      confBas.wasChanged = true;
    }
  }
  else if (strcmp(param, "autosavemode") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confBas.autoSaveHeatingMode != tmpval)
    {
      confBas.autoSaveHeatingMode = tmpval;
      confBas.wasChanged = true;
    }
  }
  else if (strcmp(param, "savetomqttret") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confBas.saveToMqttRetained != tmpval)
    {
      confBas.saveToMqttRetained = tmpval;
      confBas.wasChanged = true;
      if (tmpval == false)
      {
        publishDeleteRetainedSavedStates();
      }
    }
  }
  else if (strcmp(param, "tempmin") == 0)
  {
    float valueFloat = round(atof(value) * 2.0) / 2.0;
    if (valueFloat != confBas.setTempMin)
    {
      if (valueFloat >= 10 && valueFloat <= 16)
      {
        confBas.setTempMin = valueFloat;
        confBas.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "tempmax") == 0)
  {
    float valueFloat = round(atof(value) * 2.0) / 2.0;
    if (valueFloat != confBas.setTempMax)
    {
      if (valueFloat >= 18 && valueFloat <= 30)
      {
        confBas.setTempMax = valueFloat;
        confBas.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "measint") == 0)
  {
    int valueInt = atoi(value);
    if (valueInt != confBas.measureInterval)
    {
      if (valueInt >= 5 && valueInt <= 60)
      {
        confBas.measureInterval = valueInt;
        confBas.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "dispint") == 0)
  {
    int valueInt = atoi(value);
    if (valueInt != confBas.displayInterval)
    {
      if (valueInt >= 1 && valueInt <= 60)
      {
        confBas.displayInterval = valueInt;
        confBas.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "disptout") == 0)
  {
    int valueInt = atoi(value);
    if (valueInt != confBas.displayTimeout)
    {
      if (valueInt >= 2 && valueInt <= 3600)
      {
        confBas.displayTimeout = valueInt;
        confBas.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "pirendisp") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (tmpval != confBas.PIR_enablesDisplay)
    {
      confBas.PIR_enablesDisplay = tmpval;
      confBas.wasChanged = true;
    }
  }
  else if (strcmp(param, "pirendispps0") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (tmpval != confBas.PIR_enablesDisplay_preset0only)
    {
      confBas.PIR_enablesDisplay_preset0only = tmpval;
      confBas.wasChanged = true;
    }
  }
  else if (strcmp(param, "togthdisp") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (tmpval != confBas.togglingTempHumAIDisplay)
    {
      confBas.togglingTempHumAIDisplay = tmpval;
      confBas.wasChanged = true;
    }
  }


  else if (strcmp(param, "minofftime") == 0)
  {
    int valueInt = atoi(value);
    if (valueInt != confAdv.heatingMinOffTime)
    {
      confAdv.heatingMinOffTime = valueInt;
      confAdv.wasChanged = true;
    }
  }
  else if (strcmp(param, "tempdec") == 0)
  {
    float valueFloat = atof(value);
    if (valueFloat != confAdv.setTempDecreaseVal)
    {
      if (valueFloat >= 0.0 && valueFloat <= 1.5)
      {
        confAdv.setTempDecreaseVal = valueFloat;
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "hyst") == 0)
  {
    float valueFloat = atof(value);
    if (valueFloat != confAdv.hysteresis)
    {
      if (valueFloat >= 0.1 && valueFloat <= 4.0)
      {
        confAdv.hysteresis = valueFloat;
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "tempcorr") == 0)
  {
    float valueFloat = atof(value);
    if (valueFloat != confAdv.tempCorrVal)
    {
      if (valueFloat >= -5.0 && valueFloat <= 5.0)
      {
        confAdv.tempCorrVal = valueFloat;
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "humcorr") == 0)
  {
    int valueInt = atoi(value);
    if (valueInt != confAdv.humCorrVal)
    {
      if (valueInt >= -40 && valueInt <= 40)
      {
        confAdv.humCorrVal = valueInt;
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "offmsg") == 0)
  {
    if (strcmp(value, confAdv.offMessage) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdv.offMessage, "", sizeof(confAdv.offMessage));
        confAdv.wasChanged = true;
      }
      else
      {
        strlcpy(confAdv.offMessage, value, sizeof(confAdv.offMessage));
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "modename0") == 0)
  {
    if (strcmp(value, confAdv.modeName0) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdv.modeName0, "", sizeof(confAdv.modeName0));
        confAdv.wasChanged = true;
      }
      else
      {
        strlcpy(confAdv.modeName0, value, sizeof(confAdv.modeName0));
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "modename1") == 0)
  {
    if (strcmp(value, confAdv.modeName1) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdv.modeName1, "", sizeof(confAdv.modeName1));
        confAdv.wasChanged = true;
      }
      else
      {
        strlcpy(confAdv.modeName1, value, sizeof(confAdv.modeName1));
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "psetname0") == 0)
  {
    if (strcmp(value, confAdv.psetName0) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdv.psetName0, "", sizeof(confAdv.psetName0));
        confAdv.wasChanged = true;
      }
      else
      {
        strlcpy(confAdv.psetName0, value, sizeof(confAdv.psetName0));
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "psetname1") == 0)
  {
    if (strcmp(value, confAdv.psetName1) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdv.psetName1, "", sizeof(confAdv.psetName1));
        confAdv.wasChanged = true;
      }
      else
      {
        strlcpy(confAdv.psetName1, value, sizeof(confAdv.psetName1));
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "psetname2") == 0)
  {
    if (strcmp(value, confAdv.psetName2) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdv.psetName2, "", sizeof(confAdv.psetName2));
        confAdv.wasChanged = true;
      }
      else
      {
        strlcpy(confAdv.psetName2, value, sizeof(confAdv.psetName2));
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "itemplab") == 0)
  {
    if (strcmp(value, confAdv.iTempLabel) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdv.iTempLabel, "I", sizeof(confAdv.iTempLabel));
        confAdv.wasChanged = true;
      }
      else
      {
        strlcpy(confAdv.iTempLabel, value, sizeof(confAdv.iTempLabel));
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "otemplab") == 0)
  {
    if (strcmp(value, confAdv.oTempLabel) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdv.oTempLabel, "O", sizeof(confAdv.oTempLabel));
        confAdv.wasChanged = true;
      }
      else
      {
        strlcpy(confAdv.oTempLabel, value, sizeof(confAdv.oTempLabel));
        confAdv.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "pausetout") == 0)
  {
    int valueInt = atoi(value);
    if (valueInt != confAdv.pauseTout)
    {
      if (valueInt >= 0 && valueInt <= 3600)
      {
        confAdv.pauseTout = valueInt;
        confAdv.wasChanged = true;
      }
    }
  }


  else if (strcmp(param, "outtemptop") == 0)
  {
    if (strcmp(value, confAdd.outTemp_topic_in) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdd.outTemp_topic_in, "", sizeof(confAdd.outTemp_topic_in));
        configChangedMqttConnResetRequired = true;
        confAdd.wasChanged = true;
      }
      else
      {
        strlcpy(confAdd.outTemp_topic_in, value, sizeof(confAdd.outTemp_topic_in));
        configChangedMqttConnResetRequired = true;
        confAdd.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "outhumtop") == 0)
  {
    if (strcmp(value, confAdd.outHum_topic_in) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdd.outHum_topic_in, "", sizeof(confAdd.outHum_topic_in));
        configChangedMqttConnResetRequired = true;
        confAdd.wasChanged = true;
      }
      else
      {
        strlcpy(confAdd.outHum_topic_in, value, sizeof(confAdd.outHum_topic_in));
        configChangedMqttConnResetRequired = true;
        confAdd.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "pirtop") == 0)
  {
    if (strcmp(value, confAdd.mqtt_topic_pir) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdd.mqtt_topic_pir, "", sizeof(confAdd.mqtt_topic_pir));
        confAdd.wasChanged = true;
      }
      else
      {
        strlcpy(confAdd.mqtt_topic_pir, value, sizeof(confAdd.mqtt_topic_pir));
        confAdd.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "pironpld") == 0)
  {
    if (strcmp(value, confAdd.mqtt_payload_pir_on) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdd.mqtt_payload_pir_on, "", sizeof(confAdd.mqtt_payload_pir_on));
        confAdd.wasChanged = true;
      }
      else
      {
        strlcpy(confAdd.mqtt_payload_pir_on, value, sizeof(confAdd.mqtt_payload_pir_on));
        confAdd.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "piroffpld") == 0)
  {
    if (strcmp(value, confAdd.mqtt_payload_pir_off) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confAdd.mqtt_payload_pir_off, "", sizeof(confAdd.mqtt_payload_pir_off));
        confAdd.wasChanged = true;
      }
      else
      {
        strlcpy(confAdd.mqtt_payload_pir_off, value, sizeof(confAdd.mqtt_payload_pir_off));
        confAdd.wasChanged = true;
      }
    }
  }

#ifdef ENABLE_FEATURE_NTP_TIME

  else if (strcmp(param, "tzstr") == 0)
  {
    if (strcmp(value, confTime.timeZoneStr) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confTime.timeZoneStr, "", sizeof(confTime.timeZoneStr));
        configChangedRestartRequired = true;
        confTime.wasChanged = true;
      }
      else
      {
        strlcpy(confTime.timeZoneStr, value, sizeof(confTime.timeZoneStr));
        configChangedRestartRequired = true;
        confTime.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "ntpenable") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confTime.ntpEnable != tmpval)
    {
      confTime.ntpEnable = tmpval;
      configChangedRestartRequired = true;
      confTime.wasChanged = true;
    }
  }
  else if (strcmp(param, "ntpserver1") == 0)
  {
    if (strcmp(value, confTime.ntpServer1) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confTime.ntpServer1, "", sizeof(confTime.ntpServer1));
        configChangedRestartRequired = true;
        confTime.wasChanged = true;
      }
      else
      {
        strlcpy(confTime.ntpServer1, value, sizeof(confTime.ntpServer1));
        configChangedRestartRequired = true;
        confTime.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "ntpserver2") == 0)
  {
    if (strcmp(value, confTime.ntpServer2) != 0)
    {
      if (strcmp(value, "0") == 0)
      {
        strlcpy(confTime.ntpServer2, "", sizeof(confTime.ntpServer2));
        configChangedRestartRequired = true;
        confTime.wasChanged = true;
      }
      else
      {
        strlcpy(confTime.ntpServer2, value, sizeof(confTime.ntpServer2));
        configChangedRestartRequired = true;
        confTime.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "ntpsyncint") == 0)
  {
    unsigned int valueInt = atoi(value) * 60;
    if (confTime.ntpSyncInterval != valueInt)
    {
      confTime.ntpSyncInterval = valueInt;
      configChangedRestartRequired = true;
      confTime.wasChanged = true;
    }
  }
#endif


  else if (strcmp(param, "loglevser") == 0)
  {
    int valueInt = atoi(value);
    if (confLog.logLevelSerial != valueInt)
    {
      if (valueInt >= 0 && valueInt <= 5)
      {
        confLog.logLevelSerial = valueInt;
        confLog.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "loglevweb") == 0)
  {
    int valueInt = atoi(value);
    if (confLog.logLevelWeb != valueInt)
    {
      if (valueInt >= 0 && valueInt <= 5)
      {
        confLog.logLevelWeb = valueInt;
        confLog.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "loglevmqtt") == 0)
  {
    int valueInt = atoi(value);
    if (confLog.logLevelMqtt != valueInt)
    {
      if (valueInt >= 0 && valueInt <= 5)
      {
        confLog.logLevelMqtt = valueInt;
        confLog.wasChanged = true;
      }
    }
  }
  else if (strcmp(param, "logwebrequests") == 0)
  {
    bool tmpval;
    if (atoi(value) == 1)
      tmpval = true;
    else
      tmpval = false;

    if (confLog.logWebRequests != tmpval)
    {
      confLog.logWebRequests = tmpval;
      confLog.wasChanged = true;
    }
  }

  getConfig(param);

  if (confCheckUnsaved())
  {
    lastConfigChange = millis();
    lastConfigChangeNoteAlreadyDone = false;
  }
}

void getConfig(char *param)
{
# 1315 "D:/Flo/git/WiFiThermostat/src/config.ino"
  strlwr(param);

  int isConfPage = 0;

  if (strcmp(param, "values") == 0)
    isConfPage = 100;
  else if (strcmp(param, "confdevwifi") == 0)
    isConfPage = 1;
  else if (strcmp(param, "confdev") == 0)
    isConfPage = 1;
  else if (strcmp(param, "confwifi") == 0)
    isConfPage = 1;
  else if (strcmp(param, "confweb") == 0)
    isConfPage = 2;
  else if (strcmp(param, "confmqtt") == 0)
    isConfPage = 3;
  else if (strcmp(param, "confbas") == 0)
    isConfPage = 4;
  else if (strcmp(param, "confadv") == 0)
    isConfPage = 5;
  else if (strcmp(param, "confadd") == 0)
    isConfPage = 6;
#ifdef ENABLE_FEATURE_NTP_TIME
  else if (strcmp(param, "conftime") == 0)
    isConfPage = 7;
#endif
  else if (strcmp(param, "conflog") == 0)
    isConfPage = 8;

  char buf[101];


  if (strcmp(param, "temp") == 0 || isConfPage == 100)
  {
    sprintf(buf, "setTemp: %2.1f", setTemp);
    sendLog(buf);
  }
  if (strcmp(param, "templow") == 0 || isConfPage == 100)
  {
    sprintf(buf, "setTempLow: %2.1f", setTempLow);
    sendLog(buf);
  }
  if (strcmp(param, "templow2") == 0 || isConfPage == 100)
  {
    sprintf(buf, "setTempLow2: %2.1f", setTempLow2);
    sendLog(buf);
  }
  if (strcmp(param, "mode") == 0 || isConfPage == 100)
  {
    sprintf(buf, "heatingMode: %d", heatingMode);
    sendLog(buf);
  }
  if (strcmp(param, "preset") == 0 || isConfPage == 100)
  {
    sprintf(buf, "preset: %d", preset);
    sendLog(buf);
  }


  if (strcmp(param, "devname") == 0 || isConfPage == 1)
  {
    sprintf_P(buf, "%s.devName: '%s'", PGMStr_confDevWiFi, confDevWiFi.deviceName);
    sendLog(buf);
  }
  if (strcmp(param, "hostname") == 0 || isConfPage == 1)
  {
    sprintf_P(buf, "%s.hostName: '%s'", PGMStr_confDevWiFi, confDevWiFi.hostName);
    sendLog(buf);
  }
  if (strcmp(param, "ssid1") == 0 || isConfPage == 1)
  {
    sprintf_P(buf, "%s.SSID1: '%s'", PGMStr_confDevWiFi, confDevWiFi.WiFiSSID1);
    sendLog(buf);
  }
  if (strcmp(param, "wpw1") == 0 || isConfPage == 1)
  {
#ifdef DEBUGMODE
    sprintf_P(buf, "%s.WPW1: '%s'", PGMStr_confDevWiFi, confDevWiFi.WiFiPW1);
#else
    sprintf_P(buf, "%s.WPW1: '******'", PGMStr_confDevWiFi);
#endif
    sendLog(buf);
  }
  if (strcmp(param, "ssid2") == 0 || isConfPage == 1)
  {
    sprintf_P(buf, "%s.SSID2: '%s'", PGMStr_confDevWiFi, confDevWiFi.WiFiSSID2);
    sendLog(buf);
  }
  if (strcmp(param, "wpw2") == 0 || isConfPage == 1)
  {
#ifdef DEBUGMODE
    sprintf_P(buf, "%s.WPW2: '%s'", PGMStr_confDevWiFi, confDevWiFi.WiFiPW2);
#else
    sprintf_P(buf, "%s.WPW2: '******'", PGMStr_confDevWiFi);
#endif
    sendLog(buf);
  }
  if (strcmp(param, "wpwap") == 0 || isConfPage == 1)
  {
#ifdef DEBUGMODE
    sprintf_P(buf, "%s.WPWAp: '%s'", PGMStr_confDevWiFi, confDevWiFi.WiFiAPModePassword);
#else
    sprintf_P(buf, "%s.WPWAp: '******'", PGMStr_confDevWiFi);
#endif
    sendLog(buf);
  }
  if (strcmp(param, "waptout") == 0 || isConfPage == 1)
  {
    sprintf_P(buf, "%s.WApTout: %d", PGMStr_confDevWiFi, confDevWiFi.WiFiAPModeTimeout);
    sendLog(buf);
  }
  if (strcmp(param, "wconncheck") == 0 || isConfPage == 1)
  {
    sprintf_P(buf, "%s.WConnCheck: %d", PGMStr_confDevWiFi, confDevWiFi.WiFiConnCheckInterval);
    sendLog(buf);
  }
  if (strcmp(param, "wretry") == 0 || isConfPage == 1)
  {
    sprintf_P(buf, "%s.WRetry: %d", PGMStr_confDevWiFi, confDevWiFi.WiFiRetryInterval);
    sendLog(buf);
  }
  if (strcmp(param, "wreboot") == 0 || isConfPage == 1)
  {
    sprintf_P(buf, "%s.WReboot: %d", PGMStr_confDevWiFi, confDevWiFi.WiFiRebootOnNoConnect);
    sendLog(buf);
  }


  if (strcmp(param, "apitoken") == 0 || isConfPage == 2)
  {
    sprintf_P(buf, "%s.apiToken: '%s'", PGMStr_confWeb, confWeb.http_token);
    sendLog(buf);
  }
  if (strcmp(param, "httpua") == 0 || isConfPage == 2)
  {
    sprintf_P(buf, "%s.httpUA: '%s'", PGMStr_confWeb, confWeb.http_user);
    sendLog(buf);
  }
  if (strcmp(param, "httppa") == 0 || isConfPage == 2)
  {
#ifdef DEBUGMODE
    sprintf_P(buf, "%s.httpPA: '%s'", PGMStr_confWeb, confWeb.http_pass);
#else
    sprintf_P(buf, "%s.httpPA: '****'", PGMStr_confWeb);
#endif
    sendLog(buf);
  }
  if (strcmp(param, "httpauth") == 0 || isConfPage == 2)
  {
    int tmp;
    if (confWeb.http_user_auth)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.httpAuth: %d", PGMStr_confWeb, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "httpu1") == 0 || isConfPage == 2)
  {
    sprintf_P(buf, "%s.httpU1: '%s'", PGMStr_confWeb, confWeb.http_user1);
    sendLog(buf);
  }
  if (strcmp(param, "httpp1") == 0 || isConfPage == 2)
  {
#ifdef DEBUGMODE
    sprintf_P(buf, "%s.httpP1: '%s'", PGMStr_confWeb, confWeb.http_pass1);
#else
    sprintf_P(buf, "%s.httpP1: '****'", PGMStr_confWeb);
#endif
    sendLog(buf);
  }
  if (strcmp(param, "httpu2") == 0 || isConfPage == 2)
  {
    sprintf_P(buf, "%s.httpU2: '%s'", PGMStr_confWeb, confWeb.http_user2);
    sendLog(buf);
  }
  if (strcmp(param, "httpp2") == 0 || isConfPage == 2)
  {
#ifdef DEBUGMODE
    sprintf_P(buf, "%s.httpP2: '%s'", PGMStr_confWeb, confWeb.http_pass2);
#else
    sprintf_P(buf, "%s.httpP2: '****'", PGMStr_confWeb);
#endif
    sendLog(buf);
  }
  if (strcmp(param, "wconsole") == 0 || isConfPage == 2)
  {
    int tmp;
    if (confWeb.wConsole)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.wConsole: %d", PGMStr_confWeb, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "wsconsole") == 0 || isConfPage == 2)
  {
    int tmp;
    if (confWeb.wsConsole)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.wsConsole: %d", PGMStr_confWeb, tmp);
    sendLog(buf);
  }


  if (strcmp(param, "mqttenable") == 0 || isConfPage == 3)
  {
    int tmp;
    if (confMqtt.mqtt_enable)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.mqttEnable: %d", PGMStr_confMqtt, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "mqtthost") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.mqttHost: '%s'", PGMStr_confMqtt, confMqtt.mqtt_server);
    sendLog(buf);
  }
  if (strcmp(param, "mqttport") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.mqttPort: %d", PGMStr_confMqtt, confMqtt.mqtt_port);
    sendLog(buf);
  }
  if (strcmp(param, "mqttuser") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.mqttUser: '%s'", PGMStr_confMqtt, confMqtt.mqtt_user);
    sendLog(buf);
  }
  if (strcmp(param, "mqttpass") == 0 || isConfPage == 3)
  {
#ifdef DEBUGMODE
    sprintf_P(buf, "%s.mqttPass: '%s'", PGMStr_confMqtt, confMqtt.mqtt_pass);
#else
    sprintf_P(buf, "%s.mqttPass: '****'", PGMStr_confMqtt);
#endif
    sendLog(buf);
  }
  if (strcmp(param, "intop") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.inTop: '%s'", PGMStr_confMqtt, confMqtt.mqtt_topic_in);
    sendLog(buf);
  }
  if (strcmp(param, "outtop") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.outTop: '%s'", PGMStr_confMqtt, confMqtt.mqtt_topic_out);
    sendLog(buf);
  }
  if (strcmp(param, "outret") == 0 || isConfPage == 3)
  {
    int tmp;
    if (confMqtt.mqtt_outRetain)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.outRet: %d", PGMStr_confMqtt, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "outretsens") == 0 || isConfPage == 3)
  {
    int tmp;
    if (confMqtt.mqtt_outRetain_sensors)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.outRetSens: %d", PGMStr_confMqtt, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "outpubint") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.outPubInt: %d", PGMStr_confMqtt, confMqtt.mqtt_outPubInterval);
    sendLog(buf);
  }
  if (strcmp(param, "outpubintsens") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.outPubIntSens: %d", PGMStr_confMqtt, confMqtt.mqtt_outPubInterval_sensors);
    sendLog(buf);
  }
  if (strcmp(param, "willtop") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.willTop: '%s'", PGMStr_confMqtt, confMqtt.mqtt_willTopic);
    sendLog(buf);
  }
  if (strcmp(param, "willqos") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.willQos: %d", PGMStr_confMqtt, confMqtt.mqtt_willQos);
    sendLog(buf);
  }
  if (strcmp(param, "willret") == 0 || isConfPage == 3)
  {
    int tmp;
    if (confMqtt.mqtt_willRetain)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.willRet: %d", PGMStr_confMqtt, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "willmsg") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.willMsg: '%s'", PGMStr_confMqtt, confMqtt.mqtt_willMsg);
    sendLog(buf);
  }
  if (strcmp(param, "connmsg") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.connMsg: '%s'", PGMStr_confMqtt, confMqtt.mqtt_connMsg);
    sendLog(buf);
  }
  if (strcmp(param, "hbenable") == 0 || isConfPage == 3)
  {
    int tmp;
    if (confMqtt.mqtt_enable_heartbeat)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.hbEnable: %d", PGMStr_confMqtt, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "hbreconn") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.hbReconn: %lu", PGMStr_confMqtt, confMqtt.mqtt_heartbeat_maxage_reconnect / 60000);
    sendLog(buf);
  }
  if (strcmp(param, "hbreboot") == 0 || isConfPage == 3)
  {
    sprintf_P(buf, "%s.hbReboot: %lu", PGMStr_confMqtt, confMqtt.mqtt_heartbeat_maxage_reboot / 60000);
    sendLog(buf);
  }


  if (strcmp(param, "autosavetemp") == 0 || isConfPage == 4)
  {
    int tmp;
    if (confBas.autoSaveSetTemp)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.autoSaveTemp: %d", PGMStr_confBas, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "autosavemode") == 0 || isConfPage == 4)
  {
    int tmp;
    if (confBas.autoSaveHeatingMode)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.autoSaveMode: %d", PGMStr_confBas, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "savetomqttret") == 0 || isConfPage == 4)
  {
    int tmp;
    if (confBas.saveToMqttRetained)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.savetoMqttRet: %d", PGMStr_confBas, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "tempmin") == 0 || isConfPage == 4)
  {
    sprintf_P(buf, "%s.tempMin: '%2.1f'", PGMStr_confBas, confBas.setTempMin);
    sendLog(buf);
  }
  if (strcmp(param, "tempmax") == 0 || isConfPage == 4)
  {
    sprintf_P(buf, "%s.tempMax: '%2.1f'", PGMStr_confBas, confBas.setTempMax);
    sendLog(buf);
  }
  if (strcmp(param, "measint") == 0 || isConfPage == 4)
  {
    sprintf_P(buf, "%s.measInt: %d", PGMStr_confBas, confBas.measureInterval);
    sendLog(buf);
  }
  if (strcmp(param, "dispint") == 0 || isConfPage == 4)
  {
    sprintf_P(buf, "%s.dispInt: %d", PGMStr_confBas, confBas.displayInterval);
    sendLog(buf);
  }
  if (strcmp(param, "disptout") == 0 || isConfPage == 4)
  {
    sprintf_P(buf, "%s.dispTout: %d", PGMStr_confBas, confBas.displayTimeout);
    sendLog(buf);
  }
  if (strcmp(param, "pirendisp") == 0 || isConfPage == 4)
  {
    int tmp;
    if (confBas.PIR_enablesDisplay)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.pirEnDisp: %d", PGMStr_confBas, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "pirendispps0") == 0 || isConfPage == 4)
  {
    int tmp;
    if (confBas.PIR_enablesDisplay_preset0only)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.pirEnDispPs0: %d", PGMStr_confBas, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "togthdisp") == 0 || isConfPage == 4)
  {
    int tmp;
    if (confBas.togglingTempHumAIDisplay)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.togTHdisp: %d", PGMStr_confBas, tmp);
    sendLog(buf);
  }


  if (strcmp(param, "minofftime") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.minOffTime: %d", PGMStr_confAdv, confAdv.heatingMinOffTime);
    sendLog(buf);
  }
  if (strcmp(param, "tempdec") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.tempDec: %1.2f", PGMStr_confAdv, confAdv.setTempDecreaseVal);
    sendLog(buf);
  }
  if (strcmp(param, "hyst") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.hyst: %1.2f", PGMStr_confAdv, confAdv.hysteresis);
    sendLog(buf);
  }
  if (strcmp(param, "tempcorr") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.tempCorr: %1.2f", PGMStr_confAdv, confAdv.tempCorrVal);
    sendLog(buf);
  }
  if (strcmp(param, "humcorr") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.humCorr: %d", PGMStr_confAdv, confAdv.humCorrVal);
    sendLog(buf);
  }
  if (strcmp(param, "offmsg") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.offMsg: '%s'", PGMStr_confAdv, confAdv.offMessage);
    sendLog(buf);
  }
  if (strcmp(param, "modename0") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.modeName0: '%s'", PGMStr_confAdv, confAdv.modeName0);
    sendLog(buf);
  }
  if (strcmp(param, "modename1") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.modeName1: '%s'", PGMStr_confAdv, confAdv.modeName1);
    sendLog(buf);
  }
  if (strcmp(param, "psetname0") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.psetName0: '%s'", PGMStr_confAdv, confAdv.psetName0);
    sendLog(buf);
  }
  if (strcmp(param, "psetname1") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.psetName1: '%s'", PGMStr_confAdv, confAdv.psetName1);
    sendLog(buf);
  }
  if (strcmp(param, "psetname2") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.psetName2: '%s'", PGMStr_confAdv, confAdv.psetName2);
    sendLog(buf);
  }
  if (strcmp(param, "itemplab") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.iTempLab: '%s'", PGMStr_confAdv, confAdv.iTempLabel);
    sendLog(buf);
  }
  if (strcmp(param, "otemplab") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.oTempLab: '%s'", PGMStr_confAdv, confAdv.oTempLabel);
    sendLog(buf);
  }
  if (strcmp(param, "pausetout") == 0 || isConfPage == 5)
  {
    sprintf_P(buf, "%s.pauseTout: %d", PGMStr_confAdv, confAdv.pauseTout);
    sendLog(buf);
  }


  if (strcmp(param, "outtemptop") == 0 || isConfPage == 6)
  {
    sprintf_P(buf, "%s.outTempTop: '%s'", PGMStr_confAdd, confAdd.outTemp_topic_in);
    sendLog(buf);
  }
  if (strcmp(param, "outhumtop") == 0 || isConfPage == 6)
  {
    sprintf_P(buf, "%s.outHumTop: '%s'", PGMStr_confAdd, confAdd.outHum_topic_in);
    sendLog(buf);
  }
  if (strcmp(param, "pirtop") == 0 || isConfPage == 6)
  {
    sprintf_P(buf, "%s.PIRTop: '%s'", PGMStr_confAdd, confAdd.mqtt_topic_pir);
    sendLog(buf);
  }
  if (strcmp(param, "pironpld") == 0 || isConfPage == 6)
  {
    sprintf_P(buf, "%s.PIROnPld: '%s'", PGMStr_confAdd, confAdd.mqtt_payload_pir_on);
    sendLog(buf);
  }
  if (strcmp(param, "piroffpld") == 0 || isConfPage == 6)
  {
    sprintf_P(buf, "%s.PIROffPld: '%s'", PGMStr_confAdd, confAdd.mqtt_payload_pir_off);
    sendLog(buf);
  }

#ifdef ENABLE_FEATURE_NTP_TIME

  if (strcmp(param, "tzstr") == 0 || isConfPage == 7)
  {
    sprintf_P(buf, "%s.TZstr: '%s'", PGMStr_confTime, confTime.timeZoneStr);
    sendLog(buf);
  }
  if (strcmp(param, "ntpenable") == 0 || isConfPage == 7)
  {
    int tmp;
    if (confTime.ntpEnable)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.ntpEnable: %d", PGMStr_confTime, tmp);
    sendLog(buf);
  }
  if (strcmp(param, "ntpserver1") == 0 || isConfPage == 7)
  {
    sprintf_P(buf, "%s.ntpServer1: '%s'", PGMStr_confTime, confTime.ntpServer1);
    sendLog(buf);
  }
  if (strcmp(param, "ntpserver2") == 0 || isConfPage == 7)
  {
    sprintf_P(buf, "%s.ntpServer2: '%s'", PGMStr_confTime, confTime.ntpServer2);
    sendLog(buf);
  }
  if (strcmp(param, "ntpsyncint") == 0 || isConfPage == 7)
  {
    sprintf_P(buf, "%s.ntpSyncInt: %lu", PGMStr_confTime, confTime.ntpSyncInterval / 60);
    sendLog(buf);
  }
#endif


  if (strcmp(param, "loglevser") == 0 || isConfPage == 8)
  {
    sprintf_P(buf, "%s.logLevSer: %d", PGMStr_confLog, confLog.logLevelSerial);
    sendLog(buf);
  }
  if (strcmp(param, "loglevweb") == 0 || isConfPage == 8)
  {
    sprintf_P(buf, "%s.logLevWeb: %d", PGMStr_confLog, confLog.logLevelWeb);
    sendLog(buf);
  }
  if (strcmp(param, "loglevmqtt") == 0 || isConfPage == 8)
  {
    sprintf_P(buf, "%s.logLevMqtt: %d", PGMStr_confLog, confLog.logLevelMqtt);
    sendLog(buf);
  }
  if (strcmp(param, "logwebrequests") == 0 || isConfPage == 8)
  {
    int tmp;
    if (confLog.logWebRequests)
      tmp = 1;
    else
      tmp = 0;
    sprintf_P(buf, "%s.logWebRequests: %d", PGMStr_confLog, tmp);
    sendLog(buf);
  }
}

boolean loadConfigDevWiFi()
{
  char configFileName[] = "/confDevWiFi.json";
  if (SPIFFS.exists(configFileName))
  {
    File configFile = SPIFFS.open(configFileName, "r");
    if (!configFile)
    {
      Serial.print(F("ERR: Failed to open file '"));
      Serial.print(configFileName);
      Serial.println("'");
      return false;
    }
    else
    {
      Serial.print("file '");
      Serial.print(configFileName);
      Serial.print("' opened. ");
      size_t size = configFile.size();
      Serial.print("size=");
      Serial.println(size);

      if (size > 1000)
      {
        Serial.println(F("Config file size is too large"));
        return false;
      }

      std::unique_ptr<char[]> buf(new char[size]);
#ifdef DEBUGMODE
      Serial.println(F("file content:"));
      while (configFile.available())
      {
        Serial.write(configFile.read());
      }
      Serial.println();
      configFile.seek(0, SeekSet);
#endif
      configFile.readBytes(buf.get(), size);

      DynamicJsonDocument json(size + 50);
      DeserializationError error = deserializeJson(json, buf.get());
      if (error)
      {
        Serial.println(F("Failed to parse config file"));
        return false;
      }

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      char tmp[101];
#endif

      strlcpy(confDevWiFi.deviceName, json["devName"] | "", sizeof(confDevWiFi.deviceName));
      strlcpy(confDevWiFi.hostName, json["hostName"] | "", sizeof(confDevWiFi.hostName));

      strlcpy(confDevWiFi.WiFiSSID1, json["SSID1"] | "", sizeof(confDevWiFi.WiFiSSID1));

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      if (confEncryptionEnabled)
      {
        strlcpy(tmp, json["WPW1"] | "", sizeof(tmp));
        strlcpy(confDevWiFi.WiFiPW1, XORENC(tmp, encKey), sizeof(confDevWiFi.WiFiPW1));
      }
      else
        strlcpy(confDevWiFi.WiFiPW1, json["WPW1"] | "", sizeof(confDevWiFi.WiFiPW1));
#else
      strlcpy(confDevWiFi.WiFiPW1, json["WPW1"] | "", sizeof(confDevWiFi.WiFiPW1));
#endif

      strlcpy(confDevWiFi.WiFiSSID2, json["SSID2"] | "", sizeof(confDevWiFi.WiFiSSID2));

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      if (confEncryptionEnabled)
      {
        strlcpy(tmp, json["WPW2"] | "", sizeof(tmp));
        strlcpy(confDevWiFi.WiFiPW2, XORENC(tmp, encKey), sizeof(confDevWiFi.WiFiPW2));
      }
      else
        strlcpy(confDevWiFi.WiFiPW2, json["WPW2"] | "", sizeof(confDevWiFi.WiFiPW2));
#else
      strlcpy(confDevWiFi.WiFiPW2, json["WPW2"] | "", sizeof(confDevWiFi.WiFiPW2));
#endif

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      if (confEncryptionEnabled)
      {
        strlcpy(tmp, json["WPWAP"] | "", sizeof(tmp));
        strlcpy(confDevWiFi.WiFiAPModePassword, XORENC(tmp, encKey), sizeof(confDevWiFi.WiFiAPModePassword));
      }
      else
        strlcpy(confDevWiFi.WiFiAPModePassword, json["WPWAP"] | "", sizeof(confDevWiFi.WiFiAPModePassword));
#else
      strlcpy(confDevWiFi.WiFiAPModePassword, json["WPWAP"] | "", sizeof(confDevWiFi.WiFiAPModePassword));
#endif

      confDevWiFi.WiFiAPModeTimeout = json["WAPtout"] | DEFAULT_WIFI_APMODE_TIMEOUT;
      confDevWiFi.WiFiRetryInterval = json["Wretry"] | DEFAULT_WIFI_RETRY_INTERVAL;
      confDevWiFi.WiFiConnCheckInterval = json["WConnCheck"] | DEFAULT_WIFI_CONNCHECK_INTERVAL;
      confDevWiFi.WiFiRebootOnNoConnect = json["Wreboot"] | DEFAULT_WIFI_REBOOT_ONNOCONNECT;

      Serial.println(F("Loaded config values."));

      return true;
    }
    configFile.close();
  }
  else
  {
    Serial.print(F("NOTE: could not load confDevWiFi - file '"));
    Serial.print(configFileName);
    Serial.println(F("' does not exist."));
    return false;
  }
}

boolean loadConfigWeb()
{
  char configFileName[] = "/confWeb.json";
  if (SPIFFS.exists(configFileName))
  {
    File configFile = SPIFFS.open(configFileName, "r");
    if (!configFile)
    {
      Serial.print(F("ERR: Failed to open file '"));
      Serial.print(configFileName);
      Serial.println("'");
      return false;
    }
    else
    {
      Serial.print("file '");
      Serial.print(configFileName);
      Serial.print("' opened. ");
      size_t size = configFile.size();
      Serial.print("size=");
      Serial.println(size);

      if (size > 1000)
      {
        Serial.println(F("Config file size is too large"));
        return false;
      }

      std::unique_ptr<char[]> buf(new char[size]);
#ifdef DEBUGMODE
      Serial.println(F("file content:"));
      while (configFile.available())
      {
        Serial.write(configFile.read());
      }
      Serial.println();
      configFile.seek(0, SeekSet);
#endif
      configFile.readBytes(buf.get(), size);

      DynamicJsonDocument json(size + 50);
      DeserializationError error = deserializeJson(json, buf.get());
      if (error)
      {
        Serial.println(F("Failed to parse config file"));
        return false;
      }
#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      char tmp[101];
#endif

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      if (confEncryptionEnabled)
      {
        strlcpy(tmp, json["apiToken"] | "", sizeof(tmp));
        strlcpy(confWeb.http_token, XORENC(tmp, encKey), sizeof(confWeb.http_token));
      }
      else
        strlcpy(confWeb.http_token, json["apiToken"] | "", sizeof(confWeb.http_token));
#else
      strlcpy(confWeb.http_token, json["apiToken"] | "", sizeof(confWeb.http_token));
#endif

      strlcpy(confWeb.http_user, json["httpUA"] | "", sizeof(confWeb.http_user));

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      if (confEncryptionEnabled)
      {
        strlcpy(tmp, json["httpPA"] | "", sizeof(tmp));
        strlcpy(confWeb.http_pass, XORENC(tmp, encKey), sizeof(confWeb.http_pass));
      }
      else
        strlcpy(confWeb.http_pass, json["httpPA"] | "", sizeof(confWeb.http_pass));
#else
      strlcpy(confWeb.http_pass, json["httpPA"] | "", sizeof(confWeb.http_pass));
#endif

      if ((json["httpAuth"] | 0) == 1)
        confWeb.http_user_auth = true;
      else
        confWeb.http_user_auth = false;

      strlcpy(confWeb.http_user1, json["httpU1"] | "", sizeof(confWeb.http_user1));

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      if (confEncryptionEnabled)
      {
        strlcpy(tmp, json["httpP1"] | "", sizeof(tmp));
        strlcpy(confWeb.http_pass1, XORENC(tmp, encKey), sizeof(confWeb.http_pass1));
      }
      else
        strlcpy(confWeb.http_pass1, json["httpP1"] | "", sizeof(confWeb.http_pass1));
#else
      strlcpy(confWeb.http_pass1, json["httpP1"] | "", sizeof(confWeb.http_pass1));
#endif

      strlcpy(confWeb.http_user2, json["httpU2"] | "", sizeof(confWeb.http_user2));

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      if (confEncryptionEnabled)
      {
        strlcpy(tmp, json["httpP2"] | "", sizeof(tmp));
        strlcpy(confWeb.http_pass2, XORENC(tmp, encKey), sizeof(confWeb.http_pass2));
      }
      else
        strlcpy(confWeb.http_pass2, json["httpP2"] | "", sizeof(confWeb.http_pass2));
#else
      strlcpy(confWeb.http_pass2, json["httpP2"] | "", sizeof(confWeb.http_pass2));
#endif

      if ((json["wConsole"] | 0) == 1)
        confWeb.wConsole = true;
      else
        confWeb.wConsole = false;

      if ((json["wsConsole"] | 0) == 1)
        confWeb.wsConsole = true;
      else
        confWeb.wsConsole = false;

      Serial.println(F("Loaded config values."));

      return true;
    }
    configFile.close();
  }
  else
  {
    Serial.print(F("NOTE: could not load confWeb - file '"));
    Serial.print(configFileName);
    Serial.println(F("' does not exist."));
    return false;
  }
}

boolean loadConfigMqtt()
{
  char configFileName[] = "/confMqtt.json";
  if (SPIFFS.exists(configFileName))
  {
    File configFile = SPIFFS.open(configFileName, "r");
    if (!configFile)
    {
      Serial.print(F("ERR: Failed to open file '"));
      Serial.print(configFileName);
      Serial.println("'");
      return false;
    }
    else
    {
      Serial.print("file '");
      Serial.print(configFileName);
      Serial.print("' opened. ");
      size_t size = configFile.size();
      Serial.print("size=");
      Serial.println(size);

      if (size > 1000)
      {
        Serial.println(F("Config file size is too large"));
        return false;
      }

      std::unique_ptr<char[]> buf(new char[size]);
#ifdef DEBUGMODE
      Serial.println(F("file content:"));
      while (configFile.available())
      {
        Serial.write(configFile.read());
      }
      Serial.println();
      configFile.seek(0, SeekSet);
#endif
      configFile.readBytes(buf.get(), size);

      DynamicJsonDocument json(size + 50);
      DeserializationError error = deserializeJson(json, buf.get());
      if (error)
      {
        Serial.println(F("Failed to parse config file"));
        return false;
      }

      if ((json["mqttEnable"] | 0) == 1)
        confMqtt.mqtt_enable = true;
      else
        confMqtt.mqtt_enable = false;

      strlcpy(confMqtt.mqtt_server, json["mqttHost"] | "", sizeof(confMqtt.mqtt_server));
      confMqtt.mqtt_port = json["mqttPort"] | 1883;
      strlcpy(confMqtt.mqtt_user, json["mqttUser"] | "", sizeof(confMqtt.mqtt_user));

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      char tmp[101];
#endif

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
      if (confEncryptionEnabled)
      {
        strlcpy(tmp, json["mqttPass"] | "", sizeof(tmp));
        strlcpy(confMqtt.mqtt_pass, XORENC(tmp, encKey), sizeof(confMqtt.mqtt_pass));
      }
      else
        strlcpy(confMqtt.mqtt_pass, json["mqttPass"] | "", sizeof(confMqtt.mqtt_pass));
#else
      strlcpy(confMqtt.mqtt_pass, json["mqttPass"] | "", sizeof(confMqtt.mqtt_pass));
#endif

      strlcpy(confMqtt.mqtt_topic_in, json["inTop"] | "", sizeof(confMqtt.mqtt_topic_in));
      strlcpy(confMqtt.mqtt_topic_out, json["outTop"] | "", sizeof(confMqtt.mqtt_topic_out));

      if ((json["outRet"] | 0) == 1)
        confMqtt.mqtt_outRetain = true;
      else
        confMqtt.mqtt_outRetain = false;

      if ((json["outRetSens"] | 0) == 1)
        confMqtt.mqtt_outRetain_sensors = true;
      else
        confMqtt.mqtt_outRetain_sensors = false;

      confMqtt.mqtt_outPubInterval = json["outPubInt"] | MQTT_OUT_PUBLISH_INTERVAL;
      confMqtt.mqtt_outPubInterval_sensors = json["outPubIntSens"] | MQTT_OUT_PUBLISH_INTERVAL_SENSORS;

      strlcpy(confMqtt.mqtt_willTopic, json["willTop"] | "", sizeof(confMqtt.mqtt_willTopic));

      confMqtt.mqtt_willQos = json["willQos"] | 0;

      if ((json["willRet"] | 0) == 1)
        confMqtt.mqtt_willRetain = true;
      else
        confMqtt.mqtt_willRetain = false;

      strlcpy(confMqtt.mqtt_willMsg, json["willMsg"] | "", sizeof(confMqtt.mqtt_willMsg));
      strlcpy(confMqtt.mqtt_connMsg, json["connMsg"] | "", sizeof(confMqtt.mqtt_connMsg));

      if ((json["hbEnable"] | 0) == 1)
        confMqtt.mqtt_enable_heartbeat = true;
      else
        confMqtt.mqtt_enable_heartbeat = false;

      uint16_t tmpval;
      tmpval = json["hbReconn"] | 0;
      if (tmpval == 0)
        confMqtt.mqtt_heartbeat_maxage_reconnect = 0;
      else if (tmpval >= 2 && tmpval <= 10)
        confMqtt.mqtt_heartbeat_maxage_reconnect = tmpval * 60000;

      tmpval = json["hbReboot"] | 0;
      if (tmpval == 0)
        confMqtt.mqtt_heartbeat_maxage_reboot = 0;
      else if (tmpval >= 2 && tmpval <= 10)
        confMqtt.mqtt_heartbeat_maxage_reboot = tmpval * 60000;

      Serial.println(F("Loaded config values."));

      return true;
    }
    configFile.close();
  }
  else
  {
    Serial.print(F("NOTE: could not load confMqtt - file '"));
    Serial.print(configFileName);
    Serial.println(F("' does not exist."));
    return false;
  }
}

boolean loadConfigBas()
{
  char configFileName[] = "/confBas.json";
  if (SPIFFS.exists(configFileName))
  {
    File configFile = SPIFFS.open(configFileName, "r");
    if (!configFile)
    {
      Serial.print(F("ERR: Failed to open file '"));
      Serial.print(configFileName);
      Serial.println("'");
      return false;
    }
    else
    {
      Serial.print("file '");
      Serial.print(configFileName);
      Serial.print("' opened. ");
      size_t size = configFile.size();
      Serial.print("size=");
      Serial.println(size);

      if (size > 1000)
      {
        Serial.println(F("Config file size is too large"));
        return false;
      }

      std::unique_ptr<char[]> buf(new char[size]);
#ifdef DEBUGMODE
      Serial.println(F("file content:"));
      while (configFile.available())
      {
        Serial.write(configFile.read());
      }
      Serial.println();
      configFile.seek(0, SeekSet);
#endif
      configFile.readBytes(buf.get(), size);

      DynamicJsonDocument json(size + 50);
      DeserializationError error = deserializeJson(json, buf.get());
      if (error)
      {
        Serial.println(F("Failed to parse config file"));
        return false;
      }

      if ((json["autoSaveTemp"] | 0) == 1)
        confBas.autoSaveSetTemp = true;
      else
        confBas.autoSaveSetTemp = false;

      if ((json["autoSaveMode"] | 0) == 1)
        confBas.autoSaveHeatingMode = true;
      else
        confBas.autoSaveHeatingMode = false;

      if ((json["saveToMqttRet"] | 0) == 1)
        confBas.saveToMqttRetained = true;
      else
        confBas.saveToMqttRetained = false;

      if ((json["PIRenDisp"] | 0) == 1)
        confBas.PIR_enablesDisplay = true;
      else
        confBas.PIR_enablesDisplay = false;

      if ((json["PIRenDispPs0"] | 0) == 1)
        confBas.PIR_enablesDisplay_preset0only = true;
      else
        confBas.PIR_enablesDisplay_preset0only = false;

      if ((json["togTHdisp"] | 0) == 1)
        confBas.togglingTempHumAIDisplay = true;
      else
        confBas.togglingTempHumAIDisplay = false;

      confBas.setTempMin = json["tempMin"] | DEFAULT_SETTEMP_MIN;
      confBas.setTempMax = json["tempMax"] | DEFAULT_SETTEMP_MAX;
      confBas.measureInterval = json["measInt"] | DEFAULT_MEASURE_INTERVAL;
      confBas.displayInterval = json["dispInt"] | DEFAULT_DISPLAY_INTERVAL;
      confBas.displayTimeout = json["dispTout"] | DEFAULT_DISPLAY_TIMEOUT;



      return true;
    }
    configFile.close();
  }
  else
  {
    Serial.print(F("NOTE: could not load confBas - file '"));
    Serial.print(configFileName);
    Serial.println(F("' does not exist."));
    return false;
  }
}

boolean loadConfigAdv()
{
  char configFileName[] = "/confAdv.json";
  if (SPIFFS.exists(configFileName))
  {
    File configFile = SPIFFS.open(configFileName, "r");
    if (!configFile)
    {
      Serial.print(F("ERR: Failed to open file '"));
      Serial.print(configFileName);
      Serial.println("'");
      return false;
    }
    else
    {
      Serial.print("file '");
      Serial.print(configFileName);
      Serial.print("' opened. ");
      size_t size = configFile.size();
      Serial.print("size=");
      Serial.println(size);

      if (size > 1000)
      {
        Serial.println(F("Config file size is too large"));
        return false;
      }

      std::unique_ptr<char[]> buf(new char[size]);
#ifdef DEBUGMODE
      Serial.println(F("file content:"));
      while (configFile.available())
      {
        Serial.write(configFile.read());
      }
      Serial.println();
      configFile.seek(0, SeekSet);
#endif
      configFile.readBytes(buf.get(), size);

      DynamicJsonDocument json(size + 50);
      DeserializationError error = deserializeJson(json, buf.get());
      if (error)
      {
        Serial.println(F("Failed to parse config file"));
        return false;
      }

      confAdv.hysteresis = json["hyst"] | 0.2;
      confAdv.heatingMinOffTime = json["minOffTime"] | 600;
      confAdv.tempCorrVal = json["tempCorr"] | 0.0;
      confAdv.humCorrVal = json["humCorr"] | 0;
      confAdv.setTempDecreaseVal = json["tempDec"] | 0.0;

      strlcpy(confAdv.offMessage, json["offMsg"] | "", sizeof(confAdv.offMessage));

      strlcpy(confAdv.iTempLabel, json["iTempLab"] | "", sizeof(confAdv.iTempLabel));
      strlcpy(confAdv.oTempLabel, json["oTempLab"] | "", sizeof(confAdv.oTempLabel));

      strlcpy(confAdv.modeName0, json["modeName0"] | "", sizeof(confAdv.modeName0));
      strlcpy(confAdv.modeName1, json["modeName1"] | "", sizeof(confAdv.modeName1));
      strlcpy(confAdv.psetName0, json["psetName0"] | "", sizeof(confAdv.psetName0));
      strlcpy(confAdv.psetName1, json["psetName1"] | "", sizeof(confAdv.psetName1));
      strlcpy(confAdv.psetName2, json["psetName2"] | "", sizeof(confAdv.psetName2));
      confAdv.pauseTout = json["pauseTout"] | 1800;



      return true;
    }
    configFile.close();
  }
  else
  {
    Serial.print(F("NOTE: could not load confAdv - file '"));
    Serial.print(configFileName);
    Serial.println(F("' does not exist."));
    return false;
  }
}

boolean loadConfigAdd()
{
  char configFileName[] = "/confAdd.json";
  if (SPIFFS.exists(configFileName))
  {
    File configFile = SPIFFS.open(configFileName, "r");
    if (!configFile)
    {
      Serial.print(F("ERR: Failed to open file '"));
      Serial.print(configFileName);
      Serial.println("'");
      return false;
    }
    else
    {
      Serial.print("file '");
      Serial.print(configFileName);
      Serial.print("' opened. ");
      size_t size = configFile.size();
      Serial.print("size=");
      Serial.println(size);

      if (size > 1000)
      {
        Serial.println(F("Config file size is too large"));
        return false;
      }

      std::unique_ptr<char[]> buf(new char[size]);
#ifdef DEBUGMODE
      Serial.println(F("file content:"));
      while (configFile.available())
      {
        Serial.write(configFile.read());
      }
      Serial.println();
      configFile.seek(0, SeekSet);
#endif
      configFile.readBytes(buf.get(), size);

      DynamicJsonDocument json(size + 50);
      DeserializationError error = deserializeJson(json, buf.get());
      if (error)
      {
        Serial.println(F("Failed to parse config file"));
        return false;
      }

      strlcpy(confAdd.mqtt_topic_pir, json["PIRTop"] | "", sizeof(confAdd.mqtt_topic_pir));
      strlcpy(confAdd.mqtt_payload_pir_on, json["PIROnPld"] | "", sizeof(confAdd.mqtt_payload_pir_on));
      strlcpy(confAdd.mqtt_payload_pir_off, json["PIROffPld"] | "", sizeof(confAdd.mqtt_payload_pir_off));
      strlcpy(confAdd.outTemp_topic_in, json["outTempTop"] | "", sizeof(confAdd.outTemp_topic_in));
      strlcpy(confAdd.outHum_topic_in, json["outHumTop"] | "", sizeof(confAdd.outHum_topic_in));



      return true;
    }
    configFile.close();
  }
  else
  {
    Serial.print(F("NOTE: could not load confAdd - file '"));
    Serial.print(configFileName);
    Serial.println(F("' does not exist."));
    return false;
  }
}

#ifdef ENABLE_FEATURE_NTP_TIME
boolean loadConfigTime()
{
  char configFileName[] = "/confTime.json";
  if (SPIFFS.exists(configFileName))
  {
    File configFile = SPIFFS.open(configFileName, "r");
    if (!configFile)
    {
      Serial.print(F("ERR: Failed to open file '"));
      Serial.print(configFileName);
      Serial.println("'");
      return false;
    }
    else
    {
      Serial.print("file '");
      Serial.print(configFileName);
      Serial.print("' opened. ");
      size_t size = configFile.size();
      Serial.print("size=");
      Serial.println(size);

      if (size > 1000)
      {
        Serial.println(F("Config file size is too large"));
        return false;
      }

      std::unique_ptr<char[]> buf(new char[size]);
#ifdef DEBUGMODE
      Serial.println(F("file content:"));
      while (configFile.available())
      {
        Serial.write(configFile.read());
      }
      Serial.println();
      configFile.seek(0, SeekSet);
#endif
      configFile.readBytes(buf.get(), size);

      DynamicJsonDocument json(size + 50);
      DeserializationError error = deserializeJson(json, buf.get());
      if (error)
      {
        Serial.println(F("Failed to parse config file"));
        return false;
      }

      if ((json["NTPEnable"] | 0) == 1)
        confTime.ntpEnable = true;
      else
        confTime.ntpEnable = false;

      strlcpy(confTime.ntpServer1, json["NTPServer1"] | "", sizeof(confTime.ntpServer1));
      strlcpy(confTime.ntpServer2, json["NTPServer2"] | "", sizeof(confTime.ntpServer2));
      unsigned int ntpSyncInterval = json["NTPSyncInt"];
      confTime.ntpSyncInterval = ntpSyncInterval * 60;
      strlcpy(confTime.timeZoneStr, json["TZstr"] | "", sizeof(confTime.timeZoneStr));



      return true;
    }
    configFile.close();
  }
  else
  {
    Serial.print(F("NOTE: could not load confTime - file '"));
    Serial.print(configFileName);
    Serial.println(F("' does not exist."));
    return false;
  }
}
#endif

boolean loadConfigLog()
{
  char configFileName[] = "/confLog.json";
  if (SPIFFS.exists(configFileName))
  {
    File configFile = SPIFFS.open(configFileName, "r");
    if (!configFile)
    {
      Serial.print(F("ERR: Failed to open file '"));
      Serial.print(configFileName);
      Serial.println("'");
      return false;
    }
    else
    {
      Serial.print("file '");
      Serial.print(configFileName);
      Serial.print("' opened. ");
      size_t size = configFile.size();
      Serial.print("size=");
      Serial.println(size);

      if (size > 1000)
      {
        Serial.println(F("Config file size is too large"));
        return false;
      }

      std::unique_ptr<char[]> buf(new char[size]);
#ifdef DEBUGMODE
      Serial.println(F("file content:"));
      while (configFile.available())
      {
        Serial.write(configFile.read());
      }
      Serial.println();
      configFile.seek(0, SeekSet);
#endif
      configFile.readBytes(buf.get(), size);

      DynamicJsonDocument json(size + 50);
      DeserializationError error = deserializeJson(json, buf.get());
      if (error)
      {
        Serial.println(F("Failed to parse config file"));
        return false;
      }






      confLog.logLevelSerial = json["logLevSer"];
      confLog.logLevelWeb = json["logLevWeb"];
      confLog.logLevelMqtt = json["logLevMqtt"];

      if ((json["logWebRequests"] | 0) == 1)
        confLog.logWebRequests = true;
      else
        confLog.logWebRequests = false;



      return true;
    }
    configFile.close();
  }
  else
  {
    Serial.print(F("NOTE: could not load confTime - file '"));
    Serial.print(configFileName);
    Serial.println(F("' does not exist."));
    return false;
  }
}

boolean loadSetTemp()
{
  File configFile = SPIFFS.open("/setTemp", "r");
  if (!configFile)
  {
    Serial.println(F("NOTE: Failed to open file /setTemp"));
    return false;
  }
  String s = configFile.readStringUntil('\n');
  configFile.close();
  float tmpSetTemp = s.toFloat();
  if (tmpSetTemp >= confBas.setTempMin && tmpSetTemp <= confBas.setTempMax)
  {
    setTemp = tmpSetTemp;
    setTempSaved = tmpSetTemp;
    return true;
  }
  else
    return false;
}

boolean loadSetTempLow()
{
  File configFile = SPIFFS.open("/setTempLow", "r");
  if (!configFile)
  {
    Serial.println(F("NOTE: Failed to open file /setTempLow"));
    return false;
  }
  String s = configFile.readStringUntil('\n');
  configFile.close();
  float tmpSetTempLow = s.toFloat();
  if (tmpSetTempLow >= setTempLowMin && tmpSetTempLow <= setTempLowMax)
  {
    setTempLow = tmpSetTempLow;
    setTempLowSaved = tmpSetTempLow;
    return true;
  }
  else
    return false;
}

boolean loadSetTempLow2()
{
  File configFile = SPIFFS.open("/setTempLow2", "r");
  if (!configFile)
  {
    Serial.println(F("NOTE: Failed to open file /setTempLow2"));
    return false;
  }
  String s = configFile.readStringUntil('\n');
  configFile.close();
  float tmpSetTempLow2 = s.toFloat();
  if (tmpSetTempLow2 >= setTempLowMin && tmpSetTempLow2 <= setTempLowMax)
  {
    setTempLow2 = tmpSetTempLow2;
    setTempLow2Saved = tmpSetTempLow2;
    return true;
  }
  else
    return false;
}

boolean loadHeatingMode()
{
  File configFile = SPIFFS.open("/heatingMode", "r");
  if (!configFile)
  {
    Serial.println(F("NOTE: Failed to open file /heatingMode"));
    return false;
  }
  String s = configFile.readStringUntil('\n');
  configFile.close();
  int tmpHeatingMode = s.toInt();
  if (tmpHeatingMode >= 0 && tmpHeatingMode <= 1)
  {
    heatingMode = tmpHeatingMode;
    heatingModeSaved = tmpHeatingMode;
    return true;
  }
  else
    return false;
}

boolean loadPreset()
{
  File configFile = SPIFFS.open("/preset", "r");
  if (!configFile)
  {
    Serial.println(F("NOTE: Failed to open file /preset"));
    return false;
  }
  String s = configFile.readStringUntil('\n');
  configFile.close();
  int tmpPreset = s.toInt();
  if (tmpPreset >= 0 && tmpPreset <= 2)
  {
    preset = tmpPreset;
    presetSaved = tmpPreset;
    return true;
  }
  else
    return false;
}

boolean saveConfigWeb()
{
  if (confWeb.wasChanged)
  {
    char configFileName[] = "/confWeb.json";
    DynamicJsonDocument json(1050);

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
    if (confEncryptionEnabled)
      json["apiToken"] = XORENC(confWeb.http_token, encKey);
    else
      json["apiToken"] = confWeb.http_token;
#else
    json["apiToken"] = confWeb.http_token;
#endif

    json["httpUA"] = confWeb.http_user;

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
    if (confEncryptionEnabled)
      json["httpPA"] = XORENC(confWeb.http_pass, encKey);
    else
      json["httpPA"] = confWeb.http_pass;
#else
    json["httpPA"] = confWeb.http_pass;
#endif

    if (confWeb.http_user_auth)
      json["httpAuth"] = 1;
    else
      json["httpAuth"] = 0;

    json["httpU1"] = confWeb.http_user1;

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
    if (confEncryptionEnabled)
      json["httpP1"] = XORENC(confWeb.http_pass1, encKey);
    else
      json["httpP1"] = confWeb.http_pass1;
#else
    json["httpP1"] = confWeb.http_pass1;
#endif

    json["httpU2"] = confWeb.http_user2;

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
    if (confEncryptionEnabled)
      json["httpP2"] = XORENC(confWeb.http_pass2, encKey);
    else
      json["httpP2"] = confWeb.http_pass2;
#else
    json["httpP2"] = confWeb.http_pass2;
#endif

    if (confWeb.wConsole)
      json["wConsole"] = 1;
    else
      json["wConsole"] = 0;

    if (confWeb.wsConsole)
      json["wsConsole"] = 1;
    else
      json["wsConsole"] = 0;

    yield();

    File configFile = SPIFFS.open(configFileName, "w");
    if (!configFile)
    {
      Serial.print("Failed to open file '");
      Serial.print(configFileName);
      Serial.println("' for writing");
      return false;
    }
    serializeJson(json, configFile);
    confWeb.wasChanged = false;
    return true;
  }
  else
    return false;
}

boolean saveConfigMqtt()
{
  if (confMqtt.wasChanged)
  {
    char configFileName[] = "/confMqtt.json";
    DynamicJsonDocument json(1050);

    if (confMqtt.mqtt_enable)
      json["mqttEnable"] = 1;
    else
      json["mqttEnable"] = 0;

    json["mqttHost"] = confMqtt.mqtt_server;
    json["mqttPort"] = confMqtt.mqtt_port;
    json["mqttUser"] = confMqtt.mqtt_user;

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
    if (confEncryptionEnabled)
      json["mqttPass"] = XORENC(confMqtt.mqtt_pass, encKey);
    else
      json["mqttPass"] = confMqtt.mqtt_pass;
#else
    json["mqttPass"] = confMqtt.mqtt_pass;
#endif

    json["inTop"] = confMqtt.mqtt_topic_in;
    json["outTop"] = confMqtt.mqtt_topic_out;

    if (confMqtt.mqtt_outRetain)
      json["outRet"] = 1;
    else
      json["outRet"] = 0;

    if (confMqtt.mqtt_outRetain_sensors)
      json["outRetSens"] = 1;
    else
      json["outRetSens"] = 0;

    json["outPubInt"] = confMqtt.mqtt_outPubInterval;
    json["outPubIntSens"] = confMqtt.mqtt_outPubInterval_sensors;

    json["willTop"] = confMqtt.mqtt_willTopic;
    json["willQos"] = confMqtt.mqtt_willQos;

    if (confMqtt.mqtt_willRetain)
      json["willRet"] = 1;
    else
      json["willRet"] = 0;

    json["willMsg"] = confMqtt.mqtt_willMsg;
    json["connMsg"] = confMqtt.mqtt_connMsg;

    if (confMqtt.mqtt_enable_heartbeat)
      json["hbEnable"] = 1;
    else
      json["hbEnable"] = 0;

    json["hbReconn"] = confMqtt.mqtt_heartbeat_maxage_reconnect / 60000;
    json["hbReboot"] = confMqtt.mqtt_heartbeat_maxage_reboot / 60000;

    yield();

    File configFile = SPIFFS.open(configFileName, "w");
    if (!configFile)
    {
      Serial.print("Failed to open file '");
      Serial.print(configFileName);
      Serial.println("' for writing");
      return false;
    }
    serializeJson(json, configFile);
    confMqtt.wasChanged = false;
    return true;
  }
  else
    return false;
}

boolean saveConfigDevWiFi()
{
  if (confDevWiFi.wasChanged)
  {
    char configFileName[] = "/confDevWiFi.json";
    DynamicJsonDocument json(1050);

    json["devName"] = confDevWiFi.deviceName;
    json["hostName"] = confDevWiFi.hostName;
    json["SSID1"] = confDevWiFi.WiFiSSID1;

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
    if (confEncryptionEnabled)
      json["WPW1"] = XORENC(confDevWiFi.WiFiPW1, encKey);
    else
      json["WPW1"] = confDevWiFi.WiFiPW1;
#else
    json["WPW1"] = confDevWiFi.WiFiPW1;
#endif

    json["SSID2"] = confDevWiFi.WiFiSSID2;

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
    if (confEncryptionEnabled)
      json["WPW2"] = XORENC(confDevWiFi.WiFiPW2, encKey);
    else
      json["WPW2"] = confDevWiFi.WiFiPW2;
#else
    json["WPW2"] = confDevWiFi.WiFiPW2;
#endif

#ifdef ENABLE_FEATURE_PW_ENCRYPTION
    if (confEncryptionEnabled)
      json["WPWAP"] = XORENC(confDevWiFi.WiFiAPModePassword, encKey);
    else
      json["WPWAP"] = confDevWiFi.WiFiAPModePassword;
#else
    json["WPWAP"] = confDevWiFi.WiFiAPModePassword;
#endif

    json["WAPtout"] = confDevWiFi.WiFiAPModeTimeout;
    json["WConnCheck"] = confDevWiFi.WiFiConnCheckInterval;
    json["Wretry"] = confDevWiFi.WiFiRetryInterval;
    json["Wreboot"] = confDevWiFi.WiFiRebootOnNoConnect;

    yield();

    File configFile = SPIFFS.open(configFileName, "w");
    if (!configFile)
    {
      Serial.print("Failed to open file '");
      Serial.print(configFileName);
      Serial.println("' for writing");
      return false;
    }
    serializeJson(json, configFile);
    confDevWiFi.wasChanged = false;
    return true;
  }
  else
    return false;
}

boolean saveConfigBas()
{
  if (confBas.wasChanged)
  {
    char configFileName[] = "/confBas.json";
    DynamicJsonDocument json(1050);

    if (confBas.autoSaveSetTemp)
      json["autoSaveTemp"] = 1;
    else
      json["autoSaveTemp"] = 0;

    if (confBas.autoSaveHeatingMode)
      json["autoSaveMode"] = 1;
    else
      json["autoSaveMode"] = 0;

    if (confBas.saveToMqttRetained)
      json["saveToMqttRet"] = 1;
    else
      json["saveToMqttRet"] = 0;

    json["tempMin"] = confBas.setTempMin;
    json["tempMax"] = confBas.setTempMax;
    json["measInt"] = confBas.measureInterval;
    json["dispInt"] = confBas.displayInterval;
    json["dispTout"] = confBas.displayTimeout;

    if (confBas.PIR_enablesDisplay)
      json["PIRenDisp"] = 1;
    else
      json["PIRenDisp"] = 0;

    if (confBas.PIR_enablesDisplay_preset0only)
      json["PIRenDispPs0"] = 1;
    else
      json["PIRenDispPs0"] = 0;

    if (confBas.togglingTempHumAIDisplay)
      json["togTHdisp"] = 1;
    else
      json["togTHdisp"] = 0;

    yield();

    File configFile = SPIFFS.open(configFileName, "w");
    if (!configFile)
    {
      Serial.print("Failed to open file '");
      Serial.print(configFileName);
      Serial.println("' for writing");
      return false;
    }
    serializeJson(json, configFile);
    confBas.wasChanged = false;
    return true;
  }
  else
    return false;
}

boolean saveConfigAdv()
{
  if (confAdv.wasChanged)
  {
    char configFileName[] = "/confAdv.json";
    DynamicJsonDocument json(1050);

    json["hyst"] = confAdv.hysteresis;
    json["minOffTime"] = confAdv.heatingMinOffTime;
    json["tempCorr"] = confAdv.tempCorrVal;
    json["humCorr"] = confAdv.humCorrVal;
    json["tempDec"] = confAdv.setTempDecreaseVal;
    json["offMsg"] = confAdv.offMessage;
    json["iTempLab"] = confAdv.iTempLabel;
    json["oTempLab"] = confAdv.oTempLabel;
    json["modeName0"] = confAdv.modeName0;
    json["modeName1"] = confAdv.modeName1;
    json["psetName0"] = confAdv.psetName0;
    json["psetName1"] = confAdv.psetName1;
    json["psetName2"] = confAdv.psetName2;
    json["pauseTout"] = confAdv.pauseTout;

    yield();

    File configFile = SPIFFS.open(configFileName, "w");
    if (!configFile)
    {
      Serial.print("Failed to open file '");
      Serial.print(configFileName);
      Serial.println("' for writing");
      return false;
    }
    serializeJson(json, configFile);
    confAdv.wasChanged = false;
    return true;
  }
  else
    return false;
}

boolean saveConfigAdd()
{
  if (confAdd.wasChanged)
  {
    char configFileName[] = "/confAdd.json";
    DynamicJsonDocument json(1050);

    json["PIRTop"] = confAdd.mqtt_topic_pir;
    json["PIROnPld"] = confAdd.mqtt_payload_pir_on;
    json["PIROffPld"] = confAdd.mqtt_payload_pir_off;
    json["outTempTop"] = confAdd.outTemp_topic_in;
    json["outHumTop"] = confAdd.outHum_topic_in;

    yield();

    File configFile = SPIFFS.open(configFileName, "w");
    if (!configFile)
    {
      Serial.print("Failed to open file '");
      Serial.print(configFileName);
      Serial.println("' for writing");
      return false;
    }
    serializeJson(json, configFile);
    confAdd.wasChanged = false;
    return true;
  }
  else
    return false;
}

#ifdef ENABLE_FEATURE_NTP_TIME
boolean saveConfigTime()
{
  if (confTime.wasChanged)
  {
    char configFileName[] = "/confTime.json";
    DynamicJsonDocument json(1050);

    if (confTime.ntpEnable)
      json["NTPEnable"] = 1;
    else
      json["NTPEnable"] = 0;

    json["NTPServer1"] = confTime.ntpServer1;
    json["NTPServer2"] = confTime.ntpServer2;
    json["NTPSyncInt"] = confTime.ntpSyncInterval / 60;
    json["TZstr"] = confTime.timeZoneStr;

    yield();

    File configFile = SPIFFS.open(configFileName, "w");
    if (!configFile)
    {
      Serial.print("Failed to open file '");
      Serial.print(configFileName);
      Serial.println("' for writing");
      return false;
    }
    serializeJson(json, configFile);
    confTime.wasChanged = false;
    return true;
  }
  else
    return false;
}
#endif

boolean saveConfigLog()
{
  if (confLog.wasChanged)
  {
    char configFileName[] = "/confLog.json";
    DynamicJsonDocument json(1050);




    json["logLevSer"] = confLog.logLevelSerial;
    json["logLevWeb"] = confLog.logLevelWeb;
    json["logLevMqtt"] = confLog.logLevelMqtt;

    if (confLog.logWebRequests)
      json["logWebRequests"] = 1;
    else
      json["logWebRequests"] = 0;

    yield();

    File configFile = SPIFFS.open(configFileName, "w");
    if (!configFile)
    {
      Serial.print("Failed to open file '");
      Serial.print(configFileName);
      Serial.println("' for writing");
      return false;
    }
    serializeJson(json, configFile);
    confLog.wasChanged = false;
    return true;
  }
  else
    return false;
}

boolean saveSetTemp()
{
  File configFile = SPIFFS.open("/setTemp", "w");
  if (!configFile)
  {
    sendLog(F("Failed to write file /setTemp"), LOGLEVEL_ERROR);
    return false;
  }
  configFile.println(setTemp);
  configFile.close();
  setTempSaved = setTemp;
  return true;
}

boolean saveSetTempLow()
{
  File configFile = SPIFFS.open("/setTempLow", "w");
  if (!configFile)
  {
    sendLog(F("Failed to write file /setTempLow"), LOGLEVEL_ERROR);
    return false;
  }
  configFile.println(setTempLow);
  configFile.close();
  setTempLowSaved = setTempLow;
  return true;
}

boolean saveSetTempLow2()
{
  File configFile = SPIFFS.open("/setTempLow2", "w");
  if (!configFile)
  {
    sendLog(F("Failed to write file setTempLow2"), LOGLEVEL_ERROR);
    return false;
  }
  configFile.println(setTempLow2);
  configFile.close();
  setTempLow2Saved = setTempLow2;
  return true;
}

boolean saveHeatingMode()
{
  File configFile = SPIFFS.open("/heatingMode", "w");
  if (!configFile)
  {
    sendLog(F("Failed to write file /heatingMode"), LOGLEVEL_ERROR);
    return false;
  }
  configFile.println(heatingMode);
  configFile.close();
  heatingModeSaved = heatingMode;
  return true;
}

boolean savePreset()
{
  File configFile = SPIFFS.open("/preset", "w");
  if (!configFile)
  {
    sendLog(F("Failed to write file /preset"), LOGLEVEL_ERROR);
    return false;
  }
  configFile.println(preset);
  configFile.close();
  presetSaved = preset;
  return true;
}

void deleteConfig()
{
  sendLog(F("deleting configuration..."));
  SPIFFS_format();
  delay(100);
  ESP.restart();
}

void loadConf_all()
{
  sendLog("CONF: loading configurations...");
  loadConfigDevWiFi();
  loadConfigWeb();
  loadConfigMqtt();
  loadConfigBas();
  loadConfigAdv();
  loadConfigAdd();
#ifdef ENABLE_FEATURE_NTP_TIME
  loadConfigTime();
#endif
  loadConfigLog();
  sendLog("CONF: done.");
}

void saveConfig_all()
{
  if(confCheckUnsaved()) {
  sendLog(F("CONF: saving..."));
  saveConfigDevWiFi();
  yield();
  saveConfigWeb();
  yield();
  saveConfigMqtt();
  yield();
  saveConfigBas();
  yield();
  saveConfigAdv();
  yield();
  saveConfigAdd();
  yield();
#ifdef ENABLE_FEATURE_NTP_TIME
  saveConfigTime();
  yield();
#endif
  saveConfigLog();
  yield();
  sendLog(F("CONF: saving to SPIFFS DONE"));
  }
  else sendLog(F("CONF: nothing changed."));
}

void loadSavedValues()
{
  loadSetTemp();
  loadSetTempLow();
  loadSetTempLow2();
  loadHeatingMode();
  loadPreset();
}

void saveValues()
{
  sendLog(F("saving values..."));
  saveSetTemp();
  yield();
  saveSetTempLow();
  yield();
  saveSetTempLow2();
  yield();
  saveHeatingMode();
  yield();
  sendLog(F("saved values to SPIFFS - DONE"));
}

void SPIFFS_format()
{
  sendLog(F("formatting SPIFFS, please wait 30 secs"));
  SPIFFS.format();
  sendLog(F("SPIFFS formatted"));

  File f = SPIFFS.open("/formatted", "w");
  if (!f)
  {
    sendLog(F("creating file '/formatted' failed"));
  }
  else
  {
    f.println(F("Format Complete"));
  }
  f.close();
}

void SPIFFS_formatIfIsnt()
{
  if (!SPIFFS.exists("/formatted"))
  {
    SPIFFS_format();
  }





}

void SPIFFS_listFiles()
{

  sendLog(F("ls SPIFFS:"));
  Dir dir = SPIFFS.openDir("/");
  while (dir.next())
  {

    File f = dir.openFile("r");


    char buf[101];
    sprintf(buf, "  %s    %d", dir.fileName().c_str(), f.size());
    sendLog(buf);
    f.close();
  }
  sendLog(F("--------"));

}

void loadConf_defaults()
{

  createDeviceName();



  strlcpy(confDevWiFi.hostName, confDevWiFi.deviceName, sizeof(confDevWiFi.hostName));
  strlcpy(confDevWiFi.WiFiAPModePassword, DEFAULT_WIFI_APMODE_PASSWORD, sizeof(confDevWiFi.WiFiAPModePassword));
  confDevWiFi.WiFiAPModeTimeout = DEFAULT_WIFI_APMODE_TIMEOUT;
  confDevWiFi.WiFiRetryInterval = DEFAULT_WIFI_RETRY_INTERVAL;
  confDevWiFi.WiFiConnCheckInterval = DEFAULT_WIFI_CONNCHECK_INTERVAL;
  confDevWiFi.WiFiRebootOnNoConnect = DEFAULT_WIFI_REBOOT_ONNOCONNECT;
  confDevWiFi.wasChanged = false;


  strlcpy(confWeb.http_token, HTTP_SET_TOKEN, sizeof(confWeb.http_token));
  strlcpy(confWeb.http_user, DEFAULT_HTTP_USER, sizeof(confWeb.http_user));
  strlcpy(confWeb.http_pass, DEFAULT_HTTP_PASS, sizeof(confWeb.http_pass));
  confWeb.http_user_auth = DEFAULT_HTTP_USER_AUTH;
  confWeb.wasChanged = false;


  confMqtt.mqtt_enable = MQTT_ENABLE;
  strlcpy(confMqtt.mqtt_server, MQTT_SERVER, sizeof(confMqtt.mqtt_server));
  confMqtt.mqtt_port = MQTT_PORT;
  strlcpy(confMqtt.mqtt_user, MQTT_USER, sizeof(confMqtt.mqtt_user));
  strlcpy(confMqtt.mqtt_pass, MQTT_PASS, sizeof(confMqtt.mqtt_pass));
  strlcpy(confMqtt.mqtt_topic_in, MQTT_TOPIC_IN, sizeof(confMqtt.mqtt_topic_in));
  strlcpy(confMqtt.mqtt_topic_out, MQTT_TOPIC_OUT, sizeof(confMqtt.mqtt_topic_out));
  strlcpy(confMqtt.mqtt_willTopic, MQTT_WILLTOPIC, sizeof(confMqtt.mqtt_willTopic));
  confMqtt.mqtt_willQos = MQTT_WILLQOS;
  confMqtt.mqtt_willRetain = MQTT_WILLRETAIN;
  strlcpy(confMqtt.mqtt_willMsg, MQTT_WILLMSG, sizeof(confMqtt.mqtt_willMsg));
  strlcpy(confMqtt.mqtt_connMsg, MQTT_CONNMSG, sizeof(confMqtt.mqtt_connMsg));
  confMqtt.mqtt_outRetain = MQTT_OUT_RETAIN;
  confMqtt.mqtt_outRetain_sensors = MQTT_OUT_RETAIN_SENSORS;
  confMqtt.mqtt_enable_heartbeat = MQTT_ENABLE_HEARTBEAT;
  confMqtt.mqtt_heartbeat_maxage_reconnect = MQTT_HEARTBEAT_MAXAGE;
  confMqtt.mqtt_heartbeat_maxage_reboot = MQTT_HEARTBEAT_MAXAGE_REBOOT;
  confMqtt.wasChanged = false;


  confBas.setTempMin = DEFAULT_SETTEMP_MIN;
  confBas.setTempMax = DEFAULT_SETTEMP_MAX;
  confBas.autoSaveSetTemp = AUTOSAVE_SETTEMP;
  confBas.autoSaveHeatingMode = AUTOSAVE_SETMODE;
  confBas.saveToMqttRetained = SAVE_TO_MQTT_RETAINED;
  confBas.measureInterval = DEFAULT_MEASURE_INTERVAL;
  confBas.displayInterval = DEFAULT_DISPLAY_INTERVAL;
  confBas.displayTimeout = DEFAULT_DISPLAY_TIMEOUT;
  confBas.PIR_enablesDisplay = DEFAULT_PIR_ENABLES_DISPLAY;
  confBas.PIR_enablesDisplay_preset0only = DEFAULT_PIR_ENABLES_DISPLAY_PRESET0_ONLY;
  confBas.togglingTempHumAIDisplay = DEFAULT_TOGGLING_I_O_TEMPHUM;
  confBas.wasChanged = false;


  confAdv.hysteresis = DEFAULT_HYSTERESIS;
  confAdv.heatingMinOffTime = DEFAULT_HEATING_MIN_OFFTIME;
  confAdv.tempCorrVal = TEMPSENSOR_CORRECTION_VALUE;
  confAdv.humCorrVal = HUMSENSOR_CORRECTION_VALUE;
  confAdv.setTempDecreaseVal = SETTEMP_DECREASE_VALUE;
  strlcpy(confAdv.offMessage, OFF_MESSAGE, sizeof(confAdv.offMessage));
  strlcpy(confAdv.iTempLabel, INSIDE_TEMP_LABEL, sizeof(confAdv.iTempLabel));
  strlcpy(confAdv.oTempLabel, OUTSIDE_TEMP_LABEL, sizeof(confAdv.oTempLabel));
  strlcpy(confAdv.modeName0, MODE_NAME_0, sizeof(confAdv.modeName0));
  strlcpy(confAdv.modeName1, MODE_NAME_1, sizeof(confAdv.modeName1));
  strlcpy(confAdv.psetName0, PRESET_NAME_0, sizeof(confAdv.psetName0));
  strlcpy(confAdv.psetName1, PRESET_NAME_1, sizeof(confAdv.psetName1));
  strlcpy(confAdv.psetName2, PRESET_NAME_2, sizeof(confAdv.psetName2));
  confAdv.pauseTout = 1800;
  confAdv.wasChanged = false;


  strlcpy(confAdd.mqtt_topic_pir, MQTT_TOPIC_PIR, sizeof(confAdd.mqtt_topic_pir));
  strlcpy(confAdd.mqtt_payload_pir_on, MQTT_TOPIC_PIR_ON, sizeof(confAdd.mqtt_payload_pir_on));
  strlcpy(confAdd.mqtt_payload_pir_off, MQTT_TOPIC_PIR_OFF, sizeof(confAdd.mqtt_payload_pir_off));
  strlcpy(confAdd.outTemp_topic_in, OUTTEMP_TOPIC_IN, sizeof(confAdd.outTemp_topic_in));
  strlcpy(confAdd.outHum_topic_in, OUTHUM_TOPIC_IN, sizeof(confAdd.outHum_topic_in));
  confAdd.wasChanged = false;


#ifdef ENABLE_FEATURE_NTP_TIME
  confTime.ntpEnable = DEFAULT_NTP_ENABLED;
  strlcpy(confTime.timeZoneStr, DEFAULT_TIMEZONE, sizeof(confTime.timeZoneStr));
  strlcpy(confTime.ntpServer1, DEFAULT_NTP_SERVER, sizeof(confTime.ntpServer1));
  confTime.ntpSyncInterval = DEFAULT_NTP_SYNC_INTERVAL;
  confTime.wasChanged = false;
#endif


  confLog.logLevelSerial = DEFAULT_LOGLEVEL_SERIAL;
  confLog.logLevelWeb = DEFAULT_LOGLEVEL_WEB;
  confLog.logLevelMqtt = DEFAULT_LOGLEVEL_MQTT;
  confLog.logLevelSyslog = DEFAULT_LOGLEVEL_SYSLOG;
  confLog.wasChanged = false;
}

void loadConf_restoreDefaultWhenMissing()
{
  if (strlen(confDevWiFi.deviceName) < 4)
    createDeviceName();

  if (strlen(confDevWiFi.hostName) < 4)
    strlcpy(confDevWiFi.hostName, confDevWiFi.deviceName, sizeof(confDevWiFi.hostName));

  if (confAdv.modeName0[0] == '\0')
    strlcpy(confAdv.modeName0, MODE_NAME_0, sizeof(confAdv.modeName0));
  if (confAdv.modeName1[0] == '\0')
    strlcpy(confAdv.modeName1, MODE_NAME_1, sizeof(confAdv.modeName1));
  if (confAdv.psetName0[0] == '\0')
    strlcpy(confAdv.psetName0, PRESET_NAME_0, sizeof(confAdv.psetName0));
  if (confAdv.psetName1[0] == '\0')
    strlcpy(confAdv.psetName1, PRESET_NAME_1, sizeof(confAdv.psetName1));
  if (confAdv.psetName2[0] == '\0')
    strlcpy(confAdv.psetName2, PRESET_NAME_2, sizeof(confAdv.psetName2));
  if (confAdv.iTempLabel[0] == '\0')
    strlcpy(confAdv.iTempLabel, INSIDE_TEMP_LABEL, sizeof(confAdv.iTempLabel));
  if (confAdv.oTempLabel[0] == '\0')
    strlcpy(confAdv.oTempLabel, OUTSIDE_TEMP_LABEL, sizeof(confAdv.oTempLabel));

  if (confDevWiFi.WiFiConnCheckInterval == 0)
    confDevWiFi.WiFiConnCheckInterval = DEFAULT_WIFI_CONNCHECK_INTERVAL;


#ifdef ENABLE_FEATURE_NTP_TIME
  if (confTime.ntpEnable && strlen(confTime.ntpServer1) == 0)
    strlcpy(confTime.ntpServer1, DEFAULT_NTP_SERVER, sizeof(confTime.ntpServer1));
  if (confTime.ntpEnable && strlen(confTime.timeZoneStr) == 0)
    strlcpy(confTime.timeZoneStr, DEFAULT_TIMEZONE, sizeof(confTime.timeZoneStr));
#endif
}

void confClearCredentials()
{
  strcpy(confWeb.http_token, "");
  strcpy(confWeb.http_pass, "");
  strcpy(confWeb.http_pass1, "");
  strcpy(confWeb.http_pass2, "");
  saveConfigWeb();
  strcpy(confMqtt.mqtt_pass, "");
  saveConfigMqtt();
  sendLog(F("CONF: cleared credentials"));
}

void confClearWiFiCredentials()
{
  strcpy(confDevWiFi.WiFiPW1, "");
  strcpy(confDevWiFi.WiFiPW2, "");
  strcpy(confDevWiFi.WiFiAPModePassword, "");
  saveConfigDevWiFi();
  sendLog(F("CONF: cleared WiFi credentials"));
}

bool confCheckEncrypted()
{
  if (SPIFFS.exists("/isEncrypted"))
  {
    confEncryptionEnabled = true;
    sendLog("CONF: is encrypted");
    return true;
  }
  else
  {
    confEncryptionEnabled = false;
    sendLog("CONF: is NOT encrypted");
    return false;
  }
}

void confEncrypt()
{
  if (!confCheckEncrypted())
  {
    sendLog(F("CONF: encrypting config..."));
    confEncryptionEnabled = true;
    saveConfig_all();
    File configFile = SPIFFS.open("/isEncrypted", "w");
    configFile.close();
    sendLog(F("CONF: config encryption DONE"));
  }
  else
  {
    sendLog(F("CONF: already encrypted."));
  }
}

void confDecrypt()
{
  if (confCheckEncrypted())
  {
    sendLog(F("CONF: decrypting config..."));
    confEncryptionEnabled = false;
    confClearCredentials();
    confClearWiFiCredentials();
    SPIFFS.remove("/isEncrypted");
    sendLog(F("CONF: config decrypted. all credentials were deleted. please re-enter WiFi credentials before reboot!"));
  }
  else
  {
    sendLog(F("CONF: config is not encrypted."));
  }
}

bool confCheckUnsaved()
{
  bool confChanged = false;
  if (confDevWiFi.wasChanged)
    confChanged = true;
  if (confWeb.wasChanged)
    confChanged = true;
  if (confMqtt.wasChanged)
    confChanged = true;
  if (confBas.wasChanged)
    confChanged = true;
  if (confAdv.wasChanged)
    confChanged = true;
  if (confAdd.wasChanged)
    confChanged = true;
  if (confTime.wasChanged)
    confChanged = true;
  if (confLog.wasChanged)
    confChanged = true;
  return confChanged;
}

void confChangedLogNote(bool force = false)
{
  if (confCheckUnsaved() && (force || (!lastConfigChangeNoteAlreadyDone && (millis() - lastConfigChange) > 5000)))
  {
    sendLog(F("NOTE: pending config changes. Execute 'saveconf' to save or 'loadconf' to discard."));
    confMqttConnResetRequiredLogNote();
    confRestartRequiredLogNote();
    lastConfigChangeNoteAlreadyDone = true;
  }
  if(force) {
    confMqttConnResetRequiredLogNote();
    confRestartRequiredLogNote();
  }
}

void confRestartRequiredLogNote()
{
  if (configChangedRestartRequired)
    sendLog(F("NOTE: config changes require restart. Remember 'saveconf' before!"));
}

void confMqttConnResetRequiredLogNote()
{
  if (configChangedMqttConnResetRequired)
    sendLog(F("NOTE: MQTT config changes require connection reset -> will be done automatically on 'saveconf'."));
}
# 1 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"

#include "html.h"
#include "html_conf.h"
#include "html_confAdd.h"
#include "html_confAdv.h"
#include "html_confBas.h"
#include "html_confDevWiFi.h"
#include "html_confMqtt.h"
#include "html_confWeb.h"
#include "html_confTime.h"
#include "html_confLog.h"
#include "html_main.h"
#include "html_redTemps.h"
#include "html_sysinfo.h"

#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
#include "html_console_ws.h"
#endif

#ifdef ENABLE_FEATURE_WEB_CONSOLE
#include "html_console.h"
#endif

void httpServerHandleMainPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_main_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_main_body);
  if (httpIsAuthenticatedAdmin())
  {
    httpServer.sendContent_P(html_main_body_adminonly);
#ifdef ENABLE_FEATURE_WEB_CONSOLE
    if (confWeb.wConsole)
      httpServer.sendContent_P(html_main_body_adminonly_console);
#endif
#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
if (confWeb.wsConsole)
      httpServer.sendContent_P(html_main_body_adminonly_wsconsole);
#endif
  }
  httpServer.sendContent_P(html_main_body2);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleRedTempsPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_redTemps_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_redTemps_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_conf_body);
#ifdef ENABLE_FEATURE_WEB_CONSOLE
    if (confWeb.wConsole)
      httpServer.sendContent_P(html_conf_body_console);
#endif
#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
  if (confWeb.wsConsole)
    httpServer.sendContent_P(html_conf_body_wsconsole);
#endif
  httpServer.sendContent_P(html_conf_body_end);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfWebPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_confweb_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confweb_body);
  #ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
  httpServer.sendContent_P(html_confweb_body_wsconsole);
  #endif
  httpServer.sendContent_P(html_confweb_body2);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfMqttPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_confmqtt_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confmqtt_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfDevWiFiPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_confDevWiFi_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confDevWiFi_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfBasPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_confbas_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confbas_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfAdvPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_confadv_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confadv_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfAddPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_confadd_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confadd_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfTimePage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_conftime_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_conftime_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfLogPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_conflog_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_conflog_body);
  httpServerSendHtmlFooterChunked();
}

#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
void httpServerHandleWSConsolePage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_wsconsole_body);
  httpServerSendHtmlFooterChunked();
}
#endif

void httpServerHandleConsolePage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_console_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleConfSavedPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_confsaved_body);
  httpServerSendHtmlFooterChunked();
}
# 211 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"
void httpServerHandleRestartPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  configChangedRestartRequired = false;
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_restarting_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleClearconfPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_clearconf_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerHandleSysInfoPage()
{
  httpServerSendHtmlHeadChunked();
  httpServer.sendContent_P(html_sysinfo_script);
  httpServer.sendContent_P(html_head_end);
  httpServer.sendContent_P(html_bodytag_jsinit);
  httpServerSendHtmlBodyPageheadChunked();
  httpServer.sendContent_P(html_sysinfo_body);
  httpServerSendHtmlFooterChunked();
}

void httpServerSendHtmlHeadChunked()
{
  httpServer.setContentLength(CONTENT_LENGTH_UNKNOWN);
  httpServer.send(200, "text/html", html_head_part1);
  httpServer.sendContent_P(PGMStr_FIRMWARE_NAME);
  httpServer.sendContent(" - ");
  httpServer.sendContent(confDevWiFi.deviceName);
  httpServer.sendContent_P(html_head_part2);
}

void httpServerSendHtmlBodyPageheadChunked()
{
  httpServer.sendContent_P(html_body_pagehead_part1);
  httpServer.sendContent_P(PGMStr_FIRMWARE_NAME);
  httpServer.sendContent(" - ");
  httpServer.sendContent(confDevWiFi.deviceName);
  httpServer.sendContent_P(html_body_pagehead_part2);
  if (configChangedRestartRequired)
    httpServer.sendContent_P(html_body_pagehead_confchangednote);
}

void httpServerSendHtmlFooterChunked()
{
  httpServer.sendContent_P(html_footer1);
  httpServer.sendContent_P(html_footer_a1);
  httpServer.sendContent_P(PGMStr_FIRMWARE_URL);
  httpServer.sendContent_P(html_footer_a2);
  httpServer.sendContent_P(PGMStr_FIRMWARE_NAME);
  httpServer.sendContent_P(html_footer_ae);
  httpServer.sendContent(" ");
  httpServer.sendContent_P(PGMStr_FIRMWARE_VERSION);
#ifdef DEBUGMODE
  httpServer.sendContent("&nbsp;<span style='color:red;font-weight:bold;'>DEBUG</span>");
#endif
  httpServer.sendContent(" by ");
  httpServer.sendContent_P(html_footer_a1);
  httpServer.sendContent_P(PGMStr_FIRMWARE_COPYRIGHT_URL);
  httpServer.sendContent_P(html_footer_a2);
  httpServer.sendContent_P(PGMStr_FIRMWARE_COPYRIGHT);
  httpServer.sendContent_P(html_footer_ae);
  httpServer.sendContent_P(html_footer2);
  httpServer.sendContent("");
  httpServer.client().stop();
}

boolean httpIsAuthenticated()
{
  if (WifiInApMode && strlen(confDevWiFi.WiFiAPModePassword) >= 8)
    return true;
  if (confWeb.http_user_auth)
  {
    boolean useAuth = false;
    boolean isAuthenticated = false;


    if (strlen(confWeb.http_pass) > 0 || strlen(confWeb.http_pass1) > 0 || strlen(confWeb.http_pass2) > 0)
      useAuth = true;
    if (strlen(confWeb.http_pass) == 0)
    {
      return true;
    }
    if (useAuth)
    {

      if ((strlen(confWeb.http_user) > 0 && strlen(confWeb.http_pass) > 0))
      {
        if (httpServer.authenticate(confWeb.http_user, confWeb.http_pass))
          isAuthenticated = true;
      }
      if ((strlen(confWeb.http_user1) > 0 && strlen(confWeb.http_pass1) > 0))
      {
        if (httpServer.authenticate(confWeb.http_user1, confWeb.http_pass1))
          isAuthenticated = true;
      }
      if ((strlen(confWeb.http_user2) > 0 && strlen(confWeb.http_pass2) > 0))
      {
        if (httpServer.authenticate(confWeb.http_user2, confWeb.http_pass2))
          isAuthenticated = true;
      }

      if (strlen(confWeb.http_pass1) == 0)
      {
        isAuthenticated = true;
      }
      return isAuthenticated;
    }

    else
      return true;
  }

  else
  {
    if (strlen(confWeb.http_pass) > 0)
    {
      if (httpServer.authenticate(confWeb.http_user, confWeb.http_pass))
        return true;
      else
        return false;
    }
    else
      return true;
  }
}

boolean httpIsAuthenticatedAdmin()
{
  if (WifiInApMode && strlen(confDevWiFi.WiFiAPModePassword) >= 8)
    return true;
  boolean auth = false;
  if ((strlen(confWeb.http_user) > 0 && strlen(confWeb.http_pass) > 0))
    auth = true;
  if (auth)
  {
    if (!httpServer.authenticate(confWeb.http_user, confWeb.http_pass))
      return false;
    else
      return true;
  }
  else
    return true;
}

void httpServerHandleNotFound()
{
  httpServer.send(404, "text/plain", "404 NOT FOUND");
}

void httpSendUnauthorized()
{
  httpServer.send(401, "text/plain", "UNAUTHORIZED");
}

void httpSend200OK()
{
  httpServer.send(200, "text/plain", "OK");
}

boolean httpCheckToken()
{
  if (confWeb.http_token[0] != '\0')
  {
    if (httpServer.hasArg("token"))
    {
      char buf[20];
      httpServer.arg("token").toCharArray(buf, 20);
      if (strcmp(buf, confWeb.http_token) == 0)
        return true;
      else
        return false;
    }
    else
      return false;
  }
  else
    return false;
}

void httpServerInit()
{
  httpServer.on("/style.css", []() {
    httpServer.sendHeader("cache-control", "max-age=86400", false);
    httpServer.send_P(200, "text/css", html_stylesheet);
  });

  httpServer.on("/api", []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {
      if (confLog.logWebRequests || httpServer.args() > 0)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /api (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      if (httpServer.hasArg("BtnPlus"))
      {
        setTempStepUp();
        sendLog(F("WEB: BtnPlus"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnMinus"))
      {
        setTempStepDown();
        sendLog(F("WEB: BtnMinus"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnPset0"))
      {
        setPresetTo(0);
        sendLog(F("WEB: BtnPset0"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnPset1"))
      {
        setPresetTo(1);
        sendLog(F("WEB: BtnPset1"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnPset2"))
      {
        setPresetTo(2);
        sendLog(F("WEB: BtnPset2"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnOn"))
      {
        setHeatingmodeTo(1);
        sendLog(F("WEB: BtnOn"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnOff"))
      {
        setHeatingmodeTo(0);
        sendLog(F("WEB: BtnOff"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnL1Plus"))
      {
        setTempLowStepUp();
        sendLog(F("WEB: BtnL1Plus"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnL1Minus"))
      {
        setTempLowStepDown();
        sendLog(F("WEB: BtnL1Minus"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnL2Plus"))
      {
        setTempLow2StepUp();
        sendLog(F("WEB: BtnL2Plus"), LOGLEVEL_INFO);
      }
      if (httpServer.hasArg("BtnL2Minus"))
      {
        setTempLow2StepDown();
        sendLog(F("WEB: BtnL2Minus"), LOGLEVEL_INFO);
      }

      if (httpServer.hasArg("setTemp"))
      {
        sendLog(F("WEB: /api?setTemp"), LOGLEVEL_INFO);
        char bufVal[20];
        httpServer.arg("setTemp").toCharArray(bufVal, 20);
        float valueFloat = round(atof(bufVal) * 2.0) / 2.0;
        setTempTo(valueFloat);
      }

      if (httpServer.hasArg("setPause"))
      {
        sendLog(F("WEB: /api?setPause"), LOGLEVEL_INFO);
        char bufVal[20];
        httpServer.arg("setPause").toCharArray(bufVal, 20);
        int valueInt = atoi(bufVal);
        setHeatingPause(valueInt);
      }

      if (httpServer.hasArg("setMode"))
      {
        sendLog(F("WEB: /api?setMode"), LOGLEVEL_INFO);
        char bufVal[20];
        httpServer.arg("setMode").toCharArray(bufVal, 20);
        int valueInt = atoi(bufVal);
        if (valueInt >= 0 && valueInt <= 1)
          setHeatingmodeTo(valueInt);
      }

      if (httpServer.hasArg("setPreset"))
      {
        sendLog(F("WEB: /api?setPreset"), LOGLEVEL_INFO);
        char bufVal[20];
        httpServer.arg("setPreset").toCharArray(bufVal, 20);
        int valueInt = atoi(bufVal);
        if (valueInt >= 0 && valueInt <= 2)
          setPresetTo(valueInt);
      }







      StaticJsonDocument<850> json;

      json["devname"] = confDevWiFi.deviceName;
      json["ssid"] = WiFi.SSID();
      json["WiFiNum"] = persWM.getActiveWiFiNum();

      json["uptime"] = getUptimeStr();

#ifdef ENABLE_FEATURE_NTP_TIME
      if (confTime.ntpEnable)
      {
        char buf[13];
        updateTime();
        if (lt.tm_year > 70)
        {
          strftime(buf, sizeof(buf), "%H:%M", &lt);
          json["time"] = buf;
          strftime(buf, sizeof(buf), "%d.%m.%Y", &lt);
          json["date"] = buf;
        }
      }
#endif

      json["freeheap"] = ESP.getFreeHeap();

      mqtt_updateCurrentStateName();
      json["mqttstate"] = mqttCurrentStateName;
      json["mqtthost"] = confMqtt.mqtt_server;

      if (mqttReconnects < 1)
        json["mqttreconn"] = mqttReconnects;
      else
        json["mqttreconn"] = mqttReconnects - 1;

      json["setTemp"] = setTemp;
      json["currSetTemp"] = currSetTemp;
      json["actSetTemp"] = currActualSetTemp;
      json["temp"] = round1(currTemp);
      json["hum"] = int(currHum);

      uint8_t _heatingState;
      if(turnHeatingOn) _heatingState = 1;
      else if(heatingLockTime > 0) _heatingState = 2;
      else _heatingState = 0;

      json["heating"] = _heatingState;
      json["heatingLockTime"] = heatingLockTime;
      json["heatingPause"] = heatingPause;
      json["mode"] = heatingMode;
      json["modeName"] = currentModeName;
      json["pset"] = preset;
      json["psetName"] = currentPresetName;
      json["psetName0"] = confAdv.psetName0;
      json["psetName1"] = confAdv.psetName1;
      json["psetName2"] = confAdv.psetName2;
      json["tempLow"] = setTempLow;
      json["tempLow2"] = setTempLow2;
      json["outTemp"] = round1(outTemp);
      json["outHum"] = outHum;

      char jsonchar[750];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/confDataWeb", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {


      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confDataWeb (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      StaticJsonDocument<1000> json;

      json["apiToken"] = confWeb.http_token;
      json["httpUA"] = confWeb.http_user;

      if (strlen(confWeb.http_pass) > 0)
        json["httpPA"] = "****";
      else
        json["httpPA"] = "";

      if (confWeb.http_user_auth)
        json["httpAuth"] = 1;
      else
        json["httpAuth"] = 0;

      json["httpU1"] = confWeb.http_user1;

      if (strlen(confWeb.http_pass1) > 0)
        json["httpP1"] = "****";
      else
        json["httpP1"] = "";
      json["httpU2"] = confWeb.http_user2;

      if (strlen(confWeb.http_pass2) > 0)
        json["httpP2"] = "****";
      else
        json["httpP2"] = "";

      if (confWeb.wConsole)
        json["wConsole"] = 1;
      else
        json["wConsole"] = 0;

      if (confWeb.wsConsole)
        json["wsConsole"] = 1;
      else
        json["wsConsole"] = 0;

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/confDataMqtt", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confDataMqtt (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      StaticJsonDocument<1000> json;

      if (confMqtt.mqtt_enable)
        json["mqttEnable"] = 1;
      else
        json["mqttEnable"] = 0;

      json["mqttHost"] = confMqtt.mqtt_server;
      json["mqttPort"] = confMqtt.mqtt_port;
      json["mqttUser"] = confMqtt.mqtt_user;


      if (strlen(confMqtt.mqtt_pass) > 0)
        json["mqttPass"] = "****";
      else
        json["mqttPass"] = "";

      json["inTop"] = confMqtt.mqtt_topic_in;
      json["outTop"] = confMqtt.mqtt_topic_out;

      if (confMqtt.mqtt_outRetain)
        json["outRet"] = 1;
      else
        json["outRet"] = 0;
      if (confMqtt.mqtt_outRetain_sensors)
        json["outRetSens"] = 1;
      else
        json["outRetSens"] = 0;

      json["outPubInt"] = confMqtt.mqtt_outPubInterval;
      json["outPubIntSens"] = confMqtt.mqtt_outPubInterval_sensors;

      json["willTop"] = confMqtt.mqtt_willTopic;
      json["willQos"] = confMqtt.mqtt_willQos;

      if (confMqtt.mqtt_willRetain)
        json["willRet"] = 1;
      else
        json["willRet"] = 0;

      json["willMsg"] = confMqtt.mqtt_willMsg;
      json["connMsg"] = confMqtt.mqtt_connMsg;

      if (confMqtt.mqtt_enable_heartbeat)
        json["hbEnable"] = 1;
      else
        json["hbEnable"] = 0;

      json["hbReconn"] = confMqtt.mqtt_heartbeat_maxage_reconnect / 60000;
      json["hbReboot"] = confMqtt.mqtt_heartbeat_maxage_reboot / 60000;

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/setConfWeb", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {

      String addr = httpServer.client().remoteIP().toString();
      char buf[40];
      sprintf(buf, "WEB: /setConfWeb (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);

      bool httpPASet, httpP1Set, httpP2Set;
      httpPASet = false;
      httpP1Set = false;
      httpP2Set = false;
      if (httpServer.hasArg("httpPASet"))
        httpPASet = true;
      if (httpServer.hasArg("httpP1Set"))
        httpP1Set = true;
      if (httpServer.hasArg("httpP2Set"))
        httpP2Set = true;

      for (int i = 0; i < httpServer.args(); i++)
      {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0)
        {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);

          if (strcmp(bufName, "httpUA") == 0 || strcmp(bufName, "httpPA") == 0)
          {
            if (httpPASet)
              setConfig(bufName, bufValue);
          }
          else if (strcmp(bufName, "httpU1") == 0 || strcmp(bufName, "httpP1") == 0)
          {
            if (httpP1Set)
              setConfig(bufName, bufValue);
          }
          else if (strcmp(bufName, "httpU2") == 0 || strcmp(bufName, "httpP2") == 0)
          {
            if (httpP2Set)
              setConfig(bufName, bufValue);
          }
          else if (strcmp(bufName, "httpPASet") != 0 && strcmp(bufName, "httpP1Set") != 0 && strcmp(bufName, "httpP2Set") != 0)
            setConfig(bufName, bufValue);

        }
      }
      yield();

      saveConfigWeb();
      yield();
      loadConfigWeb();

      httpServerHandleConfSavedPage();


    }
  });

  httpServer.on("/setConfMqtt", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {


      String addr = httpServer.client().remoteIP().toString();
      char buf[40];
      sprintf(buf, "WEB: /setConfMqtt (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);

      bool mqttPassSet;
      mqttPassSet = false;
      if (httpServer.hasArg("mqttPassSet"))
        mqttPassSet = true;

      for (int i = 0; i < httpServer.args(); i++)
      {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0)
        {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);

          if (strcmp(bufName, "mqttUser") == 0 || strcmp(bufName, "mqttPass") == 0)
          {
            if (mqttPassSet)
              setConfig(bufName, bufValue);
          }
          else
            setConfig(bufName, bufValue);
        }


      }
      yield();
      saveConfigMqtt();
      yield();
      loadConfigMqtt();


      httpServerHandleConfSavedPage();

    }
  });

  httpServer.on("/confDataDevWiFi", []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confDataDevWiFi (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }
# 875 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"
      StaticJsonDocument<800> json;

      json["devName"] = confDevWiFi.deviceName;
      json["hostName"] = confDevWiFi.hostName;
      json["SSID1"] = confDevWiFi.WiFiSSID1;

      if (strlen(confDevWiFi.WiFiPW1) > 0)
        json["WPW1"] = "****";
      else
        json["WPW1"] = "";
      json["SSID2"] = confDevWiFi.WiFiSSID2;

      if (strlen(confDevWiFi.WiFiPW2) > 0)
        json["WPW2"] = "****";
      else
        json["WPW2"] = "";
      json["SSIDAP"] = confDevWiFi.WiFiAPModeSSID;
      json["WPWAP"] = confDevWiFi.WiFiAPModePassword;
      json["WAPtout"] = confDevWiFi.WiFiAPModeTimeout;
      json["WConnCheck"] = confDevWiFi.WiFiConnCheckInterval;
      json["Wretry"] = confDevWiFi.WiFiRetryInterval;
      json["Wreboot"] = confDevWiFi.WiFiRebootOnNoConnect;

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/setConfDevWiFi", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {

      String addr = httpServer.client().remoteIP().toString();
      char buf[40];
      sprintf(buf, "WEB: /setConfDevWiFi (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);

      bool WPW1Set, WPW2Set, WPWAPSet;
      WPW1Set = false;
      WPW2Set = false;
      WPWAPSet = false;
      if (httpServer.hasArg("WPW1Set"))
        WPW1Set = true;
      if (httpServer.hasArg("WPW2Set"))
        WPW2Set = true;
      if (httpServer.hasArg("WPWAPSet"))
        WPWAPSet = true;

      for (int i = 0; i < httpServer.args(); i++)
      {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0)
        {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);

          if (strcmp(bufName, "SSID1") == 0 || strcmp(bufName, "WPW1") == 0)
          {
            if (WPW1Set)
              setConfig(bufName, bufValue);
          }
          else if (strcmp(bufName, "SSID2") == 0 || strcmp(bufName, "WPW2") == 0)
          {
            if (WPW2Set)
              setConfig(bufName, bufValue);
          }
          else if (strcmp(bufName, "WPWAP") == 0)
          {
            if (WPWAPSet)
              setConfig(bufName, bufValue);
          }
          else
            setConfig(bufName, bufValue);
        }
      }
      yield();
      saveConfigDevWiFi();
      yield();
      loadConfigDevWiFi();


      httpServerHandleConfSavedPage();

    }
  });

  httpServer.on("/setConfBas", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {

      String addr = httpServer.client().remoteIP().toString();
      char buf[40];
      sprintf(buf, "WEB: /setConfBas (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);

      for (int i = 0; i < httpServer.args(); i++)
      {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0)
        {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);
          setConfig(bufName, bufValue);
        }
      }
      yield();
      saveConfigBas();
      yield();
      loadConfigBas();

      httpServerHandleConfSavedPage();
    }
  });

  httpServer.on("/setConfAdv", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {

      String addr = httpServer.client().remoteIP().toString();
      char buf[40];
      sprintf(buf, "WEB: /setConfAdv (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);

      for (int i = 0; i < httpServer.args(); i++)
      {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0)
        {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);
          setConfig(bufName, bufValue);
        }
      }
      yield();
      saveConfigAdv();
      yield();
      loadConfigAdv();

      httpServerHandleConfSavedPage();
    }
  });

  httpServer.on("/setConfAdd", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {

      String addr = httpServer.client().remoteIP().toString();
      char buf[40];
      sprintf(buf, "WEB: /setConfAdd (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);

      for (int i = 0; i < httpServer.args(); i++)
      {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0)
        {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);
          setConfig(bufName, bufValue);
        }
      }
      yield();
      saveConfigAdd();
      yield();
      loadConfigAdd();

      httpServerHandleConfSavedPage();
    }
  });

#ifdef ENABLE_FEATURE_NTP_TIME
  httpServer.on("/setConfTime", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {

      String addr = httpServer.client().remoteIP().toString();
      char buf[40];
      sprintf(buf, "WEB: /setConfTime (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);

      for (int i = 0; i < httpServer.args(); i++)
      {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0)
        {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);
          setConfig(bufName, bufValue);
        }
      }
      yield();
      saveConfigTime();
      yield();
      loadConfigTime();

      httpServerHandleConfSavedPage();
    }
  });
#endif

  httpServer.on("/setConfLog", []() {
    if (!httpIsAuthenticatedAdmin())
      httpSendUnauthorized();
    else
    {

      String addr = httpServer.client().remoteIP().toString();
      char buf[40];
      sprintf(buf, "WEB: /setConfLog (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);

      for (int i = 0; i < httpServer.args(); i++)
      {
        char bufName[20];
        char bufValue[101];
        httpServer.argName(i).toCharArray(bufName, 20);
        httpServer.arg(i).toCharArray(bufValue, 101);

        if (strlen(bufName) > 0)
        {
          Serial.print("web update ");
          Serial.print(bufName);
          Serial.print(" = ");
          Serial.println(bufValue);
          setConfig(bufName, bufValue);
        }
      }
      yield();
      saveConfigLog();
      yield();
      loadConfigLog();

      httpServerHandleConfSavedPage();
    }
  });

  httpServer.on("/confDataBas", []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {


      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confDataBas (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }
# 1188 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"
      StaticJsonDocument<500> json;

      if (confBas.autoSaveSetTemp)
        json["autoSaveTemp"] = 1;
      else
        json["autoSaveTemp"] = 0;

      if (confBas.autoSaveHeatingMode)
        json["autoSaveMode"] = 1;
      else
        json["autoSaveMode"] = 0;

      if (confBas.saveToMqttRetained)
        json["saveToMqttRet"] = 1;
      else
        json["saveToMqttRet"] = 0;

      json["tempMin"] = confBas.setTempMin;
      json["tempMax"] = confBas.setTempMax;
      json["measInt"] = confBas.measureInterval;
      json["dispInt"] = confBas.displayInterval;
      json["dispTout"] = confBas.displayTimeout;

      if (confBas.PIR_enablesDisplay)
        json["PIRenDisp"] = 1;
      else
        json["PIRenDisp"] = 0;

      if (confBas.PIR_enablesDisplay_preset0only)
        json["PIRenDispPs0"] = 1;
      else
        json["PIRenDispPs0"] = 0;

      if (confBas.togglingTempHumAIDisplay)
        json["togTHdisp"] = 1;
      else
        json["togTHdisp"] = 0;

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/confDataAdv", []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {


      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confDataAdv (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }
# 1268 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"
      StaticJsonDocument<750> json;
      json["minOffTime"] = confAdv.heatingMinOffTime;
      json["tempDec"] = confAdv.setTempDecreaseVal;
      json["hyst"] = confAdv.hysteresis;
      json["tempCorr"] = confAdv.tempCorrVal;
      json["humCorr"] = confAdv.humCorrVal;
      json["offMsg"] = confAdv.offMessage;
      json["modeName0"] = confAdv.modeName0;
      json["modeName1"] = confAdv.modeName1;
      json["psetName0"] = confAdv.psetName0;
      json["psetName1"] = confAdv.psetName1;
      json["psetName2"] = confAdv.psetName2;
      json["iTempLab"] = confAdv.iTempLabel;
      json["oTempLab"] = confAdv.oTempLabel;
      json["pauseTout"] = confAdv.pauseTout;

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/confDataAdd", []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {


      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confDataAdd (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }
# 1326 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"
      StaticJsonDocument<1000> json;

      json["outTempTop"] = confAdd.outTemp_topic_in;
      json["outHumTop"] = confAdd.outHum_topic_in;
      json["PIRTop"] = confAdd.mqtt_topic_pir;
      json["PIROnPld"] = confAdd.mqtt_payload_pir_on;
      json["PIROffPld"] = confAdd.mqtt_payload_pir_off;

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/confDataTime", []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {


      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confDataTime (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }
# 1376 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"
      StaticJsonDocument<1000> json;

      if (confTime.ntpEnable)
        json["NTPEnable"] = 1;
      else
        json["NTPEnable"] = 0;

      json["NTPServer1"] = confTime.ntpServer1;
      json["NTPServer2"] = confTime.ntpServer2;
      json["TZStr"] = confTime.timeZoneStr;
      json["NTPSyncInt"] = confTime.ntpSyncInterval / 60;

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/confDataLog", []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confDataLog (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }
# 1429 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"
      StaticJsonDocument<1000> json;




      json["logLevSer"] = confLog.logLevelSerial;
      json["logLevWeb"] = confLog.logLevelWeb;
      json["logLevMqtt"] = confLog.logLevelMqtt;

      if (confLog.logWebRequests)
        json["logWebRequests"] = 1;
      else
        json["logWebRequests"] = 0;

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });


  httpServer.on("/sysinfod", HTTP_GET, []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {
      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /sysinfod (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      char buf[40];
      byte mac[6];
      WiFi.macAddress(mac);

      StaticJsonDocument<1000> json;
      json["DevName"] = confDevWiFi.deviceName;
      json["HostName"] = confDevWiFi.hostName;

      sprintf(buf, "%02X:%02X:%02X:%02X:%02X:%02X", (uint8_t)mac[0], (uint8_t)mac[1], (uint8_t)mac[2], (uint8_t)mac[3], (uint8_t)mac[4], (uint8_t)mac[5]);
      json["MAC"] = buf;







      json["IP"] = WiFi.localIP().toString();
      json["GW"] = WiFi.gatewayIP().toString();
      json["DNS"] = WiFi.dnsIP().toString();

      json["SSID"] = WiFi.SSID();
      json["WiFiConf"] = persWM.getActiveWiFiNum();
      json["UpTime"] = getUptimeStr();
      json["HeapFree"] = ESP.getFreeHeap();
      json["HeapFragment"] = ESP.getHeapFragmentation();
      json["HeapMaxBlock"] = ESP.getMaxFreeBlockSize();
      json["ResetReason"] = ESP.getResetReason();
      json["CoreVersion"] = ESP.getCoreVersion();
      json["SDKVersion"] = ESP.getSdkVersion();
      json["CPUfreq"] = ESP.getCpuFreqMHz();
      json["SketchSize"] = ESP.getSketchSize();
      json["FlashSize"] = ESP.getFlashChipRealSize();

      sprintf(buf, "%s", PGMStr_FIRMWARE_NAME);
      json["FWName"] = buf;

      sprintf(buf, "%s", PGMStr_FIRMWARE_VERSION);
      json["FWVer"] = buf;

      sprintf(buf, "%s", PGMStr_FIRMWARE_COPYRIGHT);
      json["FWCr"] = buf;

      sprintf(buf, "%s", compile_date);
      json["FWBuilt"] = buf;
#ifdef DEBUGMODE
      json["FWDebug"] = "yes";
#else
      json["FWDebug"] = "no";
#endif

#ifdef ENABLE_FEATURE_NTP_TIME
      if (confTime.ntpEnable)
      {
        char buf[13];
        updateTime();
        if(lt.tm_year > 70) {
          strftime(buf, sizeof(buf), "%H:%M", &lt);
          json["Time"] = buf;
          strftime(buf, sizeof(buf), "%d.%m.%Y", &lt);
          json["Date"] = buf;
        }
      }
#endif

      yield();

      char jsonchar[1000];
      serializeJson(json, jsonchar);
      httpServer.send(200, "application/json", jsonchar);
    }
  });

  httpServer.on("/sysinfo", HTTP_GET, []() {
    if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {
      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /sysinfo (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }
      httpServerHandleSysInfoPage();
    }
  });
# 1565 "D:/Flo/git/WiFiThermostat/src/httpServer.ino"
  httpServer.on("/", []() {
    String addr = httpServer.client().remoteIP().toString();
    if (confLog.logWebRequests || httpServer.args() > 0)
    {
      char buf[40];
      sprintf(buf, "WEB: / (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);
    }

    if (httpServer.hasArg("restart"))
    {
      if (httpIsAuthenticated() || (!httpIsAuthenticated() && httpCheckToken()))
      {
        sendLog("WEB: /?restart", LOGLEVEL_INFO);
        httpServerHandleRestartPage();
        restart();
      }
      else
        httpSendUnauthorized();
    }
    else if (httpServer.hasArg("mqttreconnect"))
    {
      if (httpIsAuthenticated() || (!httpIsAuthenticated() && httpCheckToken()))
      {

        sendLog("WEB: /?mqttreconnect", LOGLEVEL_INFO);
        mqttReconnect();
        httpServer.sendHeader("Location", "/", true);
        httpServer.send(303);
      }
      else
        httpSendUnauthorized();
    }
    else if (httpServer.hasArg("clearconf"))
    {
      if (httpIsAuthenticatedAdmin() || (!httpIsAuthenticatedAdmin() && httpCheckToken()))
      {
        sendLog("WEB: /?clearconf", LOGLEVEL_INFO);
        httpServerHandleClearconfPage();

        yield();
        delay(5);
        deleteConfig();
      }
      else
        httpSendUnauthorized();
    }
    else if (httpServer.hasArg("clearwifi"))
    {
      if (httpIsAuthenticatedAdmin() || (!httpIsAuthenticatedAdmin() && httpCheckToken()))
      {
        sendLog("WEB: /?clearwifi", LOGLEVEL_INFO);
        httpServerHandleClearconfPage();

        yield();
        delay(5);
        confClearWiFiCredentials();
      }
      else
        httpSendUnauthorized();
    }
    else if (httpServer.hasArg("clearcreds"))
    {
      if (httpIsAuthenticatedAdmin() || (!httpIsAuthenticatedAdmin() && httpCheckToken()))
      {
        sendLog("WEB: /?clearcreds", LOGLEVEL_INFO);
        httpServerHandleClearconfPage();

        yield();
        delay(5);
        confClearCredentials();
      }
      else
        httpSendUnauthorized();
    }
    else if (!httpIsAuthenticated())
      return httpServer.requestAuthentication();
    else
    {
      if (confLog.logWebRequests)
        sendLog("WEB: /", LOGLEVEL_INFO);
      httpServerHandleMainPage();
    }
  });

  httpServer.on("/conf", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /conf (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfPage();
    }
  });

  httpServer.on("/confweb", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confweb (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfWebPage();
    }
  });

  httpServer.on("/confmqtt", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confmqtt (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfMqttPage();
    }
  });

  httpServer.on("/confdevwifi", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confdevwifi (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfDevWiFiPage();
    }
  });

  httpServer.on("/confbas", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confbas (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfBasPage();
    }
  });

  httpServer.on("/confadv", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confadv (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfAdvPage();
    }
  });

  httpServer.on("/confadd", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /confadd (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfAddPage();
    }
  });

  httpServer.on("/conftime", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /conftime (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfTimePage();
    }
  });

  httpServer.on("/conflog", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /conflog (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleConfLogPage();
    }
  });

  httpServer.on("/redTemps", []() {
    if (!httpIsAuthenticatedAdmin())
      return httpServer.requestAuthentication();
    else
    {

      if (confLog.logWebRequests)
      {
        String addr = httpServer.client().remoteIP().toString();
        char buf[40];
        sprintf(buf, "WEB: /redTemps (from %s)", addr.c_str());
        sendLog(buf, LOGLEVEL_INFO);
      }

      httpServerHandleRedTempsPage();
    }
  });

#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
  if (confWeb.wsConsole)
  {
    httpServer.on("/wsconsole", []() {
      if (!httpIsAuthenticatedAdmin())
        return httpServer.requestAuthentication();
      else
      {

        if (confLog.logWebRequests)
        {
          String addr = httpServer.client().remoteIP().toString();
          char buf[40];
          sprintf(buf, "WEB: /wsconsole (from %s)", addr.c_str());
          sendLog(buf, LOGLEVEL_INFO);
        }

        wsValidSessionId = millis();
        char sidbuf[20];
        sprintf(sidbuf, "sessionId=%lu|", wsValidSessionId);
        httpServer.sendHeader("Set-Cookie", sidbuf);
        httpServerHandleWSConsolePage();
      }
    });
    httpServer.on("/wsapp.js", []() {
      httpServer.sendHeader("cache-control", "max-age=86400", false);
      httpServer.send_P(200, "text/javascript", js_wsapp);
    });
  }
#endif

  httpServer.onNotFound([]() {
    String addr = httpServer.client().remoteIP().toString();
    if (confLog.logWebRequests)
    {
      char buf[40];
      sprintf(buf, "WEB: 404 (from %s)", addr.c_str());
      sendLog(buf, LOGLEVEL_INFO);
    }
    httpServerHandleNotFound();
  });

#ifdef ENABLE_FEATURE_WEB_CONSOLE
  if (confWeb.wConsole)
  {
    httpServer.on("/console", []() {
      if (!httpIsAuthenticatedAdmin())
        return httpServer.requestAuthentication();
      else
      {

        if (confLog.logWebRequests)
        {
          String addr = httpServer.client().remoteIP().toString();
          char buf[40];
          sprintf(buf, "WEB: /console (from %s)", addr.c_str());
          sendLog(buf, LOGLEVEL_INFO);
        }
        httpServerHandleConsolePage();
      }
    });
    httpServer.on("/webcsapi", []() {
      if (!httpIsAuthenticatedAdmin())
        return httpServer.requestAuthentication();
      else
      {
        if (httpServer.hasArg("cmd"))
        {
          char buf[101];
          httpServer.arg("cmd").toCharArray(buf, 100);
          strlcpy(cmdPayload, buf, sizeof(cmdPayload));
          cmdInQueue = true;
          evalCmd();
        }
        if (confLog.logWebRequests)
        {
          String addr = httpServer.client().remoteIP().toString();
          char buf[40];
          sprintf(buf, "WEB: /conflog (from %s)", addr.c_str());
          sendLog(buf, LOGLEVEL_INFO);
        }
        httpServer.send(200, "text/plain", webLogBuffer);
      }
    });
    httpServer.on("/csapp.js", []() {
      httpServer.sendHeader("cache-control", "max-age=86400", false);
      httpServer.send_P(200, "text/javascript", js_csapp);
    });
  }
#endif


#ifdef ENABLE_FEATURE_HTTP_UPDATER
  httpUpdater.setup(&httpServer, "/update", confWeb.http_user, confWeb.http_pass);
#endif

  httpServer.begin();
}
# 1 "D:/Flo/git/WiFiThermostat/src/logging.ino"
void sendLog(const char *msg, uint8_t loglevel)
{
    char buf[200];
    char buf2[221];
    bool timeIsValid = false;
    strlcpy(buf, msg, sizeof(buf));

#ifdef ENABLE_FEATURE_NTP_TIME
    static char tbuf[20];
    if (confTime.ntpEnable)
    {
        updateTime();
        if (lt.tm_year > 70)
        {

            strftime(tbuf, sizeof(tbuf), "%H:%M:%S", &lt);
            sprintf(buf2, "[%s] %s\r\n", tbuf, buf);
            timeIsValid = true;
        }
    }
#endif

    if (!timeIsValid)
    {
        unsigned long tmpMillis;
        unsigned long tmpSecs;
        unsigned int restMillis;
        tmpMillis = millis();
        tmpSecs = tmpMillis / 1000;
        restMillis = tmpMillis - (tmpSecs * 1000);


        if (tmpSecs < 10000)
            sprintf(buf2, "[%04lu.%3u] %s\r\n", tmpSecs, restMillis, buf);
        else
            sprintf(buf2, "[%08lu] %s\r\n", tmpSecs, buf);
    }

    if (loglevel <= confLog.logLevelSerial)
        Serial.print(buf2);

    if (confMqtt.mqtt_enable && mqttclient.state() == 0)
    {
        if (loglevel <= confLog.logLevelMqtt)
            mqttclient.publish(confMqtt.mqtt_topic_out, buf, false);
    }

#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
    yield();
    if (confWeb.wsConsole && webSocket.connectedClients() > 0)
    {
        if (loglevel <= confLog.logLevelWeb)
            webSocket.broadcastTXT(buf2);
    }
#endif

#ifdef ENABLE_FEATURE_WEB_CONSOLE
    if (confWeb.wConsole && loglevel <= confLog.logLevelWeb)
    {
        char buf3[250];


        sprintf(buf3, "{%u}%s", webLogBuffer_index, buf2);
# 74 "D:/Flo/git/WiFiThermostat/src/logging.ino"
        bool done = false;
        while (!done)
        {
            int currSize = strlen(webLogBuffer);
            int addSize = strlen(buf3);
            int maxSize = sizeof(webLogBuffer) - 10;






            if ((currSize + addSize) >= maxSize)
            {




                int posMsg2 = 0;
                while (posMsg2 < currSize)
                {
                    if (webLogBuffer[posMsg2] == '\n')
                    {
                        posMsg2++;
                        break;
                    }
                    else
                        posMsg2++;
                }




                int oldSize = strlen(webLogBuffer);
                int c = 0;
                while (c < (oldSize - posMsg2))
                {
                    webLogBuffer[c] = webLogBuffer[posMsg2 + c];







                    c++;
                }
                webLogBuffer[c] = '\0';


            }
            else
            {
                done = true;

            }

        }

        if ((strlen(webLogBuffer) + strlen(buf3)) < (sizeof(webLogBuffer) - 10))
        {

            int c = 0;
            int offset = strlen(webLogBuffer);



            int size = strlen(buf3);
            while (c < size)
            {
                if ((c + offset) < (int)sizeof(webLogBuffer))
                {
                    webLogBuffer[c + offset] = buf3[c];
                    c++;
                }
                else
                    break;
            }
            webLogBuffer[c + offset] = '\0';




            webLogBuffer_index++;
        }
    }
#endif
}

void sendLog(const __FlashStringHelper *msg, uint8_t loglevel)
{
    char buf[201];
    PGM_P p = reinterpret_cast<PGM_P>(msg);
    size_t n = 0;
    while (1)
    {
        unsigned char c = pgm_read_byte(p++);
        if (c == 0)
        {
            buf[n] = c;
            break;
        }
        else if (n >= sizeof(buf) - 1)
        {
            break;
        }
        else
        {
            buf[n] = c;
            n++;
        }
    }
    sendLog(buf, loglevel);
}
# 1 "D:/Flo/git/WiFiThermostat/src/miscFunctions.ino"
# 25 "D:/Flo/git/WiFiThermostat/src/miscFunctions.ino"
void updateUptime()
{
  if (millis() >= 3000000000)
  {
    sysUptime.highMillis = 1;
  }
  if (millis() <= 100000 && sysUptime.highMillis == 1)
  {
    sysUptime.rollover++;
    sysUptime.highMillis = 0;
  }

  unsigned long secsUp = millis() / 1000;
  sysUptime.sec = secsUp % 60;
  sysUptime.min = (secsUp / 60) % 60;
  sysUptime.hour = (secsUp / (60 * 60)) % 24;
  sysUptime.day = (sysUptime.rollover * 50) + (secsUp / (60 * 60 * 24));
}

char* getUptimeStr(bool includeSeconds) {
  updateUptime();
  if(includeSeconds) {
    if(sysUptime.day == 0) sprintf(sysUptime.uptimeStr, "%02u:%02u:%02u", sysUptime.hour, sysUptime.min, sysUptime.sec);
    else sprintf(sysUptime.uptimeStr, "%ud %02u:%02u:%02u", sysUptime.day, sysUptime.hour, sysUptime.min, sysUptime.sec);
  }
  else {
    if(sysUptime.day == 0) sprintf(sysUptime.uptimeStr, "%02u:%02u", sysUptime.hour, sysUptime.min);
    else sprintf(sysUptime.uptimeStr, "%ud %02u:%02u", sysUptime.day, sysUptime.hour, sysUptime.min);
  }
  return sysUptime.uptimeStr;
}

void createDeviceName()
{
  byte mac[6];
  WiFi.macAddress(mac);
  sprintf(confDevWiFi.deviceName, "%s-%02X%02X", FIRMWARE_SHORTNAME, (uint8_t)mac[4], (uint8_t)mac[5]);
}

void restart()
{
  delay(100);


  ESP.wdtDisable();
  ESP.reset();
  delay(2000);
}

void logSysdata()
{
  char logBuf[101];
  sprintf_P(logBuf, "SYS:  uptime=%s, heapFree=%u, heapFragm=%u%%, heapMaxBlock=%u", getUptimeStr(true), ESP.getFreeHeap(), ESP.getHeapFragmentation(), ESP.getMaxFreeBlockSize());

  sendLog(logBuf, LOGLEVEL_INFO);
}

void printIpcfg() {
  char buf[100];
  byte mac[6];
  WiFi.macAddress(mac);
  sprintf(buf, "%s: SSID='%s', IP='%s', GW='%s', DNS='%s', MAC='%02X:%02X:%02X:%02X:%02X:%02X'", PGMStr_WiFi, WiFi.SSID().c_str(), WiFi.localIP().toString().c_str(), WiFi.gatewayIP().toString().c_str(), WiFi.dnsIP().toString().c_str(), (uint8_t)mac[0], (uint8_t)mac[1], (uint8_t)mac[2], (uint8_t)mac[3], (uint8_t)mac[4], (uint8_t)mac[5]);
  sendLog(buf, LOGLEVEL_INFO);
}
# 1 "D:/Flo/git/WiFiThermostat/src/mqtt.ino"


#define MQTT_RECONNECT_INTERVAL_3_TRIES 15000
#define MQTT_RECONNECT_INTERVAL_10_TRIES 60000
#define MQTT_RECONNECT_INTERVAL_LONG 300000

bool mqttHeartbeatReceived = false;


void mqttCallback(char *topic, unsigned char *payload, uint16_t length)
{
# 23 "D:/Flo/git/WiFiThermostat/src/mqtt.ino"
  if (strcmp(topic, mqtt_topic_in_cmd) == 0)
  {
    int len;
    if (length < sizeof(cmdPayload))
      len = length;
    else
      len = sizeof(cmdPayload) - 1;

    for (int i = 0; i < len; i++)
    {
      cmdPayload[i] = (char)payload[i];
    }

    cmdPayload[len] = '\0';
# 54 "D:/Flo/git/WiFiThermostat/src/mqtt.ino"
    if (strncmp(cmdPayload, "HEARTBEAT", 9) == 0)
    {
      mqttLastHeartbeat = millis();
      mqttHeartbeatReceived = true;
      mqttConnected = true;
    }
    else
    {
      cmdInQueue = true;
    }
  }

  if (strcmp(topic, mqtt_topic_in_setTemp) == 0)
  {
    int len;
    if (length < sizeof(cmdPayload))
      len = length;
    else
      len = sizeof(cmdPayload) - 1;

    for (int i = 0; i < len; i++)
    {
      cmdPayload[i] = (char)payload[i];
    }

    cmdPayload[len] = '\0';



    char tmpPayload[11];
    strlcpy(tmpPayload, cmdPayload, 10);

    float valueFloat;
    valueFloat = round(atof(tmpPayload) * 2.0) / 2.0;
    setTempTo(valueFloat);
# 105 "D:/Flo/git/WiFiThermostat/src/mqtt.ino"
    char buf[50];
    sprintf(buf, "MQTT IN: setTemp to %2.1f", valueFloat);
    sendLog(buf, LOGLEVEL_INFO);

    cmdInQueue = false;
  }

  if (strcmp(topic, mqtt_topic_in_setMode) == 0)
  {
    uint8_t len;

    if (length < sizeof(cmdPayload))
      len = length;
    else
      len = sizeof(cmdPayload) - 1;

    for (int i = 0; i < len; i++)
    {
      cmdPayload[i] = (char)payload[i];
    }

    cmdPayload[len] = '\0';



    char tmpPayload[21];
    strlcpy(tmpPayload, cmdPayload, sizeof(tmpPayload));
    strlwr(tmpPayload);

    unsigned char tmpHeatMode = 100;

    char tmpModename0[15];
    char tmpModename1[15];
    strlcpy(tmpModename0, confAdv.modeName0, sizeof(tmpModename0));
    strlcpy(tmpModename1, confAdv.modeName1, sizeof(tmpModename1));
    strlwr(tmpModename0);
    strlwr(tmpModename1);

    if (strcmp(tmpPayload, tmpModename0) == 0)
      tmpHeatMode = 0;
    else if (strcmp(tmpPayload, tmpModename1) == 0)
      tmpHeatMode = 1;
    else if (strcmp(tmpPayload, "off") == 0)
      tmpHeatMode = 0;
    else if (strcmp(tmpPayload, "aus") == 0)
      tmpHeatMode = 0;
    else if (strcmp(tmpPayload, "on") == 0)
      tmpHeatMode = 1;
    else if (strcmp(tmpPayload, "ein") == 0)
      tmpHeatMode = 1;
    else if (atoi(tmpPayload) == 0)
      tmpHeatMode = 0;
    else if (atoi(tmpPayload) == 1)
      tmpHeatMode = 1;

    if (tmpHeatMode == 0 || tmpHeatMode == 1)
    {
      setHeatingmodeTo(tmpHeatMode);
# 182 "D:/Flo/git/WiFiThermostat/src/mqtt.ino"
      char buf[50];
      sprintf(buf, "MQTT IN: setMode to %u", tmpHeatMode);
      sendLog(buf, LOGLEVEL_INFO);
    }

    cmdInQueue = false;
  }

  if (strcmp(topic, mqtt_topic_in_setPause) == 0)
  {
    uint8_t len;
    uint8_t _setTo = 255;

    if (length < sizeof(cmdPayload))
      len = length;
    else
      len = sizeof(cmdPayload) - 1;

    for (int i = 0; i < len; i++)
    {
      cmdPayload[i] = (char)payload[i];
    }

    cmdPayload[len] = '\0';



    char tmpPayload[21];
    strlcpy(tmpPayload, cmdPayload, sizeof(tmpPayload));
    strlwr(tmpPayload);


    if (strcmp(tmpPayload, "1") == 0) _setTo = 1;
    else if (strcmp(tmpPayload, "0") == 0) _setTo = 0;

    if(_setTo == 1 || _setTo == 0) {
      setHeatingPause(_setTo);
      char buf[50];
      sprintf(buf, "MQTT IN: setPause to %u", _setTo);
      sendLog(buf, LOGLEVEL_INFO);
    }

    cmdInQueue = false;
  }

  if (strcmp(topic, mqtt_topic_in_setPreset) == 0)
  {
    char tmpPayload[21];
    char tmpPresetName0[15];
    char tmpPresetName1[15];
    char tmpPresetName2[15];
    uint16_t len;
    unsigned char tmpPreset = 100;

    if (length < sizeof(cmdPayload))
      len = length;
    else
      len = sizeof(cmdPayload) - 1;

    for (unsigned char i = 0; i < len; i++)
    {
      cmdPayload[i] = (char)payload[i];
    }

    cmdPayload[len] = '\0';



    strlcpy(tmpPayload, cmdPayload, sizeof(tmpPayload));
    strlwr(tmpPayload);

    strlcpy(tmpPresetName0, confAdv.psetName0, sizeof(tmpPresetName0));
    strlcpy(tmpPresetName1, confAdv.psetName1, sizeof(tmpPresetName1));
    strlcpy(tmpPresetName2, confAdv.psetName2, sizeof(tmpPresetName2));
    strlwr(tmpPresetName0);
    strlwr(tmpPresetName1);
    strlwr(tmpPresetName2);

    if (strcmp(tmpPayload, tmpPresetName0) == 0)
      tmpPreset = 0;
    else if (strcmp(tmpPayload, tmpPresetName1) == 0)
      tmpPreset = 1;
    else if (strcmp(tmpPayload, tmpPresetName2) == 0)
      tmpPreset = 2;
    else if (strcmp(tmpPayload, "none") == 0)
      tmpPreset = 0;
    else if (strcmp(tmpPayload, "norm") == 0)
      tmpPreset = 0;
    else if (strcmp(tmpPayload, "red1") == 0)
      tmpPreset = 1;
    else if (strcmp(tmpPayload, "red2") == 0)
      tmpPreset = 2;
    else if (atoi(tmpPayload) == 0)
      tmpPreset = 0;
    else if (atoi(tmpPayload) == 1)
      tmpPreset = 1;
    else if (atoi(tmpPayload) == 2)
      tmpPreset = 2;

    if (tmpPreset <= 2)
    {
      setPresetTo(tmpPreset);
# 303 "D:/Flo/git/WiFiThermostat/src/mqtt.ino"
      char buf[50];
      sprintf(buf, "MQTT IN: setPreset to %s", cmdPayload);
      sendLog(buf, LOGLEVEL_INFO);
    }
    cmdInQueue = false;
  }

  if (strcmp(topic, confAdd.outTemp_topic_in) == 0)
  {
    int len;
    if (length < 6)
      len = length;
    else
      len = 5;
    for (int i = 0; i < len; i++)
    {
      outTemp_newValue[i] = (char)payload[i];
    }

    outTemp_newValue[len] = '\0';
    outTemp_parseNewValue = true;
  }

  if (strcmp(topic, confAdd.outHum_topic_in) == 0)
  {
    int len;
    if (length < 4)
      len = length;
    else
      len = 3;
    for (int i = 0; i < len; i++)
    {
      outHum_newValue[i] = (char)payload[i];
    }

    outHum_newValue[len] = '\0';
    outHum_parseNewValue = true;
  }

}

void mqttPrepareSubscribeTopics()
{

  sprintf(mqtt_topic_in_cmd, "%s/%s", confMqtt.mqtt_topic_in, "cmd");
  sprintf(mqtt_topic_in_setTemp, "%s/%s", mqtt_topic_in_cmd, "setTemp");
  sprintf(mqtt_topic_in_setMode, "%s/%s", mqtt_topic_in_cmd, "setMode");
  sprintf(mqtt_topic_in_setPreset, "%s/%s", mqtt_topic_in_cmd, "setPreset");
  sprintf(mqtt_topic_in_setPause, "%s/%s", mqtt_topic_in_cmd, "setPause");
}

bool mqttReconnect(void)
{
  mqttclient.disconnect();
  delay(10);


  String mqttClientId = FIRMWARE_SHORTNAME;
  mqttClientId += "-";

  mqttClientId += String(confDevWiFi.deviceName);






  boolean connRes;
  mqttReconnectAttempts++;
  char connectMode[20];

  if (strlen(confMqtt.mqtt_user) > 0 && strlen(confMqtt.mqtt_willTopic) == 0)
  {



    strlcpy(connectMode, "Auth, no LWT", sizeof(connectMode));
    connRes = mqttclient.connect(mqttClientId.c_str(), confMqtt.mqtt_user, confMqtt.mqtt_pass);
  }
  else if (strlen(confMqtt.mqtt_user) > 0 && strlen(confMqtt.mqtt_willTopic) > 0)
  {



    strlcpy(connectMode, "Auth and LWT", sizeof(connectMode));
    connRes = mqttclient.connect(mqttClientId.c_str(), confMqtt.mqtt_user, confMqtt.mqtt_pass, confMqtt.mqtt_willTopic, confMqtt.mqtt_willQos, confMqtt.mqtt_willRetain, confMqtt.mqtt_willMsg);
  }
  else if (strlen(confMqtt.mqtt_user) == 0 && strlen(confMqtt.mqtt_willTopic) > 0)
  {



    strlcpy(connectMode, "LWT, no Auth", sizeof(connectMode));
    connRes = mqttclient.connect(mqttClientId.c_str(), confMqtt.mqtt_willTopic, confMqtt.mqtt_willQos, confMqtt.mqtt_willRetain, confMqtt.mqtt_willMsg);
  }
  else
  {



    strlcpy(connectMode, "no Auth, no LWT", sizeof(connectMode));
    connRes = mqttclient.connect(mqttClientId.c_str());
  }
# 414 "D:/Flo/git/WiFiThermostat/src/mqtt.ino"
  char logBuf[70];
  sprintf(logBuf, "MQTT: connecting to %s:%u w/ %s, attempt: %u", confMqtt.mqtt_server, confMqtt.mqtt_port, connectMode, mqttReconnectAttempts);
  sendLog(logBuf, LOGLEVEL_INFO);

  if (connRes)
  {
# 430 "D:/Flo/git/WiFiThermostat/src/mqtt.ino"
    mqttConnected = true;
    mqttReconnects++;
    mqttOnConnect();



    sendLog("MQTT: subscribed topics:", LOGLEVEL_INFO);

    if (strlen(mqtt_topic_in_cmd) > 0)
    {
      char mqtt_topic_in_subscribe[52];
      sprintf(mqtt_topic_in_subscribe, "%s/%s", mqtt_topic_in_cmd, "#");
      if (mqttclient.subscribe(mqtt_topic_in_subscribe))
      {




        char buf[60];
        sprintf(buf, "      %s", mqtt_topic_in_subscribe);
        sendLog(buf, LOGLEVEL_INFO);
        mqttInTopicSubscribed = true;
      }
    }
    if (strlen(confAdd.outTemp_topic_in) > 0)
    {
      if (mqttclient.subscribe(confAdd.outTemp_topic_in))
      {




        char buf[60];
        sprintf(buf, "      %s", confAdd.outTemp_topic_in);
        sendLog(buf, LOGLEVEL_INFO);
      }
    }
    if (strlen(confAdd.outHum_topic_in) > 0)
    {
      if (mqttclient.subscribe(confAdd.outHum_topic_in))
      {




        char buf[60];
        sprintf(buf, "      %s", confAdd.outHum_topic_in);
        sendLog(buf, LOGLEVEL_INFO);
      }
    }
    mqttReconnectAttempts = 0;
    return mqttclient.connected();
  }
  else
  {
    int mqttConnRes = mqttclient.state();
    char logBuf[70];
    mqtt_updateCurrentStateName();
    sprintf_P(logBuf, "%s: %s, rc=%d (%s)", PGMStr_MQTT, PGMStr_connectedFailed, mqttConnRes, mqttCurrentStateName);
    sendLog(logBuf, LOGLEVEL_INFO);

    if (mqttReconnectAttempts >= 3 && (mqttConnRes == 4 || mqttConnRes == 5))
    {

      mqtt_tempDisabled_credentialError = true;
      if (confLog.logLevelSerial >= LOGLEVEL_VERBOSE)
      {

        sendLog(F("MQTT disabled until reboot due to credential error"), LOGLEVEL_ERROR);
      }
    }
    mqttConnected = false;
    mqttOnDisconnect();
    return mqttclient.connected();
  }
}

void mqttClientInit()
{
  if (confMqtt.mqtt_enable)
  {
    mqttclient.setServer(confMqtt.mqtt_server, confMqtt.mqtt_port);
    mqttclient.setCallback(mqttCallback);
    mqttLastReconnectAttempt = 0;
    mqttReconnectAttempts = 0;
    mqtt_tempDisabled_credentialError = false;
  }
}

int lastWifiStatus;

void mqttHandleConnection()
{
  if (mqttHeartbeatReceived)
  {
    mqttHeartbeatReceived = false;
    sendLog(F("MQTT: received HEARTBEAT - resetting timer..."), LOGLEVEL_VERBOSE);
  }

  int currWifiStatus = WiFi.status();
  if (currWifiStatus != lastWifiStatus)
  {
    lastWifiStatus = currWifiStatus;


  }

  if (confMqtt.mqtt_enable && !mqtt_tempDisabled_credentialError && currWifiStatus == WL_CONNECTED)
  {

    boolean doReconnect = false;
    if (!mqttclient.connected())
      doReconnect = true;

    if (mqttInTopicSubscribed && confMqtt.mqtt_heartbeat_maxage_reconnect > 0)
    {
      if (confMqtt.mqtt_enable_heartbeat && confMqtt.mqtt_heartbeat_maxage_reconnect > 0 && ((millis() - mqttLastHeartbeat) > confMqtt.mqtt_heartbeat_maxage_reconnect))
      {
        doReconnect = true;
        mqttConnected = false;
        mqttLastHeartbeat = millis();

        sendLog(F("MQTT: HEARTBEAT overdue. Force-Reconnecting MQTT..."), LOGLEVEL_WARN);
      }
    }

    if (doReconnect)
    {
      unsigned long mqttReconnectAttemptDelay;
      if (mqttReconnectAttempts < 3)
        mqttReconnectAttemptDelay = MQTT_RECONNECT_INTERVAL_3_TRIES;
      else if (mqttReconnectAttempts < 10)
        mqttReconnectAttemptDelay = MQTT_RECONNECT_INTERVAL_10_TRIES;
      else
        mqttReconnectAttemptDelay = MQTT_RECONNECT_INTERVAL_LONG;

      if (confMqtt.mqtt_enable_heartbeat && confMqtt.mqtt_heartbeat_maxage_reboot > 0 && ((millis() - mqttLastHeartbeat) > confMqtt.mqtt_heartbeat_maxage_reboot))
      {


        sendLog(F("MQTT: HEARTBEAT_MAXAGE_REBOOT overdue. Restarting..."), LOGLEVEL_WARN);
        restart();
      }

      if ((millis() - mqttLastReconnectAttempt) > mqttReconnectAttemptDelay)
      {
        mqttLastReconnectAttempt = millis();



        mqttReconnect();
      }
      mqttclient.loop();
    }
    else
    {
      mqttclient.loop();
    }
  }
}

void mqttPublishStatus()
{
  if (confMqtt.mqtt_enable && mqttclient.state() == 0)
  {
    char outMsg[60];
    sprintf_P(outMsg, "%s: %s: %s:%u, %s: %d", PGMStr_MQTT, PGMStr_connectedTo, confMqtt.mqtt_server, confMqtt.mqtt_port, PGMStr_reconnects, mqttReconnects - 1);

    sendLog(outMsg, LOGLEVEL_INFO);
  }
}

void mqttOnConnect()
{
  mqttPublishConnectMsg();
  mqttPublishStatus();
  displayShowMQTTConnected();
}

void mqttOnDisconnect()
{
  displayShowMQTTConnectionError();
}

void mqttPublishConnectMsg()
{
  if (strlen(confMqtt.mqtt_willTopic) > 4)
  {
    if (confMqtt.mqtt_enable && mqttclient.state() == 0)
    {
      mqttclient.publish(confMqtt.mqtt_willTopic, confMqtt.mqtt_connMsg, confMqtt.mqtt_willRetain);

    }
  }
}

void mqttPublishHeartbeat()
{
  if (confMqtt.mqtt_enable && confMqtt.mqtt_enable_heartbeat && mqttclient.state() == 0)
  {
    mqttclient.publish(mqtt_topic_in_cmd, "HEARTBEAT", false);
  }
}

void mqtt_updateCurrentStateName()
{
  if (confMqtt.mqtt_enable)
  {
    sprintf_P(mqttCurrentStateName, "%s", PGMStr_MQTTStates[mqttclient.state() + 4]);
  }
  else
    sprintf_P(mqttCurrentStateName, "%s", PGMStr_MQTTState_DIS);
}

void mqttResetConnection()
{
  sendLog(F("MQTT: resetting connection..."));
  if (!confMqtt.mqtt_enable)
    mqttclient.disconnect();
  else
  {
    mqttclient.disconnect();
    mqttPrepareSubscribeTopics();
    mqttClientInit();
  }
  configChangedMqttConnResetRequired = false;
}
# 1 "D:/Flo/git/WiFiThermostat/src/mqtt_out.ino"

float setTemp_lastPublished;
float currSetTemp_lastPublished;
int heatingMode_lastPublished;
int preset_lastPublished;
bool turnHeatingOn_lastPublished;

void publishCurrentThermostatValues(bool force = false)
{


  char tmp_topic_out[50];
  char ch_valuebuf[7];

  updateCurrentHeatingModeName();
  updateCurrentPresetName();

  char logBuf[101];
  sprintf_P(logBuf, "%s: %s=%u, %s=%u, %s=%2.1f, %s=%2.1f", PGMStr_thermostat, PGMStr_heatingMode, heatingMode, PGMStr_preset, preset, PGMStr_setTemp, setTemp, PGMStr_currentSetTemp, currSetTemp);
  sendLog(logBuf, LOGLEVEL_INFO);

  if (force || !confBas.saveToMqttRetained || setTemp != setTemp_lastPublished)
  {
    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "setTemp");
    sprintf(ch_valuebuf, "%2.1f", setTemp);
    mqttclient.publish(tmp_topic_out, ch_valuebuf, confMqtt.mqtt_outRetain);

    if (confBas.saveToMqttRetained && setTemp != setTemp_lastPublished)
    {

      mqttclient.publish(mqtt_topic_in_setTemp, ch_valuebuf, true);
      char buf1[30];
      sprintf_P(buf1, "%s %s %2.1f", PGMStr_mqttRetainedSave, PGMStr_setTemp, setTemp);
      sendLog(buf1);
    }

    setTemp_lastPublished = setTemp;
    yield();
  }

  if (force || currSetTemp != currSetTemp_lastPublished || !confMqtt.mqtt_outRetain)
  {
    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "currSetTemp");
    sprintf(ch_valuebuf, "%2.1f", currSetTemp);
    mqttclient.publish(tmp_topic_out, ch_valuebuf, confMqtt.mqtt_outRetain);

    currSetTemp_lastPublished = currSetTemp;
    yield();
  }

  if (force || !confBas.saveToMqttRetained || heatingMode != heatingMode_lastPublished)
  {
    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "mode");
    char ch_heatingMode[3];
    sprintf(ch_heatingMode, "%d", heatingMode);
    mqttclient.publish(tmp_topic_out, ch_heatingMode, confMqtt.mqtt_outRetain);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "modeName");
    mqttclient.publish(tmp_topic_out, currentModeName, confMqtt.mqtt_outRetain);

    if (confBas.saveToMqttRetained && heatingMode != heatingMode_lastPublished)
    {

      mqttclient.publish(mqtt_topic_in_setMode, ch_heatingMode, true);
      char buf1[30];
      sprintf_P(buf1, "%s %s %u", PGMStr_mqttRetainedSave, PGMStr_heatingMode, heatingMode);
      sendLog(buf1);

    }

    heatingMode_lastPublished = heatingMode;
    yield();
  }

  if (force || !confBas.saveToMqttRetained || preset != preset_lastPublished)
  {
    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "preset");
    char ch_preset[3];
    sprintf(ch_preset, "%d", preset);
    mqttclient.publish(tmp_topic_out, ch_preset, confMqtt.mqtt_outRetain);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "presetName");
    mqttclient.publish(tmp_topic_out, currentPresetName, confMqtt.mqtt_outRetain);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "presetHA");
    if (preset == 0)
      mqttclient.publish(tmp_topic_out, "norm", confMqtt.mqtt_outRetain);
    else if (preset == 1)
      mqttclient.publish(tmp_topic_out, "red1", confMqtt.mqtt_outRetain);
    else if (preset == 2)
      mqttclient.publish(tmp_topic_out, "red2", confMqtt.mqtt_outRetain);

    if (confBas.saveToMqttRetained && preset != preset_lastPublished)
    {

      mqttclient.publish(mqtt_topic_in_setPreset, ch_preset, true);
      char buf1[30];
      sprintf_P(buf1, "%s %s %u", PGMStr_mqttRetainedSave, PGMStr_preset, preset);
      sendLog(buf1);
    }

    preset_lastPublished = preset;
    yield();
  }

  yield();


  char ch_turnHeatingOn[5];
  unsigned int currOnOffTime;
  if (turnHeatingOn)
  {
    strcpy(ch_turnHeatingOn, "on");
    currOnOffTime = heatingOnTime;
  }
  else
  {
    strcpy(ch_turnHeatingOn, "off");
    currOnOffTime = heatingOffTime;
  }
  if (force || turnHeatingOn != turnHeatingOn_lastPublished)
  {
    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heating");
    mqttclient.publish(tmp_topic_out, ch_turnHeatingOn, confMqtt.mqtt_outRetain);
    turnHeatingOn_lastPublished = turnHeatingOn;
  }




  sprintf_P(logBuf, "%s: %s=%s (%s)", PGMStr_thermostat, PGMStr_heating, ch_turnHeatingOn, getTimeStringFromSeconds(currOnOffTime));
  sendLog(logBuf, LOGLEVEL_INFO);


  yield();

  char _buf[21];

  sprintf(_buf, "%lu", heatingOnTime);
  sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heatingOnTime");
  mqttclient.publish(tmp_topic_out, _buf);

  sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heatingOnTime_Hms");
  mqttclient.publish(tmp_topic_out, getTimeStringFromSeconds(heatingOnTime));
  yield();

  sprintf(_buf, "%lu", heatingOffTime);
  sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heatingOffTime");
  mqttclient.publish(tmp_topic_out, _buf);
  sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heatingOffTime_Hms");
  mqttclient.publish(tmp_topic_out, getTimeStringFromSeconds(heatingOffTime));

  publish_heatingLockTime();
  publish_heatingPauseTime();

  yield();
}

void publish_heatingLockTime() {
  char _tmp_topic_out[50];
  char _buf[21];
  sprintf(_buf, "%i", heatingLockTime);
  sprintf(_tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heatingLockTime");
  mqttclient.publish(_tmp_topic_out, _buf);
}

void publish_heatingPauseTime() {
  char _tmp_topic_out[50];
  char _buf[21];
  sprintf(_buf, "%i", heatingPause);
  sprintf(_tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heatingPause");
  mqttclient.publish(_tmp_topic_out, _buf);
}


float currTemp_lastPublished;
int currHum_lastPublished;


void publishCurrentSensorValues(bool force = false)
{
  if (lastTempUpdate != 0 && (millis() - lastTempUpdate) < 120000)
  {
    char tmp_topic_out[50];

    char temp_chararr[6];
    char hum_chararr[4];
    dtostrf(currTemp, 1, 1, temp_chararr);
    sprintf(hum_chararr, "%2i", currHum);
# 198 "D:/Flo/git/WiFiThermostat/src/mqtt_out.ino"
    if (force || currTemp != currTemp_lastPublished)
    {
      sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "temp");
      mqttclient.publish(tmp_topic_out, temp_chararr, confMqtt.mqtt_outRetain_sensors);
      currTemp_lastPublished = currTemp;
      yield();
    }







    if (force || currHum != currHum_lastPublished)
    {
      sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "hum");
      mqttclient.publish(tmp_topic_out, hum_chararr, confMqtt.mqtt_outRetain_sensors);
      yield();
    }

    dtostrf(currTemp_raw, 1, 1, temp_chararr);
    sprintf(hum_chararr, "%2i", currHum_raw);






    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "temp_raw");
    mqttclient.publish(tmp_topic_out, temp_chararr);
    yield();





    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "hum_raw");
    mqttclient.publish(tmp_topic_out, hum_chararr);
    yield();




    char logBuf[101];
    sprintf_P(logBuf, "SENS: temp=%2.1f, hum=%u, tempRaw=%2.1f, humRaw=%u", currTemp, currHum, currTemp_raw, currHum_raw);
    sendLog(logBuf, LOGLEVEL_INFO);
  }
}

void publishCurrentPIRValue()
{
  char tmp_topic_out[50];
  sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "PIR");


  if (PIRSensorOn)
  {
    mqttclient.publish(tmp_topic_out, confAdd.mqtt_payload_pir_on);
    sendLog("SENS: PIR=ON", LOGLEVEL_INFO);
  }
  else
  {
    mqttclient.publish(tmp_topic_out, confAdd.mqtt_payload_pir_off);
    sendLog("SENS: PIR=OFF", LOGLEVEL_INFO);
  }


  if (strlen(confAdd.mqtt_topic_pir) >= 4)
  {
    if (PIRSensorOn)
    {
      mqttclient.publish(confAdd.mqtt_topic_pir, confAdd.mqtt_payload_pir_on);
    }
    else
    {
      mqttclient.publish(confAdd.mqtt_topic_pir, confAdd.mqtt_payload_pir_off);
    }
  }
}

void publishDeleteRetainedSavedStates()
{



  if (!confBas.saveToMqttRetained)
  {
    mqttclient.publish(mqtt_topic_in_setTemp, "", true);
    mqttclient.publish(mqtt_topic_in_setMode, "", true);
    mqttclient.publish(mqtt_topic_in_setPreset, "", true);

    sendLog("MQTT: deleted retained saved states", LOGLEVEL_INFO);

    publishCurrentThermostatValues(true);
  }
}

void publishDeleteRetainedOutMessages()
{



  if (!confMqtt.mqtt_outRetain)
  {
    char tmp_topic_out[50];
    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "setTemp");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "currSetTemp");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "mode");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "modeName");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "preset");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "presetName");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "presetHA");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heating");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heatingOnTime");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "heatingOffTime");
    mqttclient.publish(tmp_topic_out, "", true);

    sendLog("MQTT: deleted retained messages (states)", LOGLEVEL_INFO);

    publishCurrentThermostatValues(true);
  }
}

void publishDeleteRetainedOutMessages_sensors()
{



  if (!confMqtt.mqtt_outRetain)
  {
    char tmp_topic_out[50];
    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "temp");
    mqttclient.publish(tmp_topic_out, "", true);

    sprintf(tmp_topic_out, "%s/%s", confMqtt.mqtt_topic_out, "hum");
    mqttclient.publish(tmp_topic_out, "", true);

    sendLog("MQTT: deleted retained messages (sensors)", LOGLEVEL_INFO);

    publishCurrentSensorValues(true);
  }
}
# 1 "D:/Flo/git/WiFiThermostat/src/outTempHum.ino"






void outTempHum_updateOnNewValue() {
  if(outTemp_parseNewValue) outTemp_update();
  if(outHum_parseNewValue) outHum_update();
}

void outTemp_update() {
  outTemp = atof(outTemp_newValue);
  outTempHumLastUpdate = millis();

  char buf[40];
  sprintf(buf, "MQTT: received OUTTemp=%2.1f", outTemp);
  sendLog(buf, LOGLEVEL_INFO);


  outTemp_parseNewValue = false;
}

void outHum_update() {
  outHum = atoi(outHum_newValue);
  outTempHumLastUpdate = millis();
  char buf[40];
  sprintf(buf, "MQTT: received OUTHum=%u", outHum);
  sendLog(buf, LOGLEVEL_INFO);


  outHum_parseNewValue = false;
}
# 1 "D:/Flo/git/WiFiThermostat/src/scheduler.ino"

void checkMillis()
{
  if ((millis() - lastRun) >= 100)
  {
    lastRun = millis();
    every100ms();
  }
}

void every100ms()
{
  if (count100ms < 10)
    count100ms++;
  else
  {
    count100ms = 0;
    everySecond();
  }

}

void everySecond()
{
  if (countSeconds < 60)
    countSeconds++;
  else
  {
    countSeconds = 0;
    everyMinute();
  }

  confChangedLogNote(false);
# 42 "D:/Flo/git/WiFiThermostat/src/scheduler.ino"
  handleDisplayTimeout();
  checkValuesChanged();
  if (sysInfoEverySecond)
    logSysdata();

#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS
  clearValidSessionId();
#endif

  if (countMeasureInterval < confBas.measureInterval)
    countMeasureInterval++;
  else
  {
    countMeasureInterval = 0;
    measureTempHum();
    thermostat();
  }

  if(heatingPause > 0) {
    heatingPause--;
    publish_heatingPauseTime();
  }

  if(heatingLockTime > 0) {
    heatingLockTime--;
    publish_heatingLockTime();
  }

  if (countDisplayInterval < confBas.displayInterval)
    countDisplayInterval++;
  else
  {
    countDisplayInterval = 0;
    updateDisplay();
  }

  if (doRestart)
    restart();

  if (configChangedMqttConnResetRequired && !confCheckUnsaved())
  {
    configChangedMqttConnResetRequired = false;
    mqttResetConnection();
  }

  if ((millis() - pendingRestart_lastMillis) > 3000)
    pendingRestart = false;






}

unsigned int outPubInterval_states_count = 0;
unsigned int outPubInterval_sensors_count = 0;

void everyMinute()
{
#ifdef ENABLE_FEATURE_NTP_TIME
  if (confTime.ntpEnable)
  {
    syncClock();
  }
#endif

  logSysdata();

  confChangedLogNote(true);

  if (confMqtt.mqtt_enable)
  {

    if (!confMqtt.mqtt_willRetain)
      mqttPublishConnectMsg();

    mqttPublishStatus();

    if (confMqtt.mqtt_enable_heartbeat)
      mqttPublishHeartbeat();

    if (confMqtt.mqtt_outPubInterval > 0 && outPubInterval_states_count >= confMqtt.mqtt_outPubInterval)
    {
      outPubInterval_states_count = 0;
      publishCurrentThermostatValues(true);
    }
    else
    {
      outPubInterval_states_count++;
      publishCurrentThermostatValues(false);
    }

    if (confMqtt.mqtt_outPubInterval_sensors > 0 && outPubInterval_sensors_count >= confMqtt.mqtt_outPubInterval_sensors)
    {
      outPubInterval_sensors_count = 0;
      publishCurrentSensorValues(true);
    }
    else
    {
      outPubInterval_sensors_count++;
      publishCurrentSensorValues(false);
    }
  }
}
# 1 "D:/Flo/git/WiFiThermostat/src/thermostat.ino"

float tmpHum, tmpTemp;
int DHTreadRetries = 2;


void readDHTsensorTemp() {

  tmpTemp = dht.readTemperature();
}
void readDHTsensorHum() {

  tmpHum = dht.readHumidity();
}

void measureTempHum() {

  for (int i = 0; i < DHTreadRetries; i++) {
    readDHTsensorTemp();
    if (!isnan(tmpTemp)) {
      sendLog(F("DHT: reading Temp OK"), LOGLEVEL_VERBOSE);
      i = DHTreadRetries;
    }
    else {
      sendLog(F("DHT: reading Temp failed - retrying.."), LOGLEVEL_INFO);
    }
  }

  for (int i = 0; i < DHTreadRetries; i++) {
    readDHTsensorHum();
    if (!isnan(tmpHum)) {
      sendLog(F("DHT: reading Hum OK"), LOGLEVEL_VERBOSE);
      i = DHTreadRetries;
    }
    else {
      sendLog(F("DHT: reading Hum failed - retrying.."), LOGLEVEL_INFO);
    }
  }


  if (isnan(tmpHum) || isnan(tmpTemp)) {

    sendLog(F("Error: Failed to read from DHT sensor!"), LOGLEVEL_ERROR);
  }
  else {
    tmpTemp = tmpTemp + confAdv.tempCorrVal;
    tmpHum = round(tmpHum) + confAdv.humCorrVal;
    int tmpHumInt = tmpHum;
    if (tmpTemp < 50.0 && tmpTemp > -20.0) {

      currTemp_raw = tmpTemp;
      currHum_raw = tmpHumInt;

      if ( lastTempUpdate > 0 && tmpTemp <= ( currTemp + 2.0 ) && tmpTemp >= ( currTemp - 2.0 ) ) {



        currTemp = (currTemp * 9 + tmpTemp) / 10;
        currHum = (currHum * 9 + tmpHumInt) / 10;
        lastTempUpdate = millis();
      }
      else if ( lastTempUpdate == 0 || (millis() - lastTempUpdate) > maxMeasurementAge ) {

        currTemp = tmpTemp + confAdv.tempCorrVal;
        currHum = tmpHumInt + confAdv.humCorrVal;
        lastTempUpdate = millis();

      }
# 76 "D:/Flo/git/WiFiThermostat/src/thermostat.ino"
    }
  }
}

void updateCurrSetTemp() {

  if (heatingMode > 0) {
    if (preset == 0) {
      currSetTemp = setTemp;
      currActualSetTemp = setTemp - confAdv.setTempDecreaseVal;
    }
    else if (preset == 1) {
      currSetTemp = setTempLow;
      currActualSetTemp = setTempLow - confAdv.setTempDecreaseVal;
    }
    else if (preset == 2) {
      currSetTemp = setTempLow2;
      currActualSetTemp = setTempLow2 - confAdv.setTempDecreaseVal;
    }
  }
  else {
    currSetTemp = DEFAULT_SETTEMP_HEATOFF;
    currActualSetTemp = currSetTemp;
  }
}

void thermostat() {
  updateCurrSetTemp();

  if (heatingMode > 0 && turnHeatingOn) {
    heatingOnTime = (millis() - heatingLastOnMillis) / 1000;




  }
  else if (heatingMode > 0 && !turnHeatingOn) {
    if(heatingLastOnMillis > 0) {

      heatingOffTime = (millis() - heatingLastOffMillis) / 1000;
    }




  }





  if ( lastTempUpdate != 0 && (millis() - lastTempUpdate) <= maxMeasurementAge ) {


#ifdef DEBUG_VERBOSE
    Serial.print("thermostat, lastTempUpdate=");
    Serial.print(lastTempUpdate);
    Serial.print(", lastTempUpdate_delta=");
    long lastTempUpdateDelta = millis() - lastTempUpdate;
    Serial.println(lastTempUpdateDelta);
#endif


    if ( turnHeatingOn && currTemp >= currActualSetTemp ) {
      turnHeatingOn = false;
      heatingLastOffMillis = millis();
      heatingLockTime = confAdv.heatingMinOffTime;
      digitalWrite(PIN_RELAIS, !RELAISONSTATE);
      updateDisplay();

      char buf[101];
      sprintf_P(buf, "TSTAT: %s OFF, on for %lus", PGMStr_switchHeating, heatingOnTime);
      sendLog(buf, LOGLEVEL_INFO);



      publishCurrentThermostatValues();
    }
    else if ( !turnHeatingOn && heatingMode > 0 && heatingLockTime == 0 && heatingPause == 0 && ( currTemp < (currActualSetTemp - confAdv.hysteresis) ) ) {
      if ( heatingOffTime > confAdv.heatingMinOffTime || heatingLastOnMillis == 0) {
        turnHeatingOn = true;


        heatingLastOnMillis = millis();
        digitalWrite(PIN_RELAIS, RELAISONSTATE);
        updateDisplay();

        char buf[101];
        sprintf(buf, "TSTAT: switch heating ON, off for %lus", heatingOffTime);
        sendLog(buf, LOGLEVEL_INFO);



        publishCurrentThermostatValues();
      }






    }
    else if (heatingPause > 0) {
      turnHeatingOn = false;
      heatingLastOffMillis = millis();
      digitalWrite(PIN_RELAIS, !RELAISONSTATE);
      updateDisplay();
    }
  }
  else {

    if (turnHeatingOn) {
      digitalWrite(PIN_RELAIS, !RELAISONSTATE);
      turnHeatingOn = false;
      heatingLastOffMillis = millis();
    }

    if ( lastTempUpdate != 0 ) sendLog(F("TSTAT: heating OFF, temp reading not yet available"), LOGLEVEL_INFO);
    else if ( (millis() - lastTempUpdate) > maxMeasurementAge ) sendLog(F("TSTAT: heating OFF, last temp reading too old"), LOGLEVEL_WARN);


    publishCurrentThermostatValues();
  }

}

void toggleOnOff() {
  if (heatingMode > 0) {
    heatingMode = 0;
    heatingPause = 0;
    heatingLockTime = 0;
    lastValueChange = millis();
    heatingModeAlreadySaved = false;
  }
  else {
    heatingMode = 1;
    heatingPause = 0;
    heatingLockTime = 0;
    lastValueChange = millis();
    heatingModeAlreadySaved = false;
  }
  updateCurrentHeatingModeName();
  updateDisplay();
}

void togglePreset() {

  if (pendingPreset < 0 || pendingPreset > 2) pendingPreset = preset;
# 235 "D:/Flo/git/WiFiThermostat/src/thermostat.ino"
  if(preset == 0) {
    if (pendingPreset == 0) pendingPreset = 1;
    else if (pendingPreset == 1) pendingPreset = 2;
    else if (pendingPreset == 2) pendingPreset = 0;
  }
  else if(preset == 1) {
    if (pendingPreset == 1) pendingPreset = 0;
    else if (pendingPreset == 0) pendingPreset = 2;
    else if (pendingPreset == 2) pendingPreset = 1;
  }
  else if(preset == 2) {
    if (pendingPreset == 2) pendingPreset = 0;
    else if (pendingPreset == 0) pendingPreset = 1;
    else if (pendingPreset == 1) pendingPreset = 2;
  }
# 263 "D:/Flo/git/WiFiThermostat/src/thermostat.ino"
  lastValueChange = millis();
  presetAlreadySaved = false;

  updatePendingPresetName();


  displayShowLine2OverlayMessage(pendingPresetName);




}

void updateCurrentHeatingModeName() {
  if (heatingMode == 0) strlcpy(currentModeName, confAdv.modeName0, 14);
  else if (heatingMode == 1) strlcpy(currentModeName, confAdv.modeName1, 14);
}

void updateCurrentPresetName() {
  if (preset == 0) strlcpy(currentPresetName, confAdv.psetName0, 14);
  else if (preset == 1) strlcpy(currentPresetName, confAdv.psetName1, 14);
  else if (preset == 2) strlcpy(currentPresetName, confAdv.psetName2, 14);
}

void updatePendingPresetName() {
  if (pendingPreset == 0) strlcpy(pendingPresetName, confAdv.psetName0, 14);
  else if (pendingPreset == 1) strlcpy(pendingPresetName, confAdv.psetName1, 14);
  else if (pendingPreset == 2) strlcpy(pendingPresetName, confAdv.psetName2, 14);
}

void setTempStepUp() {
  if (heatingMode == 1) {
    sendLog(F("TSTAT: setTemp +0.5"));
    if ( setTemp <= (confBas.setTempMax - 0.5)) {
      setTemp += 0.5;
      lastValueChange = millis();
      setTempAlreadySaved = false;
    }
    updateDisplay();
  }
}

void setTempStepDown() {
  if (heatingMode == 1) {
    sendLog(F("TSTAT: setTemp -0.5"));
    if ( setTemp >= (confBas.setTempMin + 0.5)) {
      setTemp -= 0.5;
      lastValueChange = millis();
      setTempAlreadySaved = false;
    }
    updateDisplay();
  }
}

void setTempTo(float setTo) {
  boolean changes = false;
  float tmpSetTemp;
  if(setTo != setTemp) {
    if (setTo >= confBas.setTempMin && setTo <= confBas.setTempMax) {
      tmpSetTemp = setTo;
      changes = true;
    }
    else if (setTo > confBas.setTempMax) {
      tmpSetTemp = confBas.setTempMax;
      changes = true;
    }
    else if (setTo < confBas.setTempMin) {
      tmpSetTemp = confBas.setTempMin;
      changes = true;
    }
    if (changes) {
        setTemp = tmpSetTemp;
        lastValueChange = millis();
        setTempAlreadySaved = false;
        updateDisplay();
        publishCurrentThermostatValues();

        char buf1[30];

        sprintf_P(buf1, "%s: %s %s %2.1f", PGMStr_thermostat, PGMStr_setTemp, PGMStr_changedTo, setTemp);

        sendLog(buf1);
      }
    }
}

void setTempLowStepUp() {
  sendLog(F("TSTAT: setTempLow +0.5"));
  if ( setTempLow <= (setTempLowMax - 0.5)) {
    setTempLow += 0.5;
    lastValueChange = millis();
    setTempLowAlreadySaved = false;
  }
  updateDisplay();
}

void setTempLowStepDown() {
  sendLog(F("TSTAT: setTempLow -0.5"));
  if ( setTempLow >= (setTempLowMin + 0.5)) {
    setTempLow -= 0.5;
    lastValueChange = millis();
    setTempLowAlreadySaved = false;
  }
  updateDisplay();
}

void setTempLowTo(float setTo) {
  boolean changes = false;
  float tmp_setTempLow;
  if(setTo != setTempLow) {
    if (setTo >= setTempLowMin && setTo <= setTempLowMax) {
      tmp_setTempLow = setTo;
      changes = true;
    }
    else if (setTo > setTempLowMax) {
      tmp_setTempLow = setTempLowMax;
      changes = true;
    }
    else if (setTo < setTempLowMin) {
      tmp_setTempLow = setTempLowMin;
      changes = true;
    }
    if (changes) {
      setTempLow = tmp_setTempLow;
      lastValueChange = millis();
      setTempLowAlreadySaved = false;
      updateDisplay();
      publishCurrentThermostatValues();


      char buf1[30];

      sprintf_P(buf1, "%s: %s %s %2.1f", PGMStr_thermostat, PGMStr_setTempLow, PGMStr_changedTo, setTempLow);
      sendLog(buf1);
    }
  }
}

void setTempLow2StepUp() {
  sendLog(F("TSTAT: setTempLow2 +0.5"));
  if ( setTempLow2 <= (setTempLowMax - 0.5)) {
    setTempLow2 += 0.5;
    lastValueChange = millis();
    setTempLow2AlreadySaved = false;
  }
  updateDisplay();
}

void setTempLow2StepDown() {
  sendLog(F("TSTAT: setTempLow2 -0.5"));
  if ( setTempLow2 >= (setTempLowMin + 0.5)) {
    setTempLow2 -= 0.5;
    lastValueChange = millis();
    setTempLow2AlreadySaved = false;
  }
  updateDisplay();
}

void setTempLow2To(float setTo) {
  boolean changes = false;
  float tmp_setTempLow2;
  if(setTo != setTempLow2) {
    if (setTo >= setTempLowMin && setTo <= setTempLowMax) {
      tmp_setTempLow2 = setTo;
      changes = true;
    }
    else if (setTo > setTempLowMax) {
      tmp_setTempLow2 = setTempLowMax;
      changes = true;
    }
    else if (setTo < setTempLowMin) {
      tmp_setTempLow2 = setTempLowMin;
      changes = true;
    }
    if (changes) {
      setTempLow2 = tmp_setTempLow2;
      lastValueChange = millis();
      setTempLow2AlreadySaved = false;
      updateDisplay();
      publishCurrentThermostatValues();


      char buf1[30];

      sprintf_P(buf1, "%s: %s %s %2.1f", PGMStr_thermostat, PGMStr_setTempLow2, PGMStr_changedTo, setTempLow2);
      sendLog(buf1);
    }
  }
}

void setHeatingmodeTo(unsigned char setTo) {
  if(setTo != heatingMode) {
    heatingMode = setTo;
    heatingPause = 0;
    heatingLockTime = 0;
    updateCurrSetTemp();
    lastValueChange = millis();
    heatingModeAlreadySaved = false;
    updateCurrentHeatingModeName();
    updateDisplay();
    publishCurrentThermostatValues();


    char buf1[30];

    sprintf_P(buf1, "%s: %s %s %u", PGMStr_thermostat, PGMStr_heatingMode, PGMStr_changedTo, heatingMode);
    sendLog(buf1);
  }
}

void setHeatingPause(uint8_t _setTo) {
  bool _change = false;
  char _buf1[30];
  if(_setTo == 0) {
    heatingPause = 0;
    _change = true;
    sprintf_P(_buf1, "%s: %s %s", PGMStr_thermostat, PGMStr_heatingPause, PGMStr_disabled);
  }
  else if (_setTo == 1 && heatingPause == 0) {
    heatingPause = confAdv.pauseTout;
    _change = true;
    sprintf_P(_buf1, "%s: %s %s", PGMStr_thermostat, PGMStr_heatingPause, PGMStr_enabled);
  }

  if(_change) {
    lastValueChange = millis();
    thermostat();
    updateDisplay();
    publishCurrentThermostatValues();
    sendLog(_buf1);
  }
}

void setPresetTo(unsigned char setTo) {
  if(setTo != preset) {
    if(setTo >= 0 && setTo <=2) {
      preset = setTo;
      pendingPreset = setTo;
      updateCurrSetTemp();
      lastValueChange = millis();
      presetAlreadySaved = false;
      updateCurrentPresetName();
      updateDisplay();
      publishCurrentThermostatValues();


      char buf1[30];
      sprintf_P(buf1, "%s: %s %s %u", PGMStr_thermostat, PGMStr_preset, PGMStr_changedTo, preset);
      sendLog(buf1);
    }
  }
}

void checkValuesChanged() {
  if ( !setTempAlreadySaved || !heatingModeAlreadySaved || !presetAlreadySaved || !setTempLowAlreadySaved || !setTempLow2AlreadySaved ) {
    if ( (millis() - lastValueChange) > saveValuesTimeout ) {
      if (!setTempAlreadySaved) {
        lastUpdate_setTemp = millis();
        if (confBas.autoSaveSetTemp && setTemp != setTempSaved) {
          saveSetTemp();
          sendLog(F("TSTAT: setTemp autosave done"));
        }
        setTempAlreadySaved = true;
      }
      if (!setTempLowAlreadySaved) {
        lastUpdate_setTempLow = millis();
        if (confBas.autoSaveSetTemp && setTempLow != setTempLowSaved) {
          saveSetTempLow();
          sendLog(F("TSTAT: setTempLow autosave done"));
        }
        setTempLowAlreadySaved = true;
      }
      if (!setTempLow2AlreadySaved) {
        lastUpdate_setTempLow2 = millis();
        if (confBas.autoSaveSetTemp && setTempLow2 != setTempLow2Saved) {
          saveSetTempLow2();
          sendLog(F("TSTAT: setTempLow2 autosave done"));
        }
        setTempLow2AlreadySaved = true;
      }
      if (!heatingModeAlreadySaved) {
        lastUpdate_heatingMode = millis();
        if (confBas.autoSaveHeatingMode && heatingMode != heatingModeSaved) {
          saveHeatingMode();
          sendLog(F("TSTAT: heatingMode autosave done"));
        }
        heatingModeAlreadySaved = true;
      }
      if (!presetAlreadySaved) {
        lastUpdate_preset = millis();
        preset = pendingPreset;
        if (confBas.autoSaveHeatingMode && preset != presetSaved) {
          savePreset();
          sendLog(F("TSTAT: preset autosave done"));
        }
        presetAlreadySaved = true;
      }
      publishCurrentThermostatValues();
    }
  }
}
# 1 "D:/Flo/git/WiFiThermostat/src/time.ino"
#ifdef ENABLE_FEATURE_NTP_TIME
bool setupTime()
{
    if (strlen(confTime.ntpServer1) > 4 && strlen(confTime.ntpServer2) > 4)
    {

        configTime(0, 0, confTime.ntpServer1, confTime.ntpServer2);
    }
    else if (strlen(confTime.ntpServer1) > 4)
    {
        configTime(0, 0, confTime.ntpServer1);
    }
    else return false;
    setenv("TZ", confTime.timeZoneStr, 1);
    sendLog(F("NTP:  updating time..."), LOGLEVEL_INFO);
    return true;
}

void syncClock(bool force)
{
    time_t now = time(&now);
    static time_t lastsek{0};
    if (lt.tm_sec != lastsek || force)
    {
        lastsek = lt.tm_sec;
        if (force || !(time(&now) % confTime.ntpSyncInterval))
        {

            setupTime();
        }
    }
}

void updateTime() {
    time_t now = time(&now);
    localtime_r(&now, &lt);
}

void printDate() {
    char buf[30];
    strftime(buf, sizeof(buf), "DATE: %Y-%m-%d %H:%M:%S", &lt);
    sendLog(buf);
}
#endif
# 1 "D:/Flo/git/WiFiThermostat/src/websockets.ino"
#ifdef ENABLE_FEATURE_WEB_CONSOLE_WEBSOCKETS




bool isCookieValid(String rawCookieHeaderValue) {
    if(wsValidSessionId != 0) {
   if (rawCookieHeaderValue.indexOf("sessionId") != -1) {
     String sessionIdStr = rawCookieHeaderValue.substring(rawCookieHeaderValue.indexOf("sessionId=") + 10, rawCookieHeaderValue.indexOf("|"));
     unsigned long int sessionId = strtoul(sessionIdStr.c_str(), NULL, 10);
     return sessionId == wsValidSessionId;
   }
    }
 return false;
}

void clearValidSessionId() {

    if( wsValidSessionId > 0 && (millis() - wsValidSessionId) > 2000 ) wsValidSessionId = 0;
}




bool validateHttpHeader(String headerName, String headerValue) {

 bool valid = true;

 if(headerName.equalsIgnoreCase("Cookie")) {

  valid = isCookieValid(headerValue);
 }
 return valid;
}


void startWebSocketServer() {

  const char * headerkeys[] = { "Cookie" };
  size_t headerKeyCount = sizeof(headerkeys) / sizeof(char*);
  webSocket.onValidateHttpHeader(validateHttpHeader, headerkeys, headerKeyCount);

  webSocket.begin();
  webSocket.onEvent(webSocketEvent);

  sendLog("WS:   WebSocket server started on Port 81", LOGLEVEL_INFO);
}

void webSocketEvent(uint8_t num, WStype_t type, uint8_t * payload, size_t length) {
    if(length > 0) {
    char logBuf[60];
        switch(type) {
            case WStype_DISCONNECTED:
                Serial.printf("[%u] Disconnected!\n", num);
                break;
            case WStype_CONNECTED:
                {
                    IPAddress ip = webSocket.remoteIP(num);

                    sprintf(logBuf, "WS:   Client[%u] connected, %d.%d.%d.%d, URL: %s", num, ip[0], ip[1], ip[2], ip[3], payload);
                    sendLog(logBuf, LOGLEVEL_INFO);


        webSocket.sendTXT(num, "Connected\r\n");
                }
                break;
            case WStype_TEXT:

                sprintf(logBuf, "WS:   received from Client[%u]: %s", num, payload);
                sendLog(logBuf, LOGLEVEL_INFO);

                char buf[31];
                sprintf(buf, "%s", payload);


                if(strlen(buf) > 0) strlcpy(cmdPayload, buf, sizeof(cmdPayload));
                cmdInQueue = true;






                break;
            case WStype_ERROR:
                break;
            case WStype_BIN:
                Serial.printf("[%u] get binary length: %u\n", num, length);
                hexdump(payload, length);
                break;
            default:
                break;




        }
    }
}
#endif